Attribute VB_Name = "EqParser_Fnct"
'File automatically created by pbProtoTyper.exe (27/07/2009 - 19.47.39)
Option Explicit
Option Base 1
Global Const MODULE_EVAL = 30
'EqParser Returned values (ExitCodes) and Constants
'==================================================
Global Const ANM_EVAL_OK                           = -1  'no error
Global Const ANM_EVAL_NO_ERROR                         = -1
Global Const ANM_EVAL_UndefinedError                   = 0 'Undefined error (procedure exit before completion)
Global Const ANM_EVAL_AmbFunctName                     = 1     'Ambiguous function name detected
Global Const ANM_EVAL_SyntaxError_eval                 = 2     'syntax error
Global Const ANM_EVAL_SyntaxError_parser               = 3     'syntax error
Global Const ANM_EVAL_UndefFunct                       = 4     'Undefined function
Global Const ANM_EVAL_RetValNotDef                     = 5     'Returned Value not defined (*pointer not defined)
Global Const ANM_EVAL_TokenMatchError                  = 6
Global Const ANM_EVAL_NotFound                         = 7
Global Const ANM_EVAL_DivByZero                        = 8
Global Const ANM_EVAL_ExpNotInt                        = 9
Global Const ANM_EVAL_CondNotFound                     = 10
Global Const ANM_EVAL_WrongStringMatrix                = 11
Global Const ANM_EVAL_NoEnoughtElements                = 12
Global Const ANM_EVAL_InvalidParamArg                  = 13
Global Const ANM_EVAL_MatrNotFound                     = 14
Global Const ANM_EVAL_NotRegistered                    = 15
Global Const ANM_EVAL_UndefinedCustVariable            = 16
Global Const ANM_EVAL_UndefinedCustFunct               = 17
Global Const ANM_EVAL_UndefinedConst                   = 18
Global Const ANM_EVAL_UndefinedMethod                  = 19    ' solver.pb
Global Const ANM_EVAL_ConstFound                       = 20  'used only in e_get_const(). must only be <> -24 and -25
Global Const ANM_EVAL_VarValFound                      = 21  'used only in FindVarValD(). must only be <> -24 and -25
Global Const ANM_EVAL_UndefCommand                     = 25
Global Const ANM_SOLVE_NotEvenNum                         = 22 'Simpson's Rule requires that number of subintervals N be even
Global Const ANM_SOLVE_MemAllocErr                        = 23
Global Const ANM_SOLVE_MatrNotFound                       = 24
Global e_evalRunCnt.l;Set Flag for sSetErrorMsgs
Global gExprPosStr.s, gElem.s'EqParser Supported Functions and Operators
'==========================================
'Functions: abs, exp, fix, int, log, ln, log10, rnd=(Random(arg)), sgn,  sqr
'           es. ln(4) = log(4) returns 1.3862...
'Trigon Functions
'           atan, sin, tan, cos, cosec, cotan, sec, arcsin, arccos, arcsec, arccos, arccotan
'           es. sin(1.2) returns 0.9320...
'Hyperbolic functions
'           sinh, cosh, tanh, sech, cosech, cotanh, arcsinh, arccosh, arctanh, arcsech, arccosech, arccotanh
'           es. sinh(1.2) returns 1.50946...
'Operators: and, eqv, imp, mod, not, or, xor
'           es. (1 and 2) returns 1
'Stat Functions: min, max, avg, sum, prod, sum2 (=sum^2), prod2 (=prod^2), stddev, count, geom_mean, median, mean
'                es. min(1;2;3;0.5) returns 0.5
'
'Matrix Operators: det trace syst vcoeff (es. det([mA]) calculates the determinant of [mA])
'
Global Const ANM_EVAL_IsNumeric                = 0   'no error and result is numeric
Global Const nnIsNumber                 = 0
Global Const nnIsMatrix                 = 1
'Constants for FindMatrix
'------------------------
Global Const RetMatrPtr = 1
Global Const RetIndex = 2
Global Const SrcMatrPtr = 8
Global Const SrcName = 32
Structure IntArr
    name.s
    *Matr       ;Pointer to Matrix
    InternalF.b ;Pointer to memory storing Matrix elements (a copy)
    rows.l
    cols.l
    listPos.l
    vectorF.b
EndStructure
Global kBool.l = -1    ; internal sign for boolean operations (i.e. 1 or -1)
Global dVarPos.l     ; internal flag
Global bShowMsgs.l ; internal flag
Global e_nxt_cnt.l
Global IntFunctList.s = " min max avg sum sum2 prod prod2 stddev count geom_mean median mean "
Global IntOperList.s = " and eqv imp mod not or xor "
Global IntMatrFunctList.s = " det trace syst vcoeff "
Global cnt_e_nxt.l, cnt_e_prs.l, cnt_e_match.l
Global GnnTp.b;global value used in GetResultType
Global mTp.s;global x [mA]I etc
Global nnRows.l, nnCols.l, InternalMatr.b
Global NewList arrList.IntArr()
Global cnt1.l, dbl1.d;
Global dRetVal.d
Global sVars.s, sVals.s, idx.l, VarCnt.l, sVarVals.s
Global sFuncs.s
'; Set Internal ErrMsgF; if <> 0 and Show Error Message Boxes
Public Declare Function SetErrorMsgsF Lib "aNuMet.dll" ( _
       ByVal ErrMsgsFlag As Long) As Long
' Parameter: ErrMsgsFlag 0 do nothing, 1 IDE Debug, 2 Show MessageBox
'                      4 Store Message in String and return address of string (use PeekS(Address))

'; get internal Debug Log (all those stored)
Public Declare Function GetDebugLog Lib "aNuMet.dll" ( _
       DebugLog As Long,  _
       ByVal DbgLogLen As Long,  _
       ByVal ShowF As Byte) As Long
' store result in *DebugLog and return bytes required to store DebugLog string
' Parameters: *DebugLogs pointer to a string buffer returning debug messages
'             DbgLogLen length in bytes of string buffer (bytes to copy).
'             If DbgLogLen less then needed, message is truncated. NO ERROR is set

' ; clear list created by SetMatrix in memory
Public Declare Function ClearMatrixList Lib "aNuMet.dll" ( _
       aPtr  As Any) As Long
' *aPtr is a pointer to a Matrix to skip deletion (if any)
' if *aPtr=0 then delete all, otherwise only external matrices are removed
' return number of deleted Matrices (can be also zero)

';
Public Declare Function ClearVarFuncList Lib "aNuMet.dll" ( _
       ByVal Tp As String) As Long
'  Tp.s="vars" clear Variables' List, otherwise clear Functions' list
' return 1

';calculate n!, factorial of n (es. n! = 5! = 1*2*3*4*5 = 120); return a double
Public Declare Function fact Lib "aNuMet.dll" ( _
       ByVal n As Long) As Double

'
Public Declare Function FindMatrix Lib "aNuMet.dll" ( _
       ByVal MatrName As String,  _
       ByVal Tp As Long,  _
       rows  As Long,  _
       cols  As Long,  _
       ByVal SetMsgIfErr As Byte) As Long
' search for Matrix in the internal list/memory.
' If found, Return values depends on parameter Tp; if Matrix is not found return 0 and set e_error = #MatrNotFound (-17)
' #SrcMatrPtr = 8  search by Pointer to Matrix (address in memory)
' #SrcName    = 32 use name (es. [mA]) as string to find
' #RetMatrPtr = 1  Return Pointer To Matrix (address in memory)
' #RetIndex   = 2  Return the index/position of the element in the list
' dimensions are always returned (if Matrix found);
' this function Trim spaces of MatrName

'; find a string into sVarVals
Public Declare Function FindVarFunct Lib "aNuMet.dll" ( _
       ByVal StrToFind As String,  _
       ByVal Var0Funct1 As Long,  _
       dRetVal.d As Double,  _
       ByVal sPtr  As String) As Long
' return:  1 if succesful, 0 if not, setting ErrorCode = #e_InvalidParam
' set   :  for a Variable store in dRetVal the current VALUE (0.0 if not found)
'          for a Function store in dRetVal the LENGHT of his expression (es. F1=xx + 25; return 7)
'                     and store the expression in e_spelling (es. e_spelling = "xx + 25")
' es. sVars="xxx=1.234;yyy=2.22;xyz=333.22"
'     sFuncs="funct1=xxx+yyy;Funct2=Log(10)"

'; return content of a matrix stored internally
Public Declare Function GetMatrixByLong Lib "aNuMet.dll" ( _
       ByVal SrcMemID As Long,  _
       aDest As Any,  _
       ByVal rows As Long,  _
       ByVal cols As Long) As Long
' used in lieu of aCopyArray to have "As Long" in the VB Function declaration

';; get list created by SetMatrix in memory; return a pointer to a string
Public Declare Function GetMatrixList Lib "aNuMet.dll" ( _
       ByVal ShowElem As Byte) As Long
' *aPtr is a pointer to a Matrix to skip deletion
' if *aPtr=0 then delete all, otherwise only external matrices are remmoved

';return 0 (#nnIsNumber) if result of e_eval(...*dRetVal...) is a Number; 1 (#nnIsMatrix) if it is a Matrix
Public Declare Function GetResultType Lib "aNuMet.dll" () As Long
'see sample code to know how recover Result Matrix

';get VarFuncList string; result pointed by *sList
Public Declare Function GetVarFuncList Lib "aNuMet.dll" ( _
       ByVal sList As String,  _
       ByVal sListLen As Long,  _
       ByVal Tp As String) As Long
' Tp.s="vars" get Variables' List, otherwise get Functions' list

';get Lenght of VarsList
Public Declare Function GetVarFuncListLen Lib "aNuMet.dll" ( _
       ByVal Tp As String) As Long
' Tp.s="vars" get Variables' List, otherwise get Functions' list

';reset all internal variables used by e_eval function
Public Declare Function ReSetEqParser Lib "aNuMet.dll" () As Long

';set internal sign returned by boolean operations (i.e. 1 or -1)
Public Declare Function SetBoolSign Lib "aNuMet.dll" ( _
       ByVal kk As Long) As Long

';set/store a matrix in the internal matrix list
Public Declare Function SetMatrix Lib "aNuMet.dll" ( _
       ByVal MatrName As String,  _
       aPtr As Any,  _
       ByVal rows As Long,  _
       ByVal cols As Long,  _
       ByVal Return_MatrPtr As Byte) As Long
' matrix can then be found with FindMatrix function by name (es. "[mA]") or by string of the Pointer (es. Str(@mA())
' if Return_MemID = 0, return LinkedList Position, if Return_MemID <> 0 return pointer to matrix

';set/store a string matrix in the internal matrix list
Public Declare Function SetStrMatrix Lib "aNuMet.dll" ( _
       ByVal StrMatr As String,  _
       ByVal Return_mPtr As Byte,  _
       ByVal e_evalF As Byte,  _
       ByVal SetDbgMsgF As Byte) As Long
' returned value is: Matrix List position if Return_mPtr = 0, otherwise is pointer to matrix values
' if e_evalF <> 0 then elements contains expressions and e_eval function is used to evaluate them statically (once a run)
'                      name  r; c; values
'es. of string matrix "[mA]; 3; 3; 0; 1; 2; 1.2; 2.2; 3.2; 1; 2; 12*sin(0.5)" with function
'es. of string vector "[vB]; 3; 0; 0; 1; 2"; this is a vector
' matrix can then be found with FindMatrix function by name (es. "[mA]") or by string of the Pointer (es. Str(@mA())

'; Add or Update the value of a Variable or a Function in the relevant Internal List
Public Declare Function SetVarFunct Lib "aNuMet.dll" ( _
       ByVal sVar As String,  _
       ByVal sVal As String,  _
       ByVal Var0Funct1 As Long) As Long
' return number of items, es. "xxx=1.234;yyy=2.22;xyz=333.22"

'; set to show error and debug messages during e_eval routine program execution
Public Declare Function ShowMsgs Lib "aNuMet.dll" ( _
       ByVal bShow As Long) As Long
'Parameters:   0 = No Messages
'              1 = Show Error Messages
'              2 = Show Debug Messages
'              3 = Show All Messages

';evaluate a string containing an expression.
Public Declare Function e_eval Lib "aNuMet.dll" ( _
       ByVal expression As String,  _
       dRetVal As Double,  _
       ByVal ChkFunct As Long) As Long
' If successful, return 0 (#nnIsNumber) or 1 (#nnIsMatrix) and place result in dRetVal.
' If error occurs, set e_error and return ErrorCode

'
Public Declare Function e_evals Lib "aNuMet.dll" ( _
       ByVal lExpr As String,  _
       ByVal lx0 As Double,  _
       ByVal lsVar As String,  _
       ByVal lxN As Double,  _
       ByVal lN1 As Long,  _
       Xv As Long,  _
       Yv As Long,  _
       MinMaxXY As Long) As Long
'execute e_eval lN1 times
'return three vectors: Xv.d(lN1), Yv.d(lN1) and MinMaxXY.d(4)
'  MinMaxXY(1) = MinXv: MinMaxXY(2) = MinYv: MinMaxXY(3) = MaxXv: MinMaxXY(4) = MaxYv
'return -1 if N errors, otherwise error code

';search for internal const
Public Declare Function e_get_const Lib "aNuMet.dll" ( _
       ByVal sInp As String,  _
       dbl1 As Long) As Long
' get value of const in e_spelling if found and set e_tok
' DO NOT SET e_error const if not found (it may be many another thing (es sin())

