﻿; PROJECT: aNuMet (Array of Numerical Methods), by Carlo Somigliana
; visit the web site www.semelinanno.com for more info and programs
; you can also email me at: somic@libero.it

; DESCRIPTION: this is a simple And poorly written Input module for Matrices and Vectors
; that are entered in a form and returned in a string


; LICENSE: this code is released FREEWARE. You are free to use and modify it at your wish and risk.
; No further info and support is provided nor garranteed.
; If you do something good from it, pls let me know
;---------------------------------------------------------------------------------

EnableExplicit

IncludeFile "InpMatrixForm.pbi"

Global Dim CellId(0, 0)
Global cellW=80, cellH = 20
Global wndX, wndY, wndW, wndH, mtxStr.s

Procedure.s MtxAbout(HeadF.b = 0, noHeaderF.b = 0)          ; About procedure
Protected st.s, car.s{1}, AnUc.s

    ;sRes$ = ""
    st = ""
    If noHeaderF : ProcedureReturn st : EndIf
    
    If HeadF : car = "'" : EndIf

    If #PB_Compiler_Unicode
        AnUc = "Unicode"
    Else
        AnUc = "Ansi"
    EndIf
    
    st = car + "Module name: InpMatrix.pb (for use with anmCalc.exe)" + #CRLF$
    ; st = st + car + "Version: 0.0.1.0 - Built: " + Str(#PB_Editor_BuildCount) + ". (" + AnUc +" version)" + #CRLF$
    st = st + car + "By: Carlo Somigliana, email: somic@libero.it, site: www.semelinanno.com" + #CRLF$
    st = st + car + "Web Page: www.semelinanno.com\downloads\anmcalc\anmcalc_Page.html"+ #CRLF$
    If HeadF : 
    st = st + car + "---------------------------------------------------------------------------" + #CRLF$
        ;sRes$ = st
        ProcedureReturn st
    EndIf

    st = st + car + "---------------------------------------------------------------------------" + #CRLF$
    st = st + car + "This program is a vector/matrix input module for the program anmCalc.exe"+ #CRLF$
    st = st + car + "See the relevant file or the a.m. web link for more info." + #CRLF$
    st = st + car + "derivatives, with a simple script language"+#CRLF$
    
    st = st + car + "Written in PureBasic "+StrD(#PB_Compiler_Version/100, 2)+" (x86) - (see www.purebasic.com)." + #CRLF$
    st = st + car + "This program is FREEWARE. Necessary Disclaimer: use at your own risk." + #CRLF$+ #CRLF$
    ;st = st + car + "It uses the SHAREWARE library aNuMet.dll (Array of Numerical Methods)" + #CRLF$
    st = st + car + "Pls report any bugs and/or comments to me. Fixes will be ...a.s.a.p.... :-}"+#CRLF$
    st = st + car + "If you are courious, visit the website: www.semelinanno.com for more info." + #CRLF$
    st = st + car + "---------------------------------------------------------------------------" + #CRLF$

    sRes$ = st

    gWinLogTitle= "InpMatrix Module"
    sLog(gWinLogTitle, 2, "Input Vector/Matrix", 0, 1)
    ;gedtLog = sLog(gWinLogTitle, 2, gWinLogTitle, -1, -1, @lwLog)
    
    ProcedureReturn sRes$
    
EndProcedure

Procedure wndMtx_EventLoop()                                ; main event loop
Protected rows, cols, r, c, cellid2, Tp, Tpc, QuitF.b, sRet.s, k
Protected Event, WindowID, GadgetID, EventType, MenuID, hnd, parseMtxStrF.b=0
Protected ActiveTxt, ActiveGID, st1.s, st2.s, chkML, mtxN.s, prefix.s, StartCellId

    StartCellId = #PB_Compiler_EnumerationValue + 100
    mtxN = Trim(StringField(mtxStr+"=", 2, "="))
    If mtxN <> ""
        mtxN = Trim(StringField(mtxN, 1, ";"))
    EndIf
    
;     st1 = Trim(StringField(mtxStr, 1, ";"))
;     If LCase(Left(st1, Len("matr =")))= "matr ="
;         st1 = Trim(StringField(Mid(mtxStr, Len("matr =")), 1, ";"))
        
    If mtxN <> "" And (MessageRequester("InpMatrix module", "Import matrix: "+mtxN+"?", #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes)
        parseMtxStrF = 1
        
        SetGadgetText(#txtMtxN, mtxN)
        
        rows = Val(StringField(mtxStr, 2, ";"))
        cols = Val(StringField(mtxStr, 3, ";"))
        SetGadgetText(#spnRows, Str(rows))
        SetGadgetText(#spnCols, Str(cols))
        
        Goto lbl_btnGen
lbl_ParseMtxStr:

        k = 3
        For r = 1 To rows
            For c = 1 To cols
                k + 1
                st1 = Trim(StringField(mtxStr, k, ";"))
                hnd = SetGadgetText(cellid(r, c), st1)
            Next c
        Next r
        
        mtxStr = ""
    EndIf
;    EndIf
        
    Repeat ; Start of the event loop
      
      Event = WaitWindowEvent() ; This line waits until an event is received from Windows
      WindowID = EventWindow() ; The Window where the event is generated, can be used in the gadget procedures
      GadgetID = EventGadget() ; Is it a gadget event?
      EventType = EventType() ; The event type
      
      ;You can place code here, and use the result as parameters for the procedures
      
      If Event = #PB_Event_Gadget
        
        If GadgetID = #spnCols 
          
        ElseIf GadgetID = #spnRows
          
        ElseIf GadgetID = #btnOK
            QuitF = 1
          
        ElseIf GadgetID = #btnCopy
            ClearClipboard()
            SetClipboardText(mtxStr)
          
        ElseIf GadgetID = #chkMLine
          
        ElseIf GadgetID = #txtCell
            ;If EventType = #PB_EventType_Change
            
        ElseIf GadgetID = #lblOutp
            If EventType = 256 ; #PB_EventType_LeftClick ;Or EventType = #PB_EventType_RightClick
                If rows = 1 Or cols = 1
                    st1 = "Vector: "+mtxN
                Else
                    st1 = "Matrix: "+mtxN
                EndIf
                MtxBalloonTip(GadgetID(#lblOutp), #lblOutp, mtxStr, st1, #TOOLTIP_INFO_ICON)
                
            EndIf
            
        ElseIf GadgetID = #btnGen

lbl_btnGen:        
            ; rows = GetGadgetState(#spnRows)
            ;cols = GetGadgetState(#spnCols)
            rows = Val(GetGadgetText(#spnRows))
            cols = Val(GetGadgetText(#spnCols))
            wndW = maxL(xRight(#btnCopy), cols*cellW)
            Tp = yBottom(#txtCell)+2
            wndH = Tp + rows*cellH+GadgetHeight(#lblOutp)
            
            ResizeWindow(#wndMtx, #PB_Ignore, #PB_Ignore, wndW, wndH)
            ResizeGadget(#lblOutp, #PB_Ignore, wndH-GadgetHeight(#lblOutp)+2, wndW-4, #PB_Ignore)
            ResizeGadget(#txtCell, #PB_Ignore, #PB_Ignore, wndW-4, #PB_Ignore)
            
            If IsGadget(#cntCells)
                FreeGadget(#cntCells)
            EndIf
            
            Dim cellid(rows, cols)
            
            SetGadgetText(#txtCell, "")
            
            ;If ContainerGadget(#cntCells, xleft(#lblRows), yBottom(#lblRC), wndW-4, yTop(#lblOutp)-yBottom(#lblRC), #PB_Container_Raised)
            If ContainerGadget(#cntCells, 2, yBottom(#lblRC), wndW-2, yTop(#lblOutp)-yBottom(#lblRC), #PB_Container_Raised)
                Tpc = 0
                For r = 1 To rows
                    For c = 1 To cols
                        cellid(r, c) = StartCellId + (r-1)*cols + c
                        hnd = StringGadget(cellid(r, c), 1+(c-1)*cellW, Tpc+(r-1)*cellH, cellW, cellH, "") ;, #PB_String_Numeric)
;                         Debug hnd
;                         Debug "r="+Str(r)+", c="+Str(c)+", cellid="+Str(cellid(r, c))+", X="+Str(GadgetX(cellid(r, c)))+", Y="+Str(GadgetY(cellid(r, c)))
;                         SetForegroundWindow_(WindowID(#wndMtx))
;                         doevents()
;                         Delay(500)
                    Next c
                
                Next r
                CloseGadgetList()
            EndIf
            ;Debug ""
            If parseMtxStrF: Goto lbl_ParseMtxStr: EndIf
        EndIf        
      EndIf
      
    If Event = #PB_Event_Menu                               ; /// MENUS ///////////////////////////////////////
                                                            ; /////////////////////////////////////////////////        
        MenuID = EventMenu()
                                                            ; /// MENU FILE ///
                                                            
        If MenuID = #mnuMtxOpen Or MenuID = #mnuMtxSave Or MenuID = #mnuMtxSaveAs
            MessageRequester("InpMatrix", "Function yet to be implemented!"+#CRLF$ +"My apologies")
    
        ElseIf  MenuID = #mnuMtxExit
            mtxStr = ""
            QuitF = 1
        
        ElseIf MenuID = #mnuMtxCopy
            ClearClipboard()
            SetClipboardText(mtxStr)
            
        ElseIf MenuID = #mnuMtxClearCells
            rows = Val(GetGadgetText(#spnRows))
            cols = Val(GetGadgetText(#spnCols))
            Dim cellid(rows, cols)
            
            For r = 1 To rows
                For c = 1 To cols
                    cellid(r, c) = StartCellId + (r-1)*cols + c
                    hnd = SetGadgetText(cellid(r, c), "")
                Next c
            Next r
                    
        ElseIf menuid = #mnuMtxDetermin Or MenuID = #mnuMtxTranspose Or MenuID = #mnuMtxInvert Or MenuID = #mnuMtxOrtog
            MessageRequester("InpMatrix", "Function yet to be implemented!"+#CRLF$ +"My apologies")

        ElseIf MenuID = #mnuMtxAbout
            sRet = MtxAbout(0, 0)
            sRet = sRet + #CRLF$    
            ShowString(sRet, 0)
        
        EndIf
    EndIf
        
    If EventType = #PB_EventType_Focus Or EventType = #PB_EventType_Change
; And (ActiveTxt <> #spnCols And ActiveTxt <> #spnRows)

        If GadgetID > StartCellId Or GadgetID = #txtCell
        
            If GadgetID > StartCellId 
                r = Int((GadgetID - StartCellId-1) / (cols)) + 1        
                c = (GadgetID - StartCellId-1) % (cols)+1
        ;         Debug "id="+Str((GadgetID - StartCellId))+", r="+Str(r)+", c="+Str(c)
        ;         Debug ""
        
                SetGadgetText(#lblRC, "R"+Str(r)+",C"+Str(c)+"")
                ActiveTxt = GadgetID
            EndIf
                
            st1 = "": st2 = ""
            ;ActiveGID = GetActiveGadget()
            If IsGadget(ActiveTxt)
                st1 = GetGadgetText(ActiveTxt)
            EndIf
            st2 = GetGadgetText(#txtCell)
            
            If st1 <> st2
                  ;If ActiveGID = #txtCell
                  If GadgetID = #txtCell
                        SetGadgetText(ActiveTxt, st2)
                        
                  ;ElseIf ActiveGID = ActiveTxt
                  ElseIf GadgetID = ActiveTxt
                        SetGadgetText(#txtCell, st1)
                        ;SetActiveGadget(#txtCell)
                        
                  EndIf
            EndIf
        EndIf
        
    EndIf

    ; Matr = [mB];   3;   3;   0;   1; 2; 1.2; 2.2; 3.2; 1; 2; 16.6866*Sin(0.5)"
    ; DimX = mE(3,3); mE(0,0)=1; mE(0,1)=2 ; mE(0,2)=3 
    ; DimX = mE(3,3); mE(1,0)=0; mE(1,1)=-2; mE(1,2)=3 'definition 'Matr = mE(3,3)' has to be repeated
    ; DimX = mE(3,3); mE(2,0)=0; mE(2,1)=-8; mE(2,2)=4 'on each line

    ;If Not QuitF                                                                          ; assemble the string describing the matrix/vector
        chkML = GetGadgetState(#chkMLine)
        mtxN = GetGadgetText(#txtMtxN)
        If chkML
            mtxN = TrimChar(TrimChar(mtxN, "]"), "[")
            
            prefix = "DimX = "+mtxN+"(" +Str(rows)+","+Str(cols)+"); "
            mtxStr = ""
        Else
            prefix = ""
            
            mtxStr = "Matr = "+MtxN+"; " +Str(rows)+"; "+Str(cols)+"; "
    
        EndIf
        ;mtxStr = "Matr = "+GetGadgetText(#txtMtxN)+"; " +Str(rows)+";"+Str(cols)+";"
        For r = 1 To rows
            If chkML
                mtxStr = mtxStr + prefix
            EndIf
            
            For c = 1 To cols
                st1 = Trim(GetGadgetText(cellid(r, c)))
                st2 = iifs(st1="", "0", st1)
                
                If chkML
                    
                    mtxStr = mtxStr + mtxN+"("+Str(r)+","+Str(c)+")="+st2+"; "
                    If c = cols
                        mtxStr = mtxStr + #CRLF$
                    EndIf
                Else
                    mtxStr = mtxStr + st2+"; "
                EndIf
                    
            Next c
            
        Next r
        mtxStr = Left(mtxStr, Len(mtxStr)-2); remove last ;
        If mtxStr <> GetGadgetText(#lblOutp)
            SetGadgetText(#lblOutp, mtxStr)
        EndIf
    ;EndIf
    
    Until Event = #PB_Event_CloseWindow Or QuitF; End of the event loop

    CloseWindow(#wndMtx)
EndProcedure


ProcedureDLL.l Run_MtxMaker(*mtxOut=0)                      ; exported procedure
;; inp: a pointer to a string as parameter (can be made of spaces or with a matrix expression in linear format)
;;      if the string contains a matrix expression, it is parsed and shown in the form
;; out: a pointer to a string with the resulting matrix expression, in linear format (see below)
;;      the lenght of the returned string
;;      es. Matr = [mA]; 2; 2; 4; 5; 6; 7 => [mA(2, 2)]= > mA(1,1)=4, mA(1,2)=5, ...

Protected ln, ln2

    If *mtxOut > 0
        mtxStr = PeekS(*mtxOut)
    EndIf
        
    Open_wndMtx()
    wndMtx_EventLoop()
    
    If *mtxOut > 0
        ln = Len(PeekS(*mtxOut))
        
        ln2 = MinL(ln, Len(mtxStr))
        PokeS(*mtxOut, mtxStr, ln2)

        ProcedureReturn ln2
    EndIf
    
    
EndProcedure

; This procedure is called once, when the program loads the library
; for the first time. All init stuffs can be done here (but not DirectX init)
;
ProcedureDLL AttachProcess(Instance)

    If Instance
        ;MessageRequester(Str(instance), "")

        ProcedureReturn
    Else
        Run_MtxMaker(0)
    
    
    EndIf

EndProcedure


; Called when the program release (free) the DLL
;
ProcedureDLL DetachProcess(Instance)
EndProcedure


; Both are called when a thread in a program call or release (free) the DLL
;
ProcedureDLL AttachThread(Instance)
EndProcedure

ProcedureDLL DetachThread(Instance)
EndProcedure


;Debug Defined(mtxOut, #PB_Variable)
;CompilerIf (Defined(mtxOut, #PB_Variable))

; IDE Options = PureBasic 4.31 (Windows - x86)
; ExecutableFormat = Shared Dll
; CursorPosition = 37
; FirstLine = 27
; Folding = --
; EnableUnicode
; EnableThread
; Executable = InpMatrix.dll
; EnableCompileCount = 89
; EnableBuildCount = 26
; IncludeVersionInfo
; VersionField0 = 0,0,1,0
; VersionField1 = 0,0,1,0
; VersionField2 = - - -
; VersionField3 = %executable
; VersionField4 = v0010
; VersionField6 = Vector / Matrix Input module for anmCalc
; VersionField7 = %executable
; VersionField8 = %executable
; VersionField11 = %buildcount
; VersionField12 = %buildcount
; VersionField13 = somic@libero.it
; VersionField14 = www.semelinanno.com
; VersionField15 = VOS_NT_WINDOWS32
; VersionField16 = VFT_DLL
; VersionField17 = 007f Invariant locale
; VersionField18 = Build date:
; VersionField21 = %dd/%mm/%yyyy