﻿; PureBasic Visual Designer v3.95 build 1485 (PB4Code)
EnableExplicit

Enumeration #PB_Compiler_EnumerationValue
  #MtxDll
  #anmEvalDll
EndEnumeration

Global curFontName.s, curFontSize, ResColF, lstSaved, sSep.s = "  ", lret, lstCnt
Structure llist2COLS
    row.s
    expr.s
    res.s
EndStructure

Structure llist1COL
    row.s
    text.s
EndStructure

; Procedure DebugGadgetDim(GadgetNr)
; Define gX, gY, gW, gH
; 
;     gX = GadgetX(GadgetNr)
;     gH = GadgetHeight(GadgetNr)
;     gY = GadgetY(GadgetNr)
;     gW = GadgetWidth(GadgetNr)
;     
;     Debug GetGadgetText(GadgetNr)+ " gX="+Str(gX)
;     Debug "gY="+Str(gY)
;     Debug "gH="+Str(gH)
;     Debug "gW="+Str(gW)
;     Debug ""
; 
; EndProcedure
; 

; ///////////////////// INFO ///////////////////////////
; //////////////////////////////////////////////////////
; aNuMet.dll (compiled from math.pbi, anmFuncts.pbi, aNuMet.pb, EqParser.pb, Solver.pb, Derive.pb) with the math code (not shared)
; anmEval.dll (incudes anmEval.pbi and anmEvParest.pb) with the parsing code (shared)
; InpMatrix.dll (includes InpMatrix.pb and InpMatrixForm.pbi) is the vector/matrix entry module code (shared)
; anmCalc.exe (includes anmCalc.pb and anmCalcForm.pbi) is the Calculator, loads the three previous (shared)

#UseInpMatrixDll = 0        ; leave 1 if you only have the Dll 
#UseanmEvalDll   = 0      

IncludeFile "anmEval2.pbi"
IncludeFile "anmCalcForm.pbi"

            
LoadSaveFile(#LoadCmds2)                    ; loads the list of commands for the help bar
SetKWList(srchStr(), strAct(), gTTMsg())    ; gets the keywords


CompilerIf #UseInpMatrixDll
    ; nothing done
    If  Not OpenLibrary(#MtxDLL, "InpMatrix.dll") 
        MessageRequester("anmCalc","Unable to load library InpMatrix.dll")
    EndIf
    If  Not OpenLibrary(#anmEvalDll, "anumet.dll")
        MessageRequester("anmCalc","Unable to load library anumet.dll")
        End
    EndIf
CompilerElse
    IncludeFile "InpMatrix.pb"

CompilerEndIf

Procedure SetlstCalcDim(lResColF.b)
Protected wndW

    wndW = WindowWidth(#wndCalc)
    ExprWidth = (wndW -2 - NumWidth-2) / 4 * (4-lResColF)
    SetGadgetItemAttribute(#lstCalc, 0, #PB_ListIcon_ColumnWidth , ExprWidth, 1)
    ResWidth = 0; (wndW -2 - NumWidth-2) / 4 * (lResColF)
    SetGadgetItemAttribute(#lstCalc, 0, #PB_ListIcon_ColumnWidth , ResWidth, 2)

EndProcedure


Procedure.s SavelstCalc(fName.s="")                         ; save result of calculations
Static lfName.s, cnt, lstText.s, f, k

    If fName <> ""
        lFName = fName
    EndIf
    
    If lfName = "" Or fName = ""
        lfName = SaveFileRequester("Save As", lfName, "anm Calc files (*.anc)|*.anc|All files (*.*)|*.*", 0)
        
        If lfName = ""
            ProcedureReturn ""
        EndIf
    EndIf
    
    f = CreateFile(#PB_Any, lfName)
    If f  = 0
        MessageRequester("anm Calc", "Error creating file." +#CRLF$ +lfName)
        ProcedureReturn ""
    EndIf
    
    WriteStringN(f, "Columns: "+Str(1+ResColF))                       ; write flag value
    cnt = CountGadgetItems(#lstCalc)
    For k = 0 To cnt-1
        lstText = GetGadgetItemText(#lstCalc, k, 0) +#LF$ + GetGadgetItemText(#lstCalc, k, 1) + #LF$ + GetGadgetItemText(#lstCalc, k,2)
        If lstText <> #LF$+#LF$ 
            WriteStringN(f, lstText, #PB_Ascii)
        EndIf
    
    Next k
    CloseFile(f)
    
    lstSaved = 1
    SetGadgetText(#lblInfo, "File: "+lfName)

    ProcedureReturn lfName
    
EndProcedure

Procedure.s FileSavelstCalc(fName.s="")                         ; save result of calculations
Static lfName.s, cnt, lstText.s, f, k

    If fName <> ""
        lFName = fName
    EndIf
    
    If lfName = "" Or fName = ""
        lfName = SaveFileRequester("Save As", lfName, "anm Calc files (*.anc)|*.anc|All files (*.*)|*.*", 0)
        
        If lfName = ""
            ProcedureReturn ""
        EndIf
    EndIf
    
    f = CreateFile(#PB_Any, lfName)
    If f  = 0
        MessageRequester("anm Calc", "Error creating file." +#CRLF$ +lfName)
        ProcedureReturn ""
    EndIf
    
    WriteStringN(f, "Columns: "+Str(1+ResColF))                       ; write flag value
    cnt = CountGadgetItems(#lstCalc)
    For k = 0 To cnt-1
        lstText = GetGadgetItemText(#lstCalc, k, 0) +#LF$ + GetGadgetItemText(#lstCalc, k, 1) ; + #LF$ + GetGadgetItemText(#lstCalc, k,2)
        ;lstText = GetGadgetItemText(#lstCalc, k, 0) +#TAB$ + GetGadgetItemText(#lstCalc, k, 1) ; + #LF$ + GetGadgetItemText(#lstCalc, k,2)
        If lstText <> #LF$ ; +#LF$ 
        ;If lstText <> #TAB$ ; +#LF$ 
            WriteStringN(f, lstText, #PB_Ascii)
        EndIf
    
    Next k
    CloseFile(f)
    
    lstSaved = 1
    SetGadgetText(#lblInfo, "File: "+lfName)
    ProcedureReturn lfName
    
EndProcedure

Procedure.s OpenlstCalc()                                   ; open a file with a previously stored result of calculations
Static lfName.s, cnt, lstText.s, f, k, lResColF.b, col, cols, st.s, wndW

    
    If 1; #PB_Compiler_Debugger = 0
        lfName = OpenFileRequester("Open", lfName, "anm Calc files (*.anc)|*.anc|All files (*.*)|*.*", 0)
        
    Else
        ; lFName = #UserProf + "\My Documents\test.anc"; es. "C:\Documents And Settings\username\My Documents\test.anc"

    EndIf
    
    If lfName = ""
        ProcedureReturn ""
    EndIf
    
    f = OpenFile(#PB_Any, lfName)
    If f = 0
        MessageRequester("anm Calc", "Error opening file." +#CRLF$ +lfName)
        ProcedureReturn ""
    EndIf
    
    ClearGadgetItems(#lstCalc)
    lResColF = Val(StringField(ReadString(f)+":", 2, ":"))-1
    
    If lResColF <> ResColF
        If lResColF And ResColF=0
            AddGadgetColumn(#lstCalc, 2, "Result", Reswidth)
            
            SetlstCalcDim(lResColF)
            
        ElseIf lResColF=0 And ResColF
            RemoveGadgetColumn(#lstCalc, 2)
            
        EndIf
        ResColF = lResColF
    EndIf
    
    cols = 2+ResColF
    k = 0
    lstText = ""
    lstCnt = 0
    
    While Not Eof(f)
        st = ReadString(f, #PB_Ascii  )
        col = k % cols
        If col = 1 And st <> "-" And st <> ""
            SetGadgetText(#edtCalc, st)
            WinCallback(GadgetID(#edtCalc), #WM_CHAR, 13, 0)
        EndIf
        k + 1
    Wend
    CloseFile(f)
   
    ProcedureReturn lfName
    
EndProcedure

Procedure.s FileOpenlstCalc()                                   ; open a file with a previously stored result of calculations
Static lfName.s, cnt, lstText.s, f, k, lResColF.b, col, cols, st.s, wndW

    
    If 1; #PB_Compiler_Debugger = 0
        lfName = OpenFileRequester("Open", lfName, "anm Calc files (*.anc)|*.anc|All files (*.*)|*.*", 0)
        
    Else
        ; lFName = #UserProf + "\My Documents\test.anc"; es. "C:\Documents And Settings\username\My Documents\test.anc"

    EndIf
    
    If lfName = ""
        ProcedureReturn ""
    EndIf
    
    f = OpenFile(#PB_Any, lfName)
    If f = 0
        MessageRequester("anm Calc", "Error opening file." +#CRLF$ +lfName)
        ProcedureReturn ""
    EndIf
    
    ClearGadgetItems(#lstCalc)
    lResColF = Val(StringField(ReadString(f)+":", 2, ":"))-1
        
    cols = 2+ResColF
    k = 0
    lstText = ""
    lstCnt = 0
    
    While Not Eof(f)
        st = ReadString(f, #PB_Ascii)
        If Left(st, 1)="E" And Left(st, 3) <> "ERR"
            lstText = ReadString(f, #PB_Ascii)
            SetGadgetText(#edtCalc, lstText)
            WinCallback(GadgetID(#edtCalc), #WM_CHAR, 13, 0)        
        EndIf
        k + 1
    Wend
    CloseFile(f)
   
    ProcedureReturn lfName
    
EndProcedure

Procedure Debug_GadgetIconView(List Calc1.llist1COL())      ; debug routine

Protected k, cnt, st.s
    
    ProcedureReturn 0
    
    cnt = CountGadgetItems(#lstCalc)
    For k = 0 To cnt-1
    
        st = Str(K)+" "+LSet(GetGadgetItemText(#lstCalc, k, 0),4, ".") +" | "
        st = st +LSet(GetGadgetItemText(#lstCalc, k, 1), 20, ".") + " | "
        st = st + LSet(GetGadgetItemText(#lstCalc, k, 2), 20, ".") + " > " 
        ; DebugF( st)
        Debug st
    Next k
    
    ; DebugF("LinkedList llstCalc1:")
    Debug("LinkedList llstCalc1:")
    st = ""
    
    k=0
    With Calc1()
        
        cnt = ListSize(Calc1())
        ForEach calc1()
            st = Str(K) 
            st = st + " " + LSet(\Text  , 20, ".")+" > "
            ; DebugF(st)
            Debug(st)
            k+1
        Next
    EndWith
    
    ; DebugF("")
    Debug("")

EndProcedure

Procedure SetMenuCheckGadgetColors()                        ; switch colors and check/uncheck relevant menu

    If GetMenuItemState(#mnuCalc, #mnuB_W) = 1   ; actual item state = check marked
        SetGadgetColor(#lstCalc, #PB_Gadget_BackColor, RGB(255, 255, 255))
        SetGadgetColor(#lstCalc, #PB_Gadget_FrontColor, RGB(0, 0, 0))
        SetGadgetColor(#lstCalc, #PB_Gadget_LineColor, RGB(150, 150, 150))

        SetGadgetColor(#lstCalc, #PB_Gadget_BackColor, RGB(255, 255, 255))
        SetGadgetColor(#lstCalc, #PB_Gadget_FrontColor, RGB(0, 0, 0))

        SetMenuItemState(#mnuCalc, #mnuB_W, 0)      ; now set the check mark

    Else                           ; actual item state = no check mark
        SetGadgetColor(#lstCalc, #PB_Gadget_BackColor, RGB(0, 0, 0))
        SetGadgetColor(#lstCalc, #PB_Gadget_FrontColor, RGB(255, 255, 255))
        SetGadgetColor(#lstCalc, #PB_Gadget_LineColor, RGB(150, 150, 150))

        SetGadgetColor(#edtCalc, #PB_Gadget_BackColor, RGB(0, 0, 0))
        SetGadgetColor(#edtCalc, #PB_Gadget_FrontColor, RGB(255, 255, 255))

        SetMenuItemState(#mnuCalc, #mnuB_W, 1)      ; now set the check mark
    EndIf

    SetMenuItemState(#mnuCalc, #mnuTTip, TTipF)   ; actual item state = check marked

EndProcedure

Procedure.s SearchForHelpStr(MaxKWs)                          ; get the keyword, search the keyword in the statusbar

    Protected edtTxt.s, pos, pos2, KeyW.s, keywF.b, HelpStr.s, CRLF2.s, ini, k
    
    CRLF2 = #CRLF$+#CRLF$
    edtTxt = GetGadgetText(#edtCalc)+" "
    
    pos = FindString(edtTxt, " ", 1)
    If pos > 0
        keyW = LCase(Trim(Left(edtTxt, pos)))
    EndIf
    
    If KeyW <> ""
        KeyWF = 0
        For k = 0 To MaxKWs
            If FindString(keyW , LCase(srchStr(k)), 1)
                keyWF = 1
                Break
            EndIf
        Next k
        
        If KeyWF                                                    ; if keyword found
srchKW:
            pos = FindString(Cmds, keyw, ini)
            If pos
                If Mid(Cmds, pos-2,2)=#CRLF$
                    pos2 = FindString(Cmds, CRLF2, pos)
                    If pos2 
                    
                        HelpStr = Mid(Cmds, Pos, pos2-pos)          ; get description in HelpStr
                        ;GadgetToolTip(#edtCalc, HelpStr)
                        If HelpStr <> GetGadgetText(#lblBar)
                            SetGadgetText(#lblBar, HelpStr)         ; show HelpStr in the statusbar
                        EndIf
                        
                        ;BalloonTip(GadgetID(#edtCalc), #edtCalc, HelpStr, "KeyWord: "+UCase(keyW), #TOOLTIP_INFO_ICON)
                    EndIf
                Else
                    ini = pos +1
                    Goto srchKW
                EndIf
            EndIf  
             
            ProcedureReturn srchstr(k)                  ; return keyword, HelpStr can be get from gadget

        EndIf   
    EndIf
    
    ProcedureReturn ""
    
EndProcedure

Procedure wndCalc_EventLoop()                               ; main events loop
Protected Event, WindowID, GadgetID, EventType, MenuID
Protected lret, wndW, wndH, gX, gY, gW, gH, k, cnt, sRet.s
Protected NewList llstCalc2.llist2COLS()
Protected NewList llstCalc1.llist1COL()
Protected llstRow.s, llstExpr.s, llstRes.s, Params.s, lHandle
Static DeffName.s, i, lstText.s, st.s, ln, btTitle.s, t1, Tm, iprev

    Repeat ; Start of the event loop
      
        Event = WaitWindowEvent() ; This line waits until an event is received from Windows
        WindowID = EventWindow() ; The Window where the event is generated, can be used in the gadget procedures
        GadgetID = EventGadget() ; Is it a gadget event?
        EventType = EventType() ; The event type
        
        If Plots
            Plots = aPlot_EventLoop(Event, Windowid, GadgetID, EventType, 0)
            
        EndIf

        ;You can place code here, and use the result as parameters for the procedures
        
        If Event = #PB_Event_SizeWindow
        
            wndW = WindowWidth(#wndCalc)
            wndH = WindowHeight(#wndCalc) - MenuHeight()
                        
            ResizeGadget(#lblInfo, #PB_Ignore, #PB_Ignore, wndw-2, #PB_Ignore)
    
            gX = GadgetX(#lblInfo)
            gH = GadgetHeight(#lblInfo)
            gY = GadgetY(#lblInfo)
            gW = GadgetWidth(#lblInfo)
    
            ;DebugGadgetDim(#lblInfo)
            
            ; Debug "Resize"    
            ResizeGadget(#edtCalc, 0, wndH-14-40, wndW-2, #PB_Ignore) 
    
            ;DebugGadgetDim(#edtCalc)
                    
            ResizeGadget(#lstCalc, 0, gX+gH+4, wndW-2, wndH - gY - gH - GadgetHeight(#edtCalc)- GadgetHeight(#lblBar)-8)
    
            ResizeGadget(#lblBar, 1, wndH-30, wndW -2, #PB_Ignore)
            
            ;DebugGadgetDim(#lstCalc)
    
            SetlstCalcDim(ResColF)
           
            ;Debug "--------------------------"
            
        EndIf
        
        If Event = #PB_Event_Menu                               ; /// MENUS ///////////////////////////////////////
                                                                ; /////////////////////////////////////////////////        
            MenuID = EventMenu()
        
                                                                ; /// MENU FILE ///
            If MenuID = #mnuOpen
                DeffName = FileOpenlstCalc()
                
            ElseIf  MenuID = #mnuSave
                
                DeffName = FileSavelstCalc(DeffName)
                
            ElseIf  MenuID = #mnuSaveAs

                DeffName = FileSavelstCalc("")
                
            ElseIf  MenuID = #mnuExit
            
                Event = #PB_Event_CloseWindow
            
            ElseIf MenuID = #mnuCut Or MenuID = #mnuCopy
                
                st = ""
                cnt = CountGadgetItems(#lstCalc)
                    
                For k = 0 To (cnt - 1)                                  ; get elements of listIconGadget
                    
                    If GetGadgetItemState(#lstCalc, k) = 1
                    
                        st = st + GetGadgetItemText(#lstCalc, k, 0)       
                        st = st + #TAB$ + GetGadgetItemText(#lstCalc, k, 1) 
                        If ResColF 
                            st = st + #TAB$ + GetGadgetItemText(#lstCalc, k, 2) + #CRLF$
                            
                        Else                                                ; 2 columns, Result on the next line
                                ; no row nr                             and  selected
                            If GetGadgetItemText(#lstCalc, k+1, 0) = "" And GetGadgetItemState(#lstCalc, k+1) = 1    ; no row nr
                                k = k + 1
                                st = st + #CRLF$ + GetGadgetItemText(#lstCalc, k, 1) + #CRLF$
                                
                            Else                                            ; row nr = new row
                                ; do nothing
                            EndIf
                        EndIf
                        
                    EndIf                    
                Next k
                         
                ClearClipboard()                                            ; copy in clipboard
                SetClipboardText(st)                               
             
                If MenuID = #mnuCut                                         ; delete (if Cut)
                    For k = 0 To cnt-1
                        If GetGadgetItemState(#lstCalc, k) = 1
                            RemoveGadgetItem(#lstCalc, k)
                            k - 1
                        EndIf
                    Next k
                EndIf
            
            ElseIf MenuID = #mnuPaste
                MessageRequester("anmCalc", "Function to be implemented yet")
                
            ElseIf MenuID = #mnuMatrix
                Protected dllId, MtxFunctId, mtxOut.s=Space(1000)

                mtxOut = GetGadgetText(#edtCalc)+Space(1000)
                
                CompilerIf  #UseInpMatrixDll
                    ;dllId = OpenLibrary(#MtxDLL, "InpMatrix.dll")
                    MtxFunctId = CallFunction(#MtxDLL, "Run_MtxMaker", @mtxOut)
                    
                CompilerElse
                    MtxFunctId = Run_MtxMaker(@mtxOut)
                    
                CompilerEndIf
                
                If Not MtxFunctId
                    MessageRequester("anmCalc","Unable to call function Run_MtxMaker."+#CRLF$ +"#UseInpMatrixDll = "+Str(#UseInpMatrixDll))
                EndIf
                
                If Trim(mtxOut) <> ""
                    SetGadgetText(#edtCalc, mtxOut)
                    SetActiveGadget(#edtCalc)
                    
                    SendMessage_(GadgetID(#edtCalc), #WM_KEYDOWN, #VK_END, $014F0001)
                    ; 014F 0001 = Repeat=1, ScanCode=4F, Extended=1, AltDown=0, Repeat=0, Up=0
                    SendMessage_(GadgetID(#edtCalc), #WM_KEYUP, #VK_END, $C14F0001)
                    ; C14F 0001 = Repeat=1, ScanCode=4F, Extended=1, AltDown=0, Repeat=0, Up=1
                EndIf                

            ElseIf MenuID = #mnuSelAll
                cnt = CountGadgetItems(#lstCalc)
                    
                For k = 0 To (cnt - 1)                                      ; select elements of listIconGadget
                    SetGadgetItemState(#lstCalc, k, 1)
                Next k 
                           
            ElseIf MenuID = #mnuDeleteItem
                For k = 0 To cnt-1
                    If GetGadgetItemState(#lstCalc, k) = 1
                        RemoveGadgetItem(#lstCalc, k)
                        k - 1
                    EndIf
                Next k
                                                                            ; /// MENU TOOLS ///


            ElseIf  MenuID = #mnuClearList Or MenuID = #mnuNew
                    If Not lstSaved
                        lret = MessageRequester("anm Calc", "List not saved."+#CRLF$+"Do you want to save it before clearing it?", #PB_MessageRequester_YesNoCancel)
                        
                        If lret <> #PB_MessageRequester_Cancel
                            If lret = #PB_MessageRequester_Yes
                                DeffName = FileSavelstCalc("")
                            EndIf   
                        
                        EndIf    
                    EndIf
                    ClearGadgetItems(#lstCalc)
                    SetGadgetText(#lblInfo, "New file")
                    
            ElseIf  MenuID = #mnuShowMem
                ShowMem(0)
               
            ElseIf  MenuID = #mnuShowCmds
                ShowCmds(0)
            
            ElseIf  MenuID = #mnuFunct
                ShowFuncs(0)
                                                                ; /// MENU CONFIG ///
            ElseIf MenuID = #mnuFont
              ; Debug "GadgetID: #mnuFont"
                If curFontName = ""
                    curFontName = DefFontName
                    curFontSize = DefFontSize
                EndIf
                
                lret = FontRequester(curFontName, curFontSize, 0)
                If lret
                    curFontName = SelectedFontName()
                    curFontSize = SelectedFontSize()
                EndIf
                
                FontID1 = LoadFont(1, curFontName, curFontSize)
                SetGadgetFont(#lstCalc, FontID1)
                SetGadgetFont(#edtCalc, FontID1)
                
            ElseIf MenuID = #mnuB_W
                SetMenuCheckGadgetColors()                

            ElseIf  MenuID = #mnuDecim
            
                sRet = InputRequester("anm Calc Input", "Input number of decimals for results:", Str(decimals))
                
                If IsNumeric(sRet)
                    decimals = Val(sRet)
                    ;ln = WritePrivateProfileString_("anmCalc", "Decimals", Str(Decimals), INIFileN)
                
                Else
                    MessageRequester("anm Calc Error", "Invalid number")
                EndIf
            
                
            ElseIf  MenuID = #mnuSep
            
                sSep = InputRequester("anm Calc Input", "Input separator character(s) for multiple values:", sSep)
                            
                ;ln = WritePrivateProfileString_("anmCalc", "Separator", sSep, INIFileN)
            ElseIf  MenuID = #mnuTTip
                
                If GetMenuItemState(#mnuCalc, #mnuTTip)   ; actual item state = check marked
                    SetMenuItemState(#mnuCalc, #mnuTTip, 0)
                    
                    TTipF = 0
                Else
                    SetMenuItemState(#mnuCalc, #mnuTTip, 1)
                    TTipF = 1
                EndIf

                              
            ElseIf MenuID = #mnuColumns

;+              /// CODE TO SWITCH FROM 2 TO 1 COLUMN AND VICE VERSA ///
; --------------------------------------------------------------------------
                cnt = CountGadgetItems(#lstCalc)
                DebugF( Str(cnt))

                If ResColF                                              ; from 2 to 1 column (2+ rows)  1 | xxxxxxxx | rrrrrrr |
                    ResColF = 0                                         ;                               2 | yyyyy    | uuuu    |
                    ClearList(llstCalc2())                              ;                                 |          | 222222  |
                    ClearList(llstCalc1())                              ;                                 |          | 333333  |
                    
                    For k = 0 To (cnt - 1)                              ; store elements of list
                        
                        DebugF( "k="+Str(k)+", cnt="+Str(CountGadgetItems(#lstCalc)))
                        
                        llstRow = GetGadgetItemText(#lstCalc, k, 0)     ; from 2 columns
                        llstExpr = GetGadgetItemText(#lstCalc, k, 1)
                        llstRes = GetGadgetItemText(#lstCalc, k, 2)

                                                                         ; add a new row only if numbered
                        If (Trim(llstRow) <> "") Or (llstExpr <> "" And llstExpr <> "-") ;And (llstExpr <> "" And llstExpr <> "-")
                            AddElement(llstCalc1())
                            llstCalc1()\text = llstRow+Chr(10)+llstExpr ; +Chr(10)+llstCalc2()\res
                        EndIf
                        If (llstRes <> "" ) ;And (llstExpr <> "" And llstExpr <> "-")
                            AddElement(llstCalc1())
                            llstCalc1()\text = ""+Chr(10)+llstRes
                        EndIf
                        

                        Debug_GadgetIconView(llstCalc1())
                        
                    Next k
                    
                    ClearGadgetItems(#lstCalc)                          ; rewrite elements
                    DebugF( "ClearGadgetItems")
                    Debug_GadgetIconView(llstCalc1())

                    ForEach llstCalc1()
                        AddGadgetItem(#lstCalc, -1, llstCalc1()\text)
                        
                    Next
                    
                    Debug_GadgetIconView(llstCalc1())
                    
                    RemoveGadgetColumn(#lstCalc, 2)
                                                        
                Else    
                    ResColF = 1                                         ; from 1 to 2 columns (1+ row)
                    AddGadgetColumn(#lstCalc, 2, "Result", Reswidth)
                    For k = 0 To (cnt - 1)
                        
                        DebugF( "k="+Str(k)+", cnt="+Str(CountGadgetItems(#lstCalc)))
                        
                        llstRow = GetGadgetItemText(#lstCalc, k, 0)
                        If Trim(llstRow) <> ""                          ; line numbered, bring up & right the next row (Result)
                            If Trim(GetGadgetItemText(#lstCalc, k+1, 0)) = ""
                                SetGadgetItemText(#lstCalc, k, GetGadgetItemText(#lstCalc, k+1, 1), 2)
                                ;SetGadgetItemText(#lstCalc, k+1, "", 1)
                                RemoveGadgetItem(#lstCalc, k+1)             ; delete the line moved up
                            EndIf                            
                        Else                                            
                            lstText = GetGadgetItemText(#lstCalc, k, 0) + GetGadgetItemText(#lstCalc, k, 1) + GetGadgetItemText(#lstCalc, k, 2)
                            If Trim(lstText) = ""
                                RemoveGadgetItem(#lstCalc, k)             ; delete the line moved up
                                
                            Else                                            ; line not numbered , move right and blank                                       
                                SetGadgetItemText(#lstCalc, k, GetGadgetItemText(#lstCalc, k, 1), 2)
                                SetGadgetItemText(#lstCalc, k, "", 1)
                            EndIf
                        EndIf
                        
                        Debug_GadgetIconView(llstCalc1())

                    Next k
                                        
                EndIf
;                                                                      ; ReSize gadget's columns & check menu
                ExprWidth = (wndWidth -2 - NumWidth-2) / 4 * (4-ResColF)
                SetGadgetItemAttribute(#lstCalc, 0, #PB_ListIcon_ColumnWidth , ExprWidth, 1)
            
                SetMenuItemState(#mnuCalc, #mnuColumns, ResColF)

                DebugF( "k="+Str(k)+", cnt="+Str(CountGadgetItems(#lstCalc)))
;-
                            
            ElseIf MenuID = #mnuAbout
    
                sRet = CalcAbout(0, 0)
                sRet = sRet + #CRLF$    
                ShowString(sRet, 0)
           
            EndIf
        EndIf
            
        
        If Event = #PB_Event_Gadget
            If GadgetID = #edtCalc
                If EventType = #PB_EventType_Change

                EndIf
                
            ElseIf GadgetID = #lstCalc
                If EventType = #PB_EventType_Change
                    lstSaved = 0
                    
                ElseIf EventType = #PB_EventType_LeftClick
                    Tm = ElapsedMilliseconds() - t1
                    If TTipF; Tm > 5000
                        i = GetGadgetState(#lstCalc)
                        If i <>  iprev
                            iprev = i
                            cnt = CountGadgetItems(#lstCalc)
                            btTitle = GetGadgetItemText(#lstCalc, i, 1)
                            lstText = ""
                            i + 1
                            Repeat
                                llstRow = GetGadgetItemText(#lstCalc, i, 0)
                                If (Left(llstRow, 1) <>"E")
                                    st = GetGadgetItemText(#lstCalc, i, 1)
                                    ;st = GetGadgetItemText(#lstCalc, i-ResColF, 1+ResColF)
                                    
                                    lstText = lstText +#CRLF$+ "  "+ st 
                                    llstrow = GetGadgetItemText(#lstCalc, i-ResColF, 0)
                                    i  + 1
                                Else
                                    Break                               
                                EndIf
                            ;Until  (Val(llstrow)>0) Or (i-ResColF >= cnt)
                            Until  (i-ResColF >= cnt) Or Left(llstRow, 1)="E"
                            lstText = Mid(lstText, 3)
                            If Trim(lstText) = ""
                                lstText = "   (no result to show)"
                            EndIf
                             ;GadgetToolTip(#lstCalc, lstText)
                            BalloonTip(GadgetID(#lstCalc), #lstCalc, lstText, btTitle, #TOOLTIP_INFO_ICON)
                            ;Debug lstText
                        
                        EndIf                         
                        ; t1 = ElapsedMilliseconds()
                    Else
                        
                    EndIf    
                    ;SetGadgetText(#lblInfo, GetGadgetItemText(#lstCalc, 1
                ElseIf EventType = #PB_EventType_LeftDoubleClick
                
                    i = GetGadgetState(#lstCalc)
                    st = GetGadgetItemText(#lstCalc, i, 1)
                    SetGadgetText(#edtCalc, st)
                EndIf              
            EndIf
        
        EndIf

        st = SearchForHelpStr(MaxKWs)
        SetActiveGadget(#edtCalc)
      
    Until Event = #PB_Event_CloseWindow ; End of the event loop
    
    ; SetWindowCallback(0, hWnd)
    OldWndProc = SetWindowLong_(GadgetID(#edtCalc), #GWL_WNDPROC, OldWndProc )
    
    ProcedureReturn OldWndProc
    
    
EndProcedure


Open_edtCalc()

wndCalc_EventLoop()

WriteINI()
End
;

; IDE Options = PureBasic 4.31 (Windows - x86)
; CursorPosition = 770
; FirstLine = 623
; Folding = f4
; EnableUnicode
; UseIcon = C:\Program Files\Vb30\ICONS\MISC\LIGHTON.ICO
; Executable = anmCalc.exe
; CompileSourceDirectory
; EnableCompileCount = 833
; EnableBuildCount = 34
; EnableExeConstant
; Constant = #UserProf=$USERPROFILE
; IncludeVersionInfo
; VersionField0 = 0.0.1.0
; VersionField1 = 0.0.1.0
; VersionField2 = -
; VersionField3 = %executable
; VersionField4 = 0
; VersionField5 = 0
; VersionField6 = Calculator and Expression evaluator based on aNuMet.dll
; VersionField7 = %executable
; VersionField8 = %executable
; VersionField11 = %buildcount
; VersionField12 = %buildcount
; VersionField13 = somic@libero.it
; VersionField14 = www.semelinanno.com
; VersionField18 = Build date:
; VersionField21 = %dd/%mm/%yyyy