﻿;
EnableExplicit

; - Window Constants
;
Enumeration #PB_Compiler_EnumerationValue
    #wndCalc
EndEnumeration

; - MenuBar Constants
;
Enumeration #PB_Compiler_EnumerationValue
    #mnuCalc

    #mnuNew
    #mnuOpen
    
    #mnuSave
    #mnuSaveAs
    #mnuExit
    
    #mnuCut
    #mnuCopy
    #mnuPaste
    #mnuMatrix
    
    #mnuClearList
    #mnuDeleteItem
    #mnuSelAll

    #mnuFont
    #mnuB_W
    #mnuColumns
    #mnuDecim
    #mnuSep
    #mnuTTip

    #mnuShowMem
    #mnuShowCmds
    #mnuFunct

    #mnuAbout
EndEnumeration

; - Gadget Constants
;
Enumeration #PB_Compiler_EnumerationValue
  #edtCalc
  #lblInfo
  #lblBar
  #lstCalc
EndEnumeration

; - Fonts
Global FontID1, DefFontName.s = "Monospac821 BT", DefFontSize.l = 8, BWF, TTipF
Global ResWidth, ExprWidth, wndWidth, wndHeight, NumWidth, hWnd, OldWndProc, OldWndProc_lst, gMainWinTitle.s
Global Cmds.s
Global wndX, wndY, wndW, wndH, INIFileN.s
Declare SetMenuCheckGadgetColors()                
Declare.s SearchForHelpStr(MaxKWs)                          ; get the keyword, search the keyword in the statusbar

FontID1 = LoadFont(1, DefFontName, DefFontSize)
; Procedure.l MaxL(l1.l, l2.l)
; 
;     If l1 > l2
;         ProcedureReturn l1
;     Else
;         ProcedureReturn l2
;     EndIf
; 
; EndProcedure

Procedure BalloonTip(WindowID, Gadget, Text$ , Title$, Icon)
Protected ToolTip, Balloon.TOOLINFO, ln, st.s, ret
    
     Tooltip = FindWindow_("ToolTips_Class32", 0)
     SendMessage_(ToolTip, #WM_TIMER, 1, 0)

    ToolTip=CreateWindowEx_(0,"ToolTips_Class32","",#WS_POPUP | #TTS_NOPREFIX | #TTS_BALLOON,0,0,0,0,WindowID,0,GetModuleHandle_(0),0)
    SendMessage_(ToolTip, #TTM_SETTIPTEXTCOLOR,GetSysColor_(#COLOR_INFOTEXT),0)
    SendMessage_(ToolTip, #TTM_SETTIPBKCOLOR,GetSysColor_(#COLOR_INFOBK),0)
    
    StartDrawing(WindowOutput(#wndCalc))
    ln = MaxL(TextWidth(text$), TextWidth(Title$))
    StopDrawing()
    
    SendMessage_(ToolTip, #TTM_SETMAXTIPWIDTH,0,ln*1.2)
    
    Balloon.TOOLINFO\cbSize=SizeOf(TOOLINFO)
    Balloon\uFlags=#TTF_IDISHWND | #TTF_SUBCLASS
    Balloon\hWnd=GadgetID(Gadget)
    Balloon\uId=GadgetID(Gadget)
    Balloon\lpszText=@Text$
    
    SendMessage_(ToolTip, #TTM_ADDTOOL, 0, Balloon)
    If Title$ > ""
        SendMessage_(ToolTip, #TTM_SETTITLE, Icon, @Title$)
    EndIf
  
EndProcedure


Procedure WinCallback(hWnd, uMsg, wParam, lParam)           ; Window CallBack procedure, to manage some keyboard events

Protected nVirtKey, lKeyData, chCharCode, st.s, st2.s, lstText.s, Params.s, lExitCode, i, lret
Protected lexpr.s, lresStr.s, pos, cnt, k, col1Str.s, col2Str.s, lnRes.s, keyW.s

    ;Debug DecodeWindowMessage(hWnd, uMsg, wParam, lParam)
    

    Select uMsg
;         Case #WM_KEYDOWN
;             nVirtKey = wParam
;             If nVirtKey = #VK_RETURN
;                 Debug "Enter"
;             EndIf
            
        Case #WM_CHAR
        
            chCharCode = wParam
            lKeyData = lParam
            
            If chCharCode = #VK_ESCAPE
                End
                                
            ElseIf chCharCode = #VK_RETURN
            
                lexpr = GetGadgetText(#edtCalc)                 ; get expression, evaluate it and trim result
                
                If lexpr <> ""
                
                    keyW = SearchForHelpStr(MaxKWs)
                    If keyW = ""
                        lexpr = "Expr = "+lexpr
                    EndIf
;                     
                    lresStr = ""
                    Params = " /noh /nln /nt /sel:'"+ lexpr +"' /";
                    
                    Protected anmFunctId, mtxOut.s=Space(1000)
                    
                    CompilerIf 0;#UseanmEvalDll
                        anmFunctId = CallFunction(#anmEvalDll, "anmEvalMain", Params)
                        anmFunctId = CallFunction(#anmEvalDll, "GetEvalResult", @mtxOut, Len(mtxOut))
                    
                    CompilerElse
                        lExitCode = anmEvalMain(Params)
                        res = GetEvalResult(@mtxOut, Len(mtxOut))
                        
                    CompilerEndIf
                    
                    lresStr = TrimChar(mtxOut, #CRLF$)
                    lresStr = Trim(lresStr)
                    
                    lresStr = ReplaceString(lresStr, #TAB$, "    ")
                    
                    If mtxOut <> ""                                 ; format output              
    ;+                
                        If FindString(lresStr, "ERROR", 1)          ; if ERROR remove expression
                            pos = FindString(lresStr, "===>", 1)
                            If pos > 0
                                lresStr = Mid(lresStr, pos + 5)
                                
                            EndIf
                        EndIf
                        ;Debug resStr:
                        
                                                                    ; set/write the input expression
                                                                    ; 1st column is indipendent from result
                        lstCnt = lstCnt +1 
    ;                     If ResColF
    ;                         col1Str = "E"+Str(lstCnt)+Chr(10)+lexpr 
    ;                         
    ;                     Else    
                            col1Str = "E"+Str(lstCnt)+Chr(10)+lexpr
                            AddGadgetItem(#lstCalc, -1, col1Str)
                            
    ;                     EndIf 
    
                        lresStr = lresStr + #CRLF$                  
                                                                    ; set the 2nd column result string
                        cnt = CountString(lresStr, #CRLF$)          ; result may have multiple lines
                        For k = 1 To cnt
    
                            lnRes = StringField(lresStr, k, #LF$)   ; get result line (#CRLF$ = Chr(13) + Chr(10))
                            lnRes = Left(lnRes, Len(lnRes)-1)       ; remove LF after CR
                            
    ;                         If ResColF                              ; if two columns
    ;                             If k > 1                            ; if result is in more than one line
    ;                                 ; col1Str = " "+Chr(10)+"-"
    ;                                 col1Str = "R"+Str(lstCnt)+"."+Str(k);+Chr(10)+"-"
    ;                             Else
    ;                                 col2Str = Chr(10)+"="+lnRes
    ;                             EndIf
    ;                             
    ;                         Else                                    ; if ONE column (no col2Str)
                                col1Str = ""
                                ; col2Str = " "+Chr(10)+lnRes
                                If lnRes <> ""
                                    ; col2Str = "R"+Str(lstCnt)+Chr(10)+lnRes
                                    col2Str = "="+Chr(10)+"  "+lnRes
                                    lstText = col1Str+col2Str
                                    AddGadgetItem(#lstCalc, -1, lstText)
                                Else
                                    col2Str = ""
                                    lstText = ""
                                EndIf
                                 
    ;                         EndIf 
                            
                        Next k
                        
    ;-                  FORMAT OUTPUT
    ; -------------------------------------------------
                          
                        i = CountGadgetItems(#lstCalc)
                        lret = SendMessage_(GadgetID(#lstCalc), #LVM_ENSUREVISIBLE, i-1, 0) ; scroll view to show last line
    
                    Else: 
                        ;Debug lExitCode: 
                        
                    EndIf ; If mtxOut <> "" 
    
                    SetGadgetText(#edtCalc, "")
                    
                    ProcedureReturn 0                           ; stop window processing
                EndIf
                            
            EndIf
;         Case #WM_KEYUP
;             nVirtKey = wParam
            
        Default
    
    EndSelect


    ProcedureReturn CallWindowProc_(OldWndProc, hWnd, uMsg, wParam, lParam); continue window processing

        
EndProcedure

; Procedure WinCallback_lst(hWnd, uMsg, wParam, lParam)           ; Window CallBack procedure, to manage some keyboard events
; 
;     WinCallback(GadgetID(#edtCalc), uMsg, wParam, lParam)
; 
;     ProcedureReturn CallWindowProc_(OldWndProc_lst, hWnd, uMsg, wParam, lParam); continue window processing
; 
;         
; EndProcedure

Procedure.s ReadINIstr(kewStr.s, defVals.s="", lpAppName.s="", INIFileN.s="") 
Protected st40.s="                                        ", i
Static llpAppName.s, lINIFileN.s, ldefvals.s

    If lpAppName <> ""
        llpAppName = lpAppName
    EndIf
    If INIFileN <> ""
        lINIFileN = INIFileN
    EndIf
    If defVals <> ""
        ldefVals = defVals
    EndIf
    
    If llpAppName = "" Or lINIFileN = "" Or (kewStr = "" And defVals = "")
        ProcedureReturn ""
    Else
        i = GetPrivateProfileString_(llpAppName, kewStr, ldefVals, @st40, 40, lINIFileN)
    EndIf
    
    ProcedureReturn Left(st40, i)

EndProcedure


Procedure ReadINILong(kewStr.s, defVal=0);, lpAppName.s="", INIFileN.s="")
Protected st10.s="          ", i, defVals.s
Static llpAppName.s, lINIFileN.s, ldefval

;         i = GetPrivateProfileString_(llpAppName, kewStr, Str(defVal), @st10, 10, lINIFileN)
    
    st10 = ReadINIstr(kewStr, Str(defVal))
    ProcedureReturn Val(st10)

EndProcedure

Procedure WriteINIstr(kewStr.s, str2Write.s, lpAppName.s="", INIFileN.s="")
Protected i
Static llpAppName.s, lINIFileN.s

    If lpAppName <> ""
        llpAppName = lpAppName
    EndIf
    If INIFileN <> ""
        lINIFileN = INIFileN
    EndIf
    
    If llpAppName = "" Or lINIFileN = "" Or (kewStr = "" And str2write = "")
        ProcedureReturn 0
    Else
        i = WritePrivateProfileString_(llpAppName, kewStr, str2Write, lINIFileN)
    EndIf
    
    ProcedureReturn i

EndProcedure

Procedure WriteINILong(kewStr.s, lng2Write);, lpAppName.s="", INIFileN.s="")
Protected i

    i = WriteINIstr(kewStr.s, Str(lng2Write))
    
    ProcedureReturn i

EndProcedure

Procedure ReadINI()                                         ; read ini file
Protected state

    INIFileN = GetPathPart(ProgramFilename())+"anmCalc.ini"
    
    ReadINIStr("", "", "anmCalc", INIFileN)      ; reset KeyWord and INIFIle name
    
    wndX = ReadINILong("wndX", 50)
    wndY = ReadINILong("wndY", 50)
    wndW = ReadINILong("wndW", 320)
    wndH = ReadINILong("wndH", 415)
    
    NumWidth = ReadINILong("NumWidth", 30)
    ExprWidth = (wndWidth -2 - NumWidth-2) / 4 * 3
    ExprWidth = ReadINILong("ExprWidth", ExprWidth)
    ResWidth =  (wndWidth -2 - NumWidth-2) / 4 * 1
    ResWidth = ReadINILong("ResWidth", ResWidth)


    DefFontName = ReadINIstr("DefFontName", "Lucida Console", "Config", INIFileN)
    DefFontSize = ReadINILong("DefFontSize", 8)
    
    curFontName = ReadINIstr("curFontName", DefFontName)
    curFontSize = ReadINILong("curFontSize", 8)

    BWF = ReadINILong("mnuBlackWhite", 1)
        
    ; ResColF = ReadINILong("Columns", 1)
    ResColF = 0
    decimals = ReadINILong("Decimals", 4)
    sSep = ReadINIstr("sSeparator", sSep)
    TTipF = ReadINILong("ToolTip", 0)

    
EndProcedure

Procedure WriteINI()                                        ; write ini file
Protected i
    ;INIFileN = GetPathPart(ProgramFilename())+"\anmCalc.ini"
    
    WriteINIstr("", "", "anmCalc", INIFileN)

    i = WriteINILong("wndX", WindowX(#wndCalc)); , "anmCalc", INIFileN)
    i = WriteINILong("wndY", WindowY(#wndCalc))
    i = WriteINILong("wndW", WindowWidth(#wndCalc))
    i = WriteINILong("wndH", WindowHeight(#wndCalc))
    
    NumWidth = GetGadgetItemAttribute(#lstCalc, 0, #PB_ListIcon_ColumnWidth , 0)
    i = WriteINILong("NumWidth", NumWidth)
    ExprWidth = GetGadgetItemAttribute(#lstCalc, 0, #PB_ListIcon_ColumnWidth , 1)
    i = WriteINILong("ExprWidth", ExprWidth)
    ResWidth =  GetGadgetItemAttribute(#lstCalc, 0, #PB_ListIcon_ColumnWidth , 2)
    i = WriteINILong("ResWidth", ResWidth)

    i = WriteINIstr("DefFontName", "Lucida Console", "Config", INIFileN)
    DefFontSize = WriteINILong("DefFontSize", 8)
    
    i = WriteINIstr("curFontName", curFontName)
    curFontSize = WriteINILong("curFontSize", curFontSize)

    BWF = WriteINILong("mnuBlackWhite", GetMenuItemState(#mnuCalc, #mnuB_W))
    
    ;i = WriteINILong("Columns", 1+ResColF)
    i = WriteINILong("Decimals", decimals)
    i = WriteINIstr("sSeparator", sSep)
    i = WriteINILong("ToolTip", TTipF)
    
EndProcedure

Procedure Open_edtCalc()                                    ; open main form
Protected barWidth, st.s, lret

    ReadINI()
    
    wndWidth = wndW
    barWidth = 100
    
    gWinLogTitle = "anm Calulator Log"
    gMainWinTitle = "anm Calulator" 
    
    If OpenWindow(#wndCalc, wndX, wndY, wndW, wndH, gMainWinTitle,  #PB_Window_SystemMenu | #PB_Window_MinimizeGadget | #PB_Window_MaximizeGadget | #PB_Window_SizeGadget | #PB_Window_TitleBar )
        
        If CreateMenu(#mnuCalc, WindowID(#wndCalc))
;+      MENU LIST
            MenuTitle("&File")
            MenuItem(#mnuNew, "&New")
            MenuItem(#mnuOpen, "&Open")
            MenuItem(#mnuSave, "&Save")
            MenuItem(#mnuSaveAs, "Save &As")
            MenuBar()
            MenuItem(#mnuExit, "&Exit")
            
            MenuTitle("&Edit")
            MenuItem(#mnuCut, "&Cut")
            MenuItem(#mnuCopy, "Co&py")
            MenuItem(#mnuPaste, "&Paste")
            MenuItem(#mnuMatrix, "&Matrix")
            MenuBar()
            MenuItem(#mnuClearList, "C&lear list")
            MenuItem(#mnuDeleteItem, "&Delete item(s)")
            MenuItem(#mnuSelAll, "&Select all")

            MenuTitle("&Config")
            MenuItem(#mnuFont, "&Font")
            MenuItem(#mnuB_W, "&Black-White")
            MenuItem(#mnuDecim, "&Decimals")
            MenuItem(#mnuSep, "Se&parator")
            MenuItem(#mnuTTip, "&ToolTip")
            ;MenuItem(#mnuColumns, "&Result Column")
            
            MenuTitle("&Tools")
            MenuItem(#mnuShowMem, "Show &Memory")
            MenuItem(#mnuShowCmds, "Show &Commands")
            MenuItem(#mnuFunct, "Show &Functions")
            
            MenuTitle("&Info")
            MenuItem(#mnuAbout, "&About")
;-      MENU LIST
; ----------------------------------------------------
        EndIf

        SetMenuItemState(#mnuCalc, #mnuB_W, GetMenuItemState(#mnuCalc, #mnuB_W))
    
        If #PB_Compiler_Debugger                            ; test string
            st = "Matr = [mB];   3;   3;   0;   1; 2; 1.2; 2.2; 3.2; 1; 2; 16.6866*Sin(0.5)"
            
        EndIf
        TextGadget(#lblInfo, 2, 2, wndWidth-4, 18, "Info"); , #PB_Text_Border)
        ListIconGadget(#lstCalc, 0, 20, wndWidth-2, 302, "#", 30, #PB_ListIcon_AlwaysShowSelection+ #PB_ListIcon_FullRowSelect+#PB_ListIcon_MultiSelect)
        StringGadget(#edtCalc, 0, 324, wndWidth-2, 22, st)
        TextGadget(#lblBar, 1, 333+28, wndWidth-4, 30, "Help");, #PB_Text_Border )

        SetGadgetFont(#edtCalc, FontID1)
        AddGadgetColumn(#lstCalc, 1, "E: Expression, =: Result", exprWidth)
        ; AddGadgetColumn(#lstCalc, 2, "Result", Reswidth)
        ResColF = 0
    
        SetMenuCheckGadgetColors()                
        SetGadgetFont(#lstCalc, FontID1)

        FontID1 = LoadFont(1, curFontName, curFontSize)
        SetGadgetFont(#lstCalc, FontID1)
        SetGadgetFont(#edtCalc, FontID1)
        SetGadgetText(#lblInfo, "New file")

        
    EndIf
    
    hWnd = #edtCalc
    OldWndProc = SetWindowLong_(GadgetID(#edtCalc), #GWL_WNDPROC, @WinCallback())
    ;OldWndProc_lst = SetWindowLong_(GadgetID(#lstCalc), #GWL_WNDPROC, @WinCallback_lst())
    ;OldWndProc = SetWindowLong_(WindowID(#wndCalc), #GWL_WNDPROC, @WinCallback())
    debugF("", 0)
    
    
    Cmds = LCase(sRes$)
    
EndProcedure

Procedure.s CalcAbout(HeadF.b = 0, noHeaderF.b = 0)         ; show about form
Protected st.s, car.s{1}, AnUc.s

    ;sRes$ = ""
    st = ""
    If noHeaderF : ProcedureReturn st : EndIf
    
    If HeadF : car = "'" : EndIf

    If #PB_Compiler_Unicode
        AnUc = "Unicode"
    Else
        AnUc = "Ansi"
    EndIf
    
    st = car + "Program name: anmCalc.exe (Array of Numerical Methods Calculator)" + #CRLF$
    st = st + car + "Version: 0.0.1.0 - Built: " + Str(#PB_Editor_BuildCount) + ". (" + AnUc +" version)" + #CRLF$
    st = st + car + "By: Carlo Somigliana, email: somic@libero.it, site: www.semelinanno.com" + #CRLF$
    st = st + car + "Original Web Page: www.semelinanno.com\downloads\anmcalc\anmcalc_Page.html"+ #CRLF$
    If HeadF : 
    st = st + car + "---------------------------------------------------------------------------" + #CRLF$
        ProcedureReturn st
    EndIf

    st = st + car + "---------------------------------------------------------------------------" + #CRLF$
    st = st + car + "First thanks to the PureBasic Team for PureBasic, without them this"+#CRLF$
    st = st + car + "program wouldn't exist. :-)"+ #CRLF$+ #CRLF$
    st = st + car + "This program is an advanced calculator of math formulas"+ #CRLF$
    st = st + car + "It calculates and plots expressions, polynomials, integrals, matrices," + #CRLF$
    st = st + car + "derivatives, with a simple script language"+#CRLF$
    
    st = st + car + "It incorporates the math library aNuMet.dll (Array of Numerical Methods)"+#CRLF$
    st = st + car + "a dll for numerical calculations, implementing 40+ math and matrix functions." + #CRLF$
    st = st + car + "Dll link http://www.semelinanno.com/downloads/anumet/aNuMet_Page.html." + #CRLF$+ #CRLF$
    st = st + car + "Written in PureBasic 4.31 (x86) - (see www.purebasic.com)." + #CRLF$
    st = st + car + "This program is FREEWARE. Necessary Disclaimer: use at your own risk." + #CRLF$+ #CRLF$
    st = st + car + "Pls report any bugs and/or comments to me. Fixes will be ...a.s.a.p.... :-}"+#CRLF$
    st = st + car + "If you are courious, visit the website: www.semelinanno.com for more info." + #CRLF$
    st = st + car + "---------------------------------------------------------------------------" + #CRLF$

    sRes$ = st
    
    ProcedureReturn sRes$
    
EndProcedure
; IDE Options = PureBasic 4.31 (Windows - x86)
; CursorPosition = 226
; FirstLine = 163
; Folding = ---
; EnableUnicode
; UseMainFile = anmCalc.pb
; Executable = ..\anmCalc.exe
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0