﻿; PROJECT: aNuMet (Array of Numerical Methods), by Carlo Somigliana
; visit the web site www.semelinanno.com for more info and programs
; you can also email me at: somic@libero.it

; DESCRIPTION: this is a simple And poorly written couple of routines parsing the command string
; that is passed to the anumet.dll library for the evaluation


; LICENSE: this code is released FREEWARE. You are free to use and modify it at your wish and risk.
; No further info and support is provided nor garranteed.
; If you do something good from it, pls let me know
;---------------------------------------------------------------------------------
EnableExplicit

#UseaNuMetCode  = 0
#UseDll         = 1
#UseServer      = 2
; -----------------------------------------------------------------------------------------------
#UseType = #UseDll ; #UseaNuMetCode        ;0=Use Source Code, 1=Use DLL; 2=Use Server
; -----------------------------------------------------------------------------------------------

Global Dim WndPlot.l(0) : Global Dim ImgPlots.l(0) : Global Plots.l
Global CurDir.s = GetPathPart(ProgramFilename())+"anmXNpp\"
Global InpFN.s, OutpFN.s, splPath.s, *params, splPath.s, decimals.l, ret

CompilerIf #UseType = #UseaNuMetCode
    IncludeFile "Solver.pb"                     ;Include Solver.pb
    IncludeFile "aPlot.pb"
       
CompilerElse

    IncludeFile "aNuMet.pbpt"
    IncludeFile "EqParser.pbpt"
    IncludeFile "Solver.pbpt"
    IncludeFile "Derive.pbpt"
    IncludeFile "ErrMsgs.pbpt"
    IncludeFile "aPlot.pb"
    
CompilerEndIf

Declare.l sEval(sIn.s, *sPtr, *sOutLen, noTextF, lnsF, LnCorr, LnsStr.s, pBarF, noLnExpF, splF)
Declare.s FileInpOut(param.s, action.s, matr.s = "")
Declare.s GetStErrDescr(ErrNum.l)


Procedure.l EvalParser(lInpFN.s, lOutpFN.s, lsplPath.s, ldecimals.l, *sResPtr, HeadStr.s, nohF, logF, noTextF, lnsF, LnCorr, LnsStr.s, pBarF, noLnExpF, splF)
Protected sOut.s, sOutLen.l, ErrCnt.l, *sOut, Cmds.l, ln.l
Protected fv.s, pv.s, fn.s, sRes2$
;Shared params()

    InpFN = lInpFN
    OutpFN = lOutpFN
    splPath = lsplPath
    decimals = lDecimals
    
    ;MessageRequester("sRes$", sRes$)
    
    ;*******************************************************************************
    
    ret = sEval(sRes$, @*sOut, @sOutLen, noTextF, lnsF, LnCorr, LnsStr, pBarF, noLnExpF, splF)
    
    ;*******************************************************************************
    
    sOut = Space(sOutLen);sOutLen is already Ascii or Unicode
    If *sOut>0
        sOut = PeekS(*sOut, -1, #PB_Unicode)
        FreeMemory(*sOut)
    EndIf
       
    ;MessageRequester("sOut", sOut)   

    ErrCnt = Val(Right(Str(ret), 3))
    Cmds = ret/1000
        
        If nohF = 0
            fv = "" : pv = "" : fn = "";GetPathPart(#PB_Compiler_File) + "anmXNpp.dll"
            DisplayVerInfo(fn, @fv, @pv)
            
            sRes$ = HeadStr + #CRLF$;"'Program: aExpEval.exe - rel. " + fv +#CRLF$
    
            fv = "" : pv = "" : fn = "";#aNuMetDLL$ ;GetPathPart(#PB_Compiler_File)+"aExpEval.exe"
            DisplayVerInfo(fn, @fv, @pv)
            sRes$ = sRes$ + "'Incorporates library aNuMet.dll - rel. " + fv + #CRLF$
            
            ;sRes$ = sRes$ + "'by C. Somigliana, email: somic@libero.it" + #CRLF$
            sRes$ = sRes$ + "'------------------------------------------------------------------------------------" + #CRLF$
            sRes$ = sRes$ + "'BatchRun : Time " + FormatDate("%dd/%mm/%yyyy - %hh:%ii:%ss", Date()) + #CRLF$
            sRes$ = sRes$ + "'Input file: " + InpFN + #CRLF$
            sRes$ = sRes$ + "'Executed Commands: " + Str(Cmds) + ", Errors found: " + Str(ErrCnt) + #CRLF$
            sRes$ = sRes$ + "'************************************************************************************" + #CRLF$
            sRes$ = sRes$ + sOut
        Else
            sRes$ = sOut
        EndIf
        
    ExitCode = #ANM_EVAL_NO_ERROR
    
    If Right(sRes$, 2) <> #CRLF$: sRes$ = sRes$ + #CRLF$: EndIf
    
    sLog("Eval Executed : Commands: " + Str(Cmds) + ", Errors: " + Str(ErrCnt), logF)

    PokeL(*sResPtr, @sRes$)
    
    ProcedureReturn Len(sRes$)
    
EndProcedure


Procedure.l sEval(sIn.s, *sPtr, *sOutLen, noTextF, lnsF, LnCorr, LnsStr.s, pBarF, noLnExpF, splF)

;sIn=String to Evaluate, *sPtr=pointer to output string, *sOutLen=pointer len of output text
;Return Cmds * 1000 + ErrCnt ;es 165 lines and 3 errors = 164003
Protected i.l, k.l, cnt.l, riga$, keyW.s, num.l, param.s, st1.s, pos.l, fin.l, params.s, ErrCnt.l
Protected dRet.d, r1.l, c1.l, mMemID.l, anmResStr.s, result.s, fName.s, iFunct.s, par1.l, par2.l
Protected x0.d, xN.d, method.s, met.l, sVar.s, MatrN.s, elem.s, vl.s, MatrN2.s, Polyn.s, FolderF.b
Protected resN.s, addr.l, r.l, c.l, FileOutF.b, action.s, st2.s, ms.l, Cmds.l, st.s, sN1.l, ReportCommentF.b
Protected ln.l, lni.l, lRetStr.s, AddlText.s, OldDebugF.l, OldErrMsgF.l, NumFrmt.s
Static resCnt.l, ErrNum.l, FileF.s, InpF.s, OutF.s, sOut.s, anmResStr2.s, lnRiga.l, VarPolyn.s
;Shared params()
Protected Dim outStr.s(4), ResultStr.s, StoreRes.s
;OnErrorCall(@ErrorHandler())
    
    Shared WndPlot.l() : Shared ImgPlots.l()
    Shared btnRedraw.l()
    Shared btnClosePlot.l()
    Shared lblRedraw.l()
    Shared txtFrom.l()
    Shared lblTo.l()
    Shared txtTo.l()

    If noTextF
        outStr(#nnIsNumber) = ""
        outStr(#nnIsMatrix) = ""
        outStr(#nnIsMatrix+1) = ""
        ResultStr = ""
        StoreRes = ""
    Else
        outStr(#nnIsNumber) = "Number ="
        outStr(#nnIsMatrix) = "Vector: "
        outStr(#nnIsMatrix+1) = "Matrix: "
        ResultStr = " Result => "
        StoreRes = " Stored => "
    EndIf
    
    
    For i = 1 To Plots                                      ; close all plot forms
        If WndPlot(i)<>0
            CloseWindow(WndPlot(i))
        EndIf
    Next i
    
    plots = 0
    NumFrmt = "0." + ReplaceString(Space(decimals), " ", "0")
    anmResStr = ""
    ErrCnt = 0
    
    sIn = sIn + #CRLF$
    ;Debug sIn
    cnt = CountString(sIn, #CRLF$)

    ;MessageRequester("sEval", sIn)
    
    For i = 1 To cnt
    
        ExitCode = #ANM_EVAL_NO_ERROR
        param = ""
        ;result = ""

;+ ;RIGA STRING PARSING
ReadRiga:
        riga$ = Trim(StringField(sIn, i, #CR$))
        
        ;MessageRequester("sEval", riga$)
        ;riga$ = Trim(GetGadgetItemText(#txtEval, i));first line has index 0, then ErrorLine is i+1
        ;Debug riga$
        If lnsF And i< = cnt;params(3) = 1
            resN = ";" + Str(i + LnCorr) + ";"
            pos = FindString(LnsStr, resN, 1)
            If pos = 0
                i = i + 1
                Goto ReadRiga
            Else
                LnsStr = RemoveString(LnsStr, Str(i + LnCorr))
            EndIf
        EndIf
        
        If Left(riga$, 1) = #LF$
            riga$ = Mid(riga$, 2)
        EndIf
        
        lnRiga = Len(riga$) + 1;: If lnRiga = 0: lnRiga = 1: EndIf
        If Left(riga$, 2) = "''" :
            anmResStr = anmResStr + riga$ + #CRLF$
        EndIf
        
        If (FindString(riga$, "\\", 1)<>0) Or ReportCommentF ; ; skip comments from evaluation
            ReportCommentF = 1
            anmResStr = anmResStr + riga$ + #CRLF$
            If FindString(riga$, "//", 1)<>0
                ReportCommentF = 0
            EndIf
            Continue
            
        EndIf
        
        If Left(riga$, 2) = "!\" Or FolderF                 ; skip comments from evaluation (but include into output)
            FolderF = 1
            anmResStr = anmResStr + riga$ + #CRLF$
            If Left(riga$, 2) = "!/"
                FolderF = 0
            EndIf
            Continue
            
        EndIf
        
        If Left(riga$, 1) = "'" : Continue : EndIf
        ;Debug riga$
        
        pos = FindString(riga$, "=", 1)
InitRiga:

        If pos = 0
            pos = FindString(riga$, "(", 1);se es. Integrate(...)
            If pos>0
                keyW = LCase(Trim(Left(riga$, pos-1)))
                par1 = pos
                par2 = FindString(riga$, ")", 1)
            Else
                If i = 105
                    i = i
                EndIf
            EndIf

       Else
            par1 = FindString(Left(riga$, pos), "(", 1)
            par2 = FindString(Left(riga$, pos), ")", 1)
            If par1>0
                keyW = LCase(Trim(Left(riga$, par1-1)))
            Else
                keyW = LCase(Trim(Left(riga$, pos-1)))
            EndIf
        EndIf
        fin = FindString(riga$ + "'", "'", 1)
        riga$ = Left(riga$, fin-1)

;- SHOW
        
        If pos>0
            Cmds = Cmds + 1

            If pBarF
                ;MessageRequester("", riga$)
                ret = SetProgressBar(i, cnt, 1, riga$)
                
            EndIf

            ;Debug keyW
            Select keyW
                Case "aabout"                               ; show about form
                    st1 = ""
                    st = Space(4000)
                    st = PeekS(aAbout(1))
                    For ln = 1 To CountString(st, #LF$)
                        st1 = st1 + "'" + StringField(st, ln, #LF$) + #LF$
                    Next ln
                    anmResStr = anmResStr + st1
                    
                Case "show"                                 ; show value
;+
                    dRet = 0.0
                    st1 = Trim(Mid(riga$, pos + 1)) ;1. expression or 2. matrexpr
                    resN = Trim(Mid(riga$, par1 + 1, par2-par1-1)) ;1. varName or 2. relpath, filename

                    ret = FindVarFunct(resN, 0, @dRet);0 = variable
                    ;Debug GetErrorDLL()
                    
                    If GetE_Error() = #ANM_EVAL_NO_ERROR
                        result = "Number " + resN + " = " + StrD(dRet, decimals)
                       
                    Else
                        st1 = Space(20)
                        ret = FindVarFunct(resN, 1, @st1, @dRet); 1 = function
                        ;st1 = PeekS(dRet)
                        If ret ; e_error = #ANM_EVAL_NO_ERROR
                            result = "Function " + resN + " = " + Mid(st1, 1, dRet)
                        Else
                            ;ret = e_get_const(resN, @e_spelling)
                            st1 = resN
                            ret = e_get_const(@st1, @dRet)
                            If ret ; e_error = #ANM_EVAL_NO_ERROR ; <> #ANM_EVAL_UndefinedConst
                                ;dRet = ValD(lRetStr)
                                result = "Constant " + resN + " = " + StrD(dRet, decimals)
                            
                            Else        ;e_error <> #e_UndefinedConst
                            
                                If Left(resN, 1)<>"[" : resN = "[" + resN : EndIf
                                If Right(resN, 1)<>"]" : resN = resN + "]" : EndIf
                                mMemID = FindMatrix(resN, (#SrcName + #RetMatrPtr), @r1, @c1) ;get result matrix stored in DLL
                                ;"Matr = [mC]; 3; 3; 1; 1; 4; 0; 3; 1; 4; 3; (3+2)"

                                If mMemID = 0
                                    ;e_error = #ANM_EVAL_MatrNotFound
                                    AddlText = "Matr Name: " + resN
                                    SetErrorMsgs(#PB_Compiler_Procedure, #PB_Compiler_Line, AddlText)
                                    ErrNum = GetE_Error()
                                    ErrCnt = ErrCnt + 1
                                    result = "===> ERROR n. = " + Str(ErrNum) + ": " + PeekS(GetE_ErrDescr(ErrNum))
                                    
                                Else
                                    st = resN + #CRLF$ : addr = mMemID
                                    For r = 0 To r1-1 ;assemble matrix definition string
                                        For c = 0 To c1-1
                                            If c1 = 1
                                                st = st + "vE" + "(" + Str(r) + ")=" + StrD(PeekD(addr), decimals) + #TAB$
                                            ElseIf r1 = 1
                                                st = st + "vE" + "(" + Str(c) + ")=" + StrD(PeekD(addr), decimals) + #TAB$
                                            Else
                                                st = st + "mA" + "(" + Str(r) + "," + Str(c) + ")=" + StrD(PeekD(addr), decimals) + #TAB$
                                            EndIf
                                            ;st = st + Trim0s(st1)+"; "
                                            addr = addr + 8
                                        Next c
                                        st = st + #CRLF$
                                    Next r
                                    result = st
                                    ;CAN'T USE aPrint because the mMemID is from Client Side (matrix is sent from Svr to Client)
                                    ;while aPrint works on Server side and needs an address of Server.
                                    ; for SourceCode and DLL this is not a problem because Svr & Cli are the same
                                    ;ret = aPrint(mMemID, r1, c1,"String", NumFrmt, resN, "")
                                    ;result = PeekS(ret) ;get result string
        
                                    If c1 <= 1
                                        result = outStr(#nnIsMatrix) + result
                                    Else
                                        result = outStr(#nnIsMatrix+1) + result
                                    EndIf
                                    
                                EndIf
                            EndIf
                        EndIf
                    EndIf
                    
                    If noLnExpF = 0
                        anmResStr = anmResStr + "Ln " + Str(i) + ": " + "Show(" + resN + ")"
                    EndIf
                    anmResStr = anmResStr + " => " + result + #CRLF$ + #CRLF$
;- PLOT
                Case "plot"                                 ; plot graph of function
                                                            ; Plot(-100; x; 100; 200) = 1 + 12*x - 3*x^3 + 2x^4 - 5x^5
;+
                    Plots = Plots + 1
                    
                    ReDim WndPlot.l(Plots)
                    ReDim ImgPlots.l(Plots)
                    ReDim btnRedraw.l(Plots)
                    ReDim btnClosePlot.l(Plots)
                    ReDim lblRedraw.l(Plots)
                    ReDim txtFrom.l(Plots)
                    ReDim lblTo.l(Plots)
                    ReDim txtTo.l(Plots)

                    ;Debug "Plots*10+110="+Str(Plots*10+110)
                    WndPlot(Plots) = Plots*10 + 110; oppure #PB_Compiler_EnumerationValue
                    ImgPlots(Plots) = Plots*10 + 110 + 1
                    btnRedraw(Plots) = Plots*10 + 110 + 2
                    btnClosePlot(Plots) = Plots*10 + 110 + 3
                    lblRedraw(Plots) = Plots*10 + 110 + 4
                    txtFrom(Plots) = Plots*10 + 110 + 5
                    lblTo(Plots) = Plots*10 + 110 + 6
                    txtTo(Plots) = Plots*10 + 110 + 7

                    OldDebugF = SetDebugF(0)                ; set no debug to avoid slow calculation and backup debug flags 
                    OldErrMsgF = SetErrorMsgsF(0)
                    
                    aPlotExpr(riga$, pos, par1, par2, plots)
                    
                    If splF ; spl = SavePlots
                        Protected SavedFileN.s
                        savedFileN = Space(#MAX_PATH)
                        ret = GetWndSnapShot(WndPlot(plots), splPath, @SavedFileN)
                        If ret 
                            result = SavedFileN
                        EndIf
                        CloseWindow(WndPlot(Plots))
                        
                    Else
                        result = "plot not saved file"
                    EndIf
                    
                    SetDebugF(OldDebugF)                    ; restore previous debug settings
                    SetErrorMsgsF(OldErrMsgF)
                    
                    If noLnExpF = 0 Or ErrNum <> #ANM_EVAL_NO_ERROR
                        anmResStr = anmResStr + "Ln " + Str(i) + ": " + "Plot = " + riga$ + ":" + #CRLF$
                    EndIf
                    anmResStr = anmResStr + " FileName => " + result + #CRLF$ + #CRLF$
;- SOLVEPOLYN
                Case "solvepolyn"                           ; solve polynomium
;+
                    st1 = Trim(Mid(riga$, pos + 1))
                    Polyn = ReplaceString(st1, "'", "")
                    dRet = dSolve(Polyn, VarPolyn)
                    
                    ErrNum = GetE_Error()
                    If ErrNum <> #ANM_MTX_MatrOK
                        ErrCnt = ErrCnt + 1 ;test error
                        result = "===> ERROR n. = " + Str(ErrNum) + ": " + PeekS(GetE_ErrDescr(ErrNum))
                        
                    Else
                        result = outStr(#nnIsNumber) + StrD(dRet, decimals)
                    EndIf
                    If noLnExpF = 0 Or ErrNum<>#ANM_MTX_MatrOK
                        anmResStr = anmResStr + "Ln " + Str(i) + ": " + "Polyn = " + Polyn + ":" + #CRLF$
                    EndIf
                    anmResStr = anmResStr + " Solution Polyn => " + result + #CRLF$ + #CRLF$
                    ;SetGadgetText(#txtOutp, anmResStr)
;- DIMX
                Case "dimx"                                 ; store matrix in the following format
;+
; st = st + #CRLF$ + "DimX = mE(3,3); mE(0,0)=1; mE(0,1)=2 ; mE(0,2)=3 "
; st = st + #CRLF$ + "DimX = mE(3,3); mE(1,0)=0; mE(1,1)=-2; mE(1,2)=3 'definition 'Matr = mE(3,3)' has to be repeated"
; st = st + #CRLF$ + "DimX = mE(3,3); mE(2,0)=0; mE(2,1)=-8; mE(2,2)=4 'on each line"
; st = st + #CRLF$ + "Matr = [mC]; 3; 3; 1; 1; 4; 0; 3; 1; 4; 3; 5"

                    st1 = "" : params = ""
                    Repeat
                        st1 = Trim(Mid(riga$, pos + 1))
                        par1 = FindString(riga$, "(", pos + 1)
                        par2 = FindString(riga$, ")", par1 + 1)
                        
                        MatrN = Trim(Mid(riga$, pos + 1, par1-pos-1))
                        If Left(MatrN, 1)<>"[" : MatrN = "[" + MatrN : EndIf
                        If Right(MatrN, 1)<>"]" : MatrN = MatrN + "]" : EndIf
                        
                        If MatrN2<>"" And MatrN<>MatrN2
                            MatrN2 = ""
                            i = i-1 ;one line back
                            Goto NextMatrN
                        EndIf
                        MatrN2 = MatrN
                        st1 = Trim(Mid(riga$, par1 + 1, par2-par1-1)) + ","
                        r1 = Val(StringField(st1, 1, ","))
                        c1 = Val(StringField(st1, 2, ","))
                        
                        If params = "" ;only first time
                            params = MatrN + ";" + Str(r1) + ";" + Str(c1)
                        EndIf
 
                        k = 1
                        Repeat ;elaborate all the rows with DimX
                            k = k + 1
                            elem = Trim(StringField(riga$, k, ";"))
                            vl = Trim(StringField(elem, 2, "="))
                            If vl<>"" : params = params + ";" + vl : EndIf;assemble parameter for SetStrMatrix
                        Until elem = ""
                        
                        i = i + 1 ;repeat parsing of riga$ (as above)
                        riga$ = Trim(StringField(sIn, i, #CRLF$))
                        If Left(riga$, 1) = #CRLF$ Or Left(riga$, 1) = #LF$
                            riga$ = Mid(riga$, 2)
                        EndIf
                        
                        pos = FindString(riga$, "=", 1)
                        If pos = 0
                            pos = FindString(riga$, "(", 1) ;se Integrate(...)
                        EndIf
                        fin = FindString(riga$ + "'", "'", 1)
                        riga$ = Left(riga$, fin-1)
                        
                    Until LCase(Trim(Left(riga$, 4)))<>"dimx"
NextMatrN:
                    ret = SetStrMatrix(params, 0, 1)

                    ErrNum = GetE_Error()
                    If ErrNum <> #ANM_MTX_MatrOK
                        ErrCnt = ErrCnt + 1 ;test error
                        result = "===> ERROR n. = " + Str(ErrNum) + ": " + PeekS(GetE_ErrDescr(ErrNum))

                        anmResStr = anmResStr + "Ln " + Str(i) + ": " + "Expression = " + param + ":" + #CRLF$
                        anmResStr = anmResStr + ResultStr + result + #CRLF$ + #CRLF$
                        
                    EndIf
;- INTEGRATE
                Case "integrate", "integratef"              ; integrate expression
;+
;Integrate(-10; 1000; 200; trap; x) = 1 + 12*x - x*sin(x) + 2*x^2
;IntegrateF = iFn1.txt [iFn2.txt]
                    FileF = Space(20)
                    
                    If KeyW = "integratef"
                        st1 = Trim(Mid(riga$, pos + 1))
                        ;params = LCase(Trim(Mid(riga$, par1+1, par2-par1-1)+";"))
                        InpF = StringField(st1 + " ", 1, " ")
                        OutF = StringField(st1 + " ", 2, " ")
                        OutF = TrimQPar(OutF)
                        
                        If OutF<>"" : FileF = "=>(" + st1 + ")" : EndIf
                        riga$ = FileInpOut(inpF, "fileinp", "")
                        pos = FindString(riga$, "=", 1)
                        par1 = FindString(riga$, "(", 1)
                        par2 = FindString(riga$, ")", par1)
                        
                    EndIf

                    iFunct = Trim(Mid(riga$, pos + 1))
                    params = LCase(Trim(Mid(riga$, par1 + 1, par2-par1-1) + ";"))
                    x0 = ValD(StringField(params, 1, ";"))
                    xN = ValD(StringField(params, 2, ";"))
                    sN1 = ValD(StringField(params, 3, ";"))
                    Method = Trim(StringField(params, 4, ";"))
                    If Method = "trap" : met = 1 : Else : met = 0 : EndIf
                    
                    sVar = Trim(StringField(params, 5, ";"))

                    OldDebugF = SetDebugF(0)
                    OldErrMsgF = SetErrorMsgsF(0)
                    
                    ret = Integrate(iFunct, x0, xN, sN1, met, sVar, @dRet)
                    
                    SetDebugF(OldDebugF)
                    SetErrorMsgsF(OldErrMsgF)
                    
                    ErrNum = GetE_Error()
                    If ErrNum <> #ANM_MTX_MatrOK
                        ErrCnt = ErrCnt + 1 ;test error
                        result = "===> ERROR n. = " + Str(ErrNum) + ": " + PeekS(GetE_ErrDescr(ErrNum))
                        
                    Else
                        result = outStr(#nnIsNumber) + StrD(dRet, decimals)
                    EndIf
                    
                    If FileF<>Space(20) : FileInpOut(outF, "fileout", result) : EndIf
                    
                    If noLnExpF = 0 Or ErrNum <> #ANM_MTX_MatrOK
                        anmResStr = anmResStr + "Ln " + Str(i) + ": " + "iFunction = " + iFunct + ": " + FileF + #CRLF$
                    EndIf
                    anmResStr = anmResStr + " Integral iFunction(" + Str(x0) + "," + Str(xN) + ") => " + result + #CRLF$ + #CRLF$

                    ;SetGadgetText(#txtOutp, anmResStr)
                
;- STOEXPR
                                    ;StoExpr([mEi]) = [mE]I 'calculate Inverse of [mE] and store result in [mEi]
                Case "stoexpr"                              ; solve expression and store reslut 1. StoExpr(xx) or StoExpr([mA]) or
                    result = ""
;+ ;2. StoExpr([mA], RelPath, filename) = [mE]I
                    st1 = Trim(Mid(riga$, pos + 1)) ;1. expression or 2. matrexpr
                    resN = Trim(Mid(riga$, par1 + 1, par2-par1-1)) ;1. varName or 2. relpath, filename
                    FileF = Space(20)
                    
                   If Trim(StringField(resN, 2, ";"))<>"" ;2° field = FileOut
                        ;StoExpr([mEi], FileOut, Matr_mEi.txt) = [mE]I
                        
                        st2 = resN + ";"
                        resN = Trim(StringField(st2, 1, ";"))
                        action = Trim(StringField(st2, 2, ";"))
                        fName = Trim(StringField(st2, 3, ";"));
                        FileF = "(=>" + action + " " + fName + ")"
                        
                    EndIf
                    
                    param = ReplaceString(st1, "'", "")
                    ret = e_eval(param, @dRet, 1)
                    ErrNum = GetE_Error()
                    If ErrNum = #ANM_MTX_MatrOK ;test error
                        If GetResultType() = #nnIsMatrix ;also if ret = #nnIsNumber
                            mMemID = FindMatrix(Str(dRet), (#SrcMatrPtr + #RetMatrPtr), @r1, @c1) ;get result matrix stored in DLL
                            ;"Matr = [mC]; 3; 3; 1; 1; 4; 0; 3; 1; 4; 3; (3+2)"
                            If mMemID = 0
                                ; e_error = #ANM_EVAL_NotFound
                                ErrNum = GetE_Error()
                                ErrCnt = ErrCnt + 1
                                result = "===> ERROR n. = " + Str(ErrNum) + ": " + PeekS(GetE_ErrDescr(ErrNum))
                            Else
                            
                                addr = mMemID
                                
                                If Left(resN, 1)<>"[" : resN = "[" + resN : EndIf
                                If Right(resN, 1)<>"]" : resN = resN + "]" : EndIf
                                
                                resN = resN + "; " + Str(r1) + "; " + Str(c1) + ";"
                                
                                For r = 0 To r1-1 ;assemble matrix definition string
                                    For c = 0 To c1-1
                                        st1 = StrD(PeekD(addr))
                                        resN = resN + Trim0s(st1) + "; "
                                        addr = addr + 8
                                    Next c
                                Next r
    
                                ret = SetStrMatrix(resN, 0, 1) ;store result
                                If c1 <= 1
                                    result = outStr(#nnIsMatrix) + result ; Vector
                                Else
                                    result = outStr(#nnIsMatrix+1) + result ; Matrix
                                EndIf
                                result = result + resN ;get result string
                                
                                If FileF<>Space(20) : FileInpOut(fName, action, resN) : EndIf
                            EndIf
                        Else
                            
                            st1 = Trim0s(StrD(dRet, decimals))
                            ret = SetVarFunct(resN, st1, 0)
                            result = "Number " + resN + " = " + StrD(dRet, decimals) ;show result
                        
                        EndIf
                    Else
                        ErrCnt = ErrCnt + 1
                        result = "===> ERROR n. = " + Str(ErrNum) + ": " + PeekS(GetE_ErrDescr(ErrNum))
                    EndIf
                    
                    If noLnExpF = 0 Or ErrNum <> #ANM_MTX_MatrOK
                        anmResStr = anmResStr + "Ln " + Str(i) + ": " + "Expression = " + param + ": " + FileF + #CRLF$
                    EndIf
                    anmResStr = anmResStr + StoreRes + result + #CRLF$ + #CRLF$

;- EXPR, EXPRF, HEX, BIN
                Case "expr", "exprf", "hex", "bin"          ; Syntax: Expr = expression or Expr = FileIn nomefile
;+
;                   MessageRequester(keyw,param)
                    ;Debug riga$
                    st1 = Trim(Mid(riga$, pos + 1))
                    param = ReplaceString(st1, "'", "")
                    FileF = Space(20)
                    
                    If KeyW = "exprf"
                        ;Debug st1
                        InpF = StringField(param + " ", 1, " ")
                        OutF = StringField(param + " ", 2, " ")
                        OutF = TrimQPar(OutF)
                        
                        If OutF<>"" : FileF = "=>(" + param + ")" : EndIf
                        param = FileInpOut(inpF, "fileinp", "")
                        
                        If param = "" Or ExitCode <> #ANM_EVAL_NO_ERROR
                            
                            ErrCnt = ErrCnt + 1
                            result = "===> ERROR n. = " + Str(ExitCode) + ": " + GetStErrDescr(ExitCode)
                            
                        Else
                            k = FindString(param, "=", 1)
                            If k>0
                                param = Trim(Mid(param, k + 1))
                            EndIf
                            param = LCase(Trim(StringField(param + "'", 1, "'"))) ;remove comments
                        EndIf
                    EndIf
                
                    If param<>"" And ExitCode = #ANM_EVAL_NO_ERROR
                    
                        ; MessageRequester(keyw,param)
                        ret = e_eval(param, @dRet, 1)
                        
                        ErrNum = GetE_Error()

                        If ErrNum = #ANM_EVAL_NO_ERROR ;test error
                            If GetResultType() = #nnIsMatrix ;also if ret = #nnIsNumber
                                mMemID = FindMatrix(Str(dRet), (#SrcMatrPtr + #RetMatrPtr), @r1, @c1) ;get result matrix stored in DLL
                                If mMemID = 0
                                    ; e_error = #ANM_EVAL_NotFound
                                    ErrNum = GetE_Error()
                                    ErrCnt = ErrCnt + 1
                                    result = "===> ERROR n. = " + Str(ErrNum) + ": " + PeekS(GetE_ErrDescr(ErrNum))
                                    
                                Else
                                    ret = aPrint(mMemID, r1, c1, "String", NumFrmt, "", "")
                                    result = PeekS(ret) ;get result string
        
                                    ;ClearMatrixList(dRet) non serve
                                    
                                    If c1 <= 1
                                        result = outStr(#nnIsMatrix) + result
                                    Else
                                        result = outStr(#nnIsMatrix+1) + result
                                    EndIf
                                EndIf
                            Else
                            
                                If keyw = "hex"
                                    result = outStr(#nnIsNumber) + " &" + Hex(dRet) ;show result
                                    
                                ElseIf keyw = "bin"
                                
                                    result = outStr(#nnIsNumber) + " !" + Bin(dRet) ;show result
                                Else
                                    result = outStr(#nnIsNumber) + " " + StrD(dRet, decimals) ;show result
                                EndIf
                            EndIf
                        Else
                            ErrCnt = ErrCnt + 1
                            result = "===> ERROR n. = " + Str(ErrNum) + ": " + PeekS(GetE_ErrDescr(ErrNum))
                        EndIf
                    
                    EndIf
                
                    If FileF<>Space(20) : FileInpOut(outF, "fileout", result) : EndIf
                    
                    If noLnExpF = 0 Or ErrNum <> #ANM_MTX_MatrOK
                        anmResStr = anmResStr + "Ln " + Str(i) + ": " + UCase(keyw) + " = " + param + ": " + FileF + #CRLF$
                    EndIf
                    anmResStr = anmResStr + ResultStr + result + #CRLF$ + #CRLF$

;- SYMBDIFF
                Case "sdiff", "sdifff"                      ; Syntax: Derivate = FileIn (nomefile)
                                                            ; DerivateF Polyn.txt Polyn2.txt
;+
                    FileF = Space(20)
                    
                    If KeyW = "sdifff"
                        st1 = Trim(Mid(riga$, pos + 1))
                    
                        InpF = StringField(st1 + " ", 1, " ")
                        OutF = StringField(st1 + " ", 2, " ")
                        OutF = TrimQPar(OutF)
                        If OutF <> "" : FileF = "=>(" + param + ")" : EndIf
                        riga$ = FileInpOut(inpF, "fileinp", "")
                        pos = FindString(riga$, "=", 1)
                        par1 =FindString(riga$, "(", 1)
                        par2 =FindString(riga$, ")", par1)
                        
                    EndIf
                    
                    st1 = Trim(Mid(riga$, pos + 1))
                    param = ReplaceString(st1, "'", "")
                    sVar = Trim(Mid(riga$, par1 + 1, par2-par1-1)) ;1. varName or 2. relpath, filename

                    ln = 1000
                    sRes$ = Space(ln)
                    ret = e_diff(param, sVar, @sRes$, ln)
                    If ret > ln
                        ln = ret
                        sRes$ = Space(ln)
                        ret = e_diff(param, sVar, @sRes$, ln)
                    EndIf
                    ;MessageRequester("", sRes)
                    result = sRes$;PeekS(ret)

                    ErrNum = GetE_Error()
                    If ErrNum <> #ANM_EVAL_NO_ERROR
                        ErrCnt = ErrCnt + 1 ;test error
                        result = "===> ERROR n. = " + Str(ErrNum) + ": " + PeekS(GetE_ErrDescr(ErrNum))
                    EndIf
                    
                    If FileF<>Space(20) : FileInpOut(outF, "fileout", result) : EndIf
                    If noLnExpF = 0 Or ErrNum <> #ANM_EVAL_NO_ERROR
                        anmResStr = anmResStr + "Ln " + Str(i) + ": " + "f("+sVar+") = " + Param + ":" + #CRLF$
                    EndIf
                    anmResStr = anmResStr + "f'("+sVar+") => " + result + #CRLF$ + #CRLF$
                    ;SetGadgetText(#txtOutp, anmResStr)
;- DERIVATE
                Case "derivate", "derivatef"                ; Syntax: Derivate = FileIn (nomefile)
                    ;DerivateF Polyn.txt Polyn2.txt
;+
                    st1 = Trim(Mid(riga$, pos + 1))
                    param = ReplaceString(st1, "'", "")
                    FileF = Space(20)
                    
                    If KeyW = "derivatef"
                        InpF = StringField(param + " ", 1, " ")
                        OutF = StringField(param + " ", 2, " ")
                        OutF = TrimQPar(OutF)
                        If OutF<>"" : FileF = "=>(" + param + ")" : EndIf
                        param = FileInpOut(inpF, "fileinp", "")
                        
                    EndIf
                    Polyn = param
                    ret = lPoly_dydx(param, VarPolyn)
                    result = PeekS(ret)

                    ErrNum = GetE_Error()
                    If ErrNum <> #ANM_MTX_MatrOK
                        ErrCnt = ErrCnt + 1 ;test error
                        result = "===> ERROR n. = " + Str(ErrNum) + ": " + PeekS(GetE_ErrDescr(ErrNum))
                    EndIf
                    
                    If FileF<>Space(20) : FileInpOut(outF, "fileout", result) : EndIf
                    If noLnExpF = 0 Or ErrNum<>#ANM_MTX_MatrOK
                        anmResStr = anmResStr + "Ln " + Str(i) + ": " + "Polyn = " + Polyn + ":" + #CRLF$
                    EndIf
                    anmResStr = anmResStr + " Derivate of Polyn => " + result + #CRLF$ + #CRLF$

;- MATR, VECT
                                
                Case "matr", "matrf", "vect", "vectf"       ; store matrix/vector in memory
 ;+
                    param = Trim(Mid(riga$, pos + 1))
                    FileF = Space(20)

                   If KeyW = "matrf" Or keyw = "vectf"
                        
                        InpF = StringField(param + " ", 1, " ")
                        param = FileInpOut(inpF, "fileinp", "")
                        
                    EndIf
                    
                    param = ReplaceString(param, "'", "")
                    ret = SetStrMatrix(param, 0, 1)
                    
                    ErrNum = GetE_Error()
                    If ErrNum <> #ANM_MTX_MatrOK
                        ErrCnt = ErrCnt + 1 ;test error
                        result = "===> ERROR n. = " + Str(ErrNum) + ": " + PeekS(GetE_ErrDescr(ErrNum))

                        anmResStr = anmResStr + "Ln " + Str(i) + ": " + "Expression = " + param + ": " + FileF + #CRLF$
                        anmResStr = anmResStr + ResultStr + result + #CRLF$ + #CRLF$
                        
                    EndIf
;- FUNCT

                Case "funct", "functf"                      ; define a function
;+
                    st1 = Trim(Mid(riga$, pos + 1))
                    param = ReplaceString(st1, "'", "")

                    FileF = Space(20)
                    
                    If KeyW = "functf"
                        ;FunctF = Func3 Funct3.txt
                        fName = StringField(param + " ", 1, " ")
                        InpF = StringField(param + " ", 2, " ")
                        param = FileInpOut(inpF, "fileinp", "")

                    Else
                        ;Funct = Func3 ; expr...
                        fName = Trim(StringField(param + ";", 1, ";"))
                        param = Trim(StringField(param + ";", 2, ";"))
                    EndIf

                    If param = "" Or ExitCode <> #ANM_EVAL_NO_ERROR
                        ErrCnt = ErrCnt + 1
                        result = "===> ERROR n. = " + Str(ExitCode) + ": " + GetStErrDescr(ExitCode)

                    Else
                        ret = SetVarFunct(fName, param, 1)
                    
                    EndIf
                    
;- PAUSE
                Case "pause"
                        ; ???
                        
                Case "varpolyn"                             ; define a polynomium
                    VarPolyn = Trim(Mid(riga$, pos+1))

                Case "aelemorderset"                        ; set 
                    num = Val(Trim(Mid(riga$, pos+1)))
                    ret = aElemOrderSet(num)
                    
                Case "aelemorderex"                         ; 
                    Dim a.d(1, 1) ;each dimension ranges from 0 To 1, total 2x2
                    a(0,1)=2: a(1,0)=1 ;(<>2)
                    ret = aElemOrderEx(@a(0,0), 0)
                    If ret = 0: st1 = "by Row": Else: st1 = "by Col": EndIf
                    If noLnExpF = 0
                        anmResStr = anmResStr +"Ln "+Str(i)+": "+ "aElemOrderEx = " + st1 + #CRLF$ + #CRLF$
                    EndIf

                Case "var"                                  ; set variable in memory
                    st1 = Trim(Mid(riga$, pos+1)) + ";"
                    fName = Trim(StringField(st1, 1, ";"))
                    param = Trim(StringField(st1, 2, ";"))
                    ret = SetVarFunct(fName, param, 0)
                                    
                Case "debug"                                ; enable debug
                    num = Val(Trim(Mid(riga$, pos+1)))
                    ret = SetDebugF(num)

                Case "errormsgs"                            ; enable store of errormessages
                    num = Val(Trim(Mid(riga$, pos+1)))
                    ret = SetErrorMsgsF(num)

                Default
                    #MODULE_EVAL = 30
                    SetE_error(#ANM_EVAL_UndefCommand)
                    ErrNum = #ANM_EVAL_UndefCommand ; GetE_Error()

                    ErrCnt = ErrCnt + 1 ;test error
                    result = "===> ERROR n. = " + Str(ErrNum) + ": " + PeekS(GetE_ErrDescr(ErrNum))

                    anmResStr = anmResStr + "Ln " + Str(i) + ": " + "Expression = " + param + ":" + #CRLF$
                    anmResStr = anmResStr + ResultStr + result + #CRLF$ + #CRLF$
                        
                    ;no action

            EndSelect
                    
        EndIf
        
    Next i
    
    
    ret = SetProgressBar(0, 1, 0)
    
    While Right(anmResStr, 2) = #CRLF$
        anmResStr = Left(anmResStr, Len(anmResStr)-2)
    Wend
    
    num = Len(anmResStr)*(1+#PB_Compiler_Unicode)+(1+#PB_Compiler_Unicode)
    If num > 0
        addr = AllocateMemory(num)
        PokeS(addr, anmResStr)
    Else
        addr = 0
    EndIf
    
    PokeL(*sOutLen, num)
    PokeL(*sPtr, addr)
            
    ProcedureReturn Cmds * 1000 + ErrCnt ;es 165 lines and 3 errors = 164003

EndProcedure


; IDE Options = PureBasic 4.31 (Windows - x86)
; ExecutableFormat = Shared Dll
; CursorPosition = 386
; FirstLine = 367
; Folding = ---
; EnableUnicode
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableExeConstant