﻿; PROJECT: aNuMet (Array of Numerical Methods), by Carlo Somigliana
; visit the web site www.semelinanno.com for more info and programs
; you can also email me at: somic@libero.it

; DESCRIPTION: this is a simple And poorly written set of routines serving the file anmEvParser


; LICENSE: this code is released FREEWARE. You are free to use and modify it at your wish and risk.
; No further info and support is provided nor garranteed.
; If you do something good from it, pls let me know
;---------------------------------------------------------------------------------
EnableExplicit

#lSt = 20

#loadInputTXT0      = 0
#LoadLog1           = 1
#LoadCmds2          = 2

;#writeShowMemTXT2 = 2
#loadSynSmp3        = 3
#loadOpenFile4      = 4
#writeShowCmds5     = 5
#loadCmdLn6         = 6
#writeCmdLn7        = 7
#WriteFile8         = 8

#txtNumFrmt         = 4; 4 decimals
#pBar               = 0

;;anmEval Error codes
;;-------------------
#TrialModeError     = -1
#FileOpenError      = -2
#FileWriteError     = -3
#OperCancelledError = -4
#InvalidParameter   = -5
#InstanceQuitOK     = -6
#APIError           = -7
#WindowNotFound     = -8
#ChildWndNotFound   = -9

#EVAL_NO_ERROR      = -1
#aNuMetDLL$         = "aNuMet.dll"

IncludeFile "anmFuncts.pbi"


Global MaxKWs.l = 25    ; max nr of keywords
Global Dim srchStr.s(MaxKWs): Global Dim StrAct.b(MaxKWs): Global Dim gTTmsg.s(MaxKWs)
Global Dim KWList.s(MaxKWs); of string;

Global gStrActIdx.l;KWList;

Global cnt.l, DbgFName.s
  
Global sRes$, anmResStr.s, LnsStr.s, CmdLine.s, lastCmdLn.s, INIFileN.s, gAct_Expr.l, anmXNppWnd.s

Global anmXNppF.l, NumFrmt.s, ret.l, RegType1.l, CurDir.s, ExitCode.l, batchRunF.b, HeadStr.s

CompilerIf Defined(pbDebug, #PB_Constant)=0
    #pbDebug = 0
    ;Debug "Constant 'PureConstant' is already declared"
CompilerEndIf

Global InpFN.s, OutpFN.s, LineNrs.l, decimals.l, splPath.s, logF.b, logFileN.s, AutoF.b, repF.b
Global noLnExpF.b, noLnExpFs.s, DontConfExpF.b, noTextF.b, noTextFs.s
Global delF.b, SendMsgCmdLineF.b, FirstRunF.b=1, noHF.b, getFromClpF.b, clpText.s, clpTextp.s, outClpb.s, UseInpFNF.b, UseOutpFNF.b, pBarF.b
Global SaveToClpBF.b, lnsF.b, splF.b, tsrvF.b, quitF.b, rsetF.b, ShowMemF.b, ShowLogF.b, AppendF.b
Global SelText.s, wSetupF.b, getFromSelTextF.b, ShowFlagsF.b, ShowCmdsF.b, LnCorr.l, lnCorrF.b, ShowAboutF.b
Global pos1.l, pos2.l, hWnd.l

    
Declare.s ReadFileN(FileId.l)
Declare.l ShowSyntax2(ConsoleF.b = 0, ShortHeaderF.b = 0)
Declare.s GetStErrDescr(ErrNum.l);get error description
Declare.s Header(HeadF.b = 0, noHeaderF.b = 0)
Declare.l anmDbg(txt.s, LogF.l) ;

IncludeFile "anmEvParser.pb"


Procedure.l ShowAbout(ConsoleF.b = 0)
Protected st.s, st1.s, st2.s, ln1.l
Protected ln.l, sList.s

    st = Header(0, 0)
        
    st = st + #CRLF$
                
    ShowString(st, ConsoleF)

    ;MessageRequester("Math Evaluator About", st)

EndProcedure

Procedure.s lGetErrInfo(EndF.b)
Protected st.s

    st = #CRLF$ + "FOR NB_SOMI ONLY"
    st = st + #CRLF$ + #CRLF$ + "Error Descr: " + ErrorMessage()
    st = st + #CRLF$ + "Error Line: " + Str(ErrorLine())
    st = st + #CRLF$ + "Error File: " + ErrorFile()
    
    sRes$ = st
    
    MessageRequester("Math Evaluator", st)
    
    If EndF<>0
        ProcedureReturn
    EndIf
    
    ProcedureReturn sRes$
    
EndProcedure
    
Procedure.s FileInpOut(param.s, action.s, matr.s = "")
Protected sRet$, fn.s, p1.l, s1.s, fn1.s, relPath.s, lCurDir.s, fnr.l
Static msgF.l

    sRet$ = ""
    fn = param;to keep u/lcases in filename
    relPath = GetPathPart(fn)
    lCurDir = DllDir+"anmXNpp\"
    
    ;fn = MergePaths(fn, lCurDir)
    fn = PathFileMerge(lCurDir,fn)
    param = LCase(param)
    Action = LCase(action)
    
    If Action = "fileout" ;disabled in TRIAl MODE
        If RegType1>1
            If Mid(fn, 2, 1)<>":" ;C:\...
                fn = CurDir + fn
                
            EndIf
                  
            fnr = CreateFile(0, fn)
            If fnr
                WriteString(0, matr)
                FlushFileBuffers(0)
                CloseFile(0)
            Else
                ;If batchRunF = 0
                    ret = MessageRequester("Math Evaluator", "Error 1: can't write the file." + #CRLF$ + fn, 0)
                ;EndIf
            EndIf
        Else
        EndIf
        
    Else                                                    ; filein
                
            If Mid(fn, 2, 1)<>":" ;C:\... ;RelPath
                fn = CurDir + fn
                                
            EndIf
    
            fnr = ReadFile(0, fn)
            If fnr
                While Eof(0) = 0
                    s1 = ReadString(0) ; loop as long the 'end of file' isn't reached
                    If Left(Trim(s1), 1)<>"'"
                        sRet$ = sRet$ + s1 ; display line by line in the debug window
                    EndIf
                Wend
                CloseFile(0) ; close the previously opened file
            Else
                ExitCode = #FileOpenError; -1
                ;If batchRunF = 0
                    MessageRequester("Math Evaluator", "Error 3: Couldn't open the file!" + #CRLF$ + fn)
                ;EndIf
            EndIf
    EndIf
    
    ProcedureReturn sRet$

EndProcedure

ProcedureDLL.l GetEvalResult(*sEvalResult, EvResLen.l); get Result of Evaluation
;; store string in sEvalResult and return length of string
;; Parameters: *sEvalReslut pointer to a string buffer returning result
;;             EvResLen length in characters of string buffer
;;             If EvResLen is less then needed, result is truncated. NO ERROR is set
;; if EvResLen = 0 procedure return characters required to store result string only
Protected Ln.l

    ln = Len(anmResStr)

    If EvResLen = 0
        ProcedureReturn ln
        
    EndIf

    EvResLen = MemoryStringLength(*sEvalResult)
    
    If EvResLen < ln
        ln = EvResLen
    EndIf
    
    PokeS(*sEvalResult, anmResStr, ln)
     
    ProcedureReturn Ln

EndProcedure

ProcedureDLL.s GetStErrDescr(ErrNum.l)                      ; get error description

Define k.l = 10

Dim ErrStr.s(20)

    ErrStr(#TrialModeError + k)     = "Trial Mode Error"
    ErrStr(#FileOpenError + k)      = "File Open Error (not found?)"
    ErrStr(#FileWriteError + k)     = "File Write Error (already in use?)"
    ErrStr(#OperCancelledError + k) = "Operation cancelled by user"
    ErrStr(#InvalidParameter + k)   = "Invalid Parameter."
    ErrStr(#InstanceQuitOK + k)     = "Instance Quit OK"
    ErrStr(#APIError + k)           = "API Error"
    ErrStr(#WindowNotFound + k)     = "Window not Found"
    ErrStr(#ChildWndNotFound + k)   = "Child Window Not Found"
    
    sRes$ = ErrStr(ErrNum + k)
    
    ProcedureReturn sRes$
    
EndProcedure

Procedure.s Header(HeadF.b = 0, noHeaderF.b = 0)            ; for the About box
Protected st.s, car.s{1}, AnUc.s

    ;sRes$ = ""
    st = ""
    If noHeaderF : ProcedureReturn st : EndIf
    
    If HeadF : car = "'" : EndIf

    If #PB_Compiler_Unicode
        AnUc = "Unicode"
    Else
        AnUc = "Ansi"
    EndIf
    #PB_Compiler_Version
    st = car + "Plugin name: anmXNpp.dll (Array of Numerical Methods for Notepad++)" + #CRLF$
    ; st = st + car + "Version: 0.0.4.6 - Built: " + Str(#PB_Editor_BuildCount) + ". (" + AnUc +" version)" + #CRLF$
    st = st + car + "By: Carlo Somigliana, email: somic@libero.it, site: www.semelinanno.com" + #CRLF$
    st = st + car + "Original Web Page: www.semelinanno.com\downloads\anmxnpp\anmXNpp_Page.html"+ #CRLF$
    If HeadF : 
    st = st + car + "---------------------------------------------------------------------------" + #CRLF$
        ;sRes$ = st
        ProcedureReturn st
    EndIf

    st = st + car + "---------------------------------------------------------------------------" + #CRLF$
    st = st + car + "First thanks to Scintilla developer(s) and Donho for Notepad++, without "+#CRLF$
    st = st + car + "them this plugin wouldn't exist. :-)"+ #CRLF$+ #CRLF$
    st = st + car + "anmXNpp is a Math Evaluator of math formulas and commands for Notepad++" + #CRLF$
    st = st + car + "It gives to Npp powerfull math capabilities to calculate and plot " + #CRLF$ 
    st = st + car + "expressions, functions, polynomials, integrals, matrices, derivatives." + #CRLF$
    st = st + car + "It incorporates the math library aNuMet (Array of Numerical Methods) for "+#CRLF$
    st = st + car + "numerical calculations, implementing 40+ math and matrix functions." + #CRLF$+#CRLF$
    st = st + car + "Written in PureBasic 4.30 (x86) - (see www.purebasic.com)." + #CRLF$
    st = st + car + "This program is FREEWARE. Necessary Disclaimer: use at your own risk." + #CRLF$+ #CRLF$
    st = st + car + "Pls report any bugs and/or comments to me. Fixes will be ...a.s.a.p.... :-}"+#CRLF$
    st = st + car + "If you are courious, visit the website: www.semelinanno.com for more info." + #CRLF$
    st = st + car + "---------------------------------------------------------------------------" + #CRLF$

    sRes$ = st
    
    ProcedureReturn sRes$
    
EndProcedure

; 
ProcedureDLL.l LoadSaveFile(act.b)                          ; general purpose routine to read/write files

Protected FileN.s, ln.l, *MemID, bytes.l, lanmResStr.s, ret.l, st.s, fnr.l, lCurD.s, frmt.l

    If #PB_Compiler_Unicode
        frmt = #PB_Unicode
    Else
        frmt = #PB_Ascii
    EndIf

    If act = #loadCmdLn6                                    ; load file from command line
        FileN = InpFN
        If ReadFile(0, FileN)<>0
            sRes$ = ReadFileN(0)
                     
        Else
            ret = MessageRequester("Math Evaluator", "Error 4: can't read the file" + #CRLF$ + "file: " + fileN, 0)
            
            ExitCode = #FileOpenError; -2
        EndIf
        
    ElseIf act = #loadLog1                                  ; load Log file (if any)
        FileN = logFileN
        
        If ReadFile(0, FileN)<>0
            sRes$ = ReadFileN(0)
                        
        Else   
            ret = MessageRequester("Math Evaluator", "Error 7: can't read the file" + #CRLF$ + "file: " + fileN, 0)
            ExitCode = #FileOpenError; -2
            
        EndIf
        
    ElseIf act = #LoadCmds2 
        lCurD = GetPathPart(ProgramFilename())
         ;MessageRequester("lCurD", lCurD)
        
        CompilerIf Defined(wndcalc, #PB_Constant)
            st = ""
        Else
            st = "anmXNpp\"
        CompilerEndIf
             FileN = lCurD + st+"ShowCmds.anm"
        
        If ReadFile(0, FileN)<>0
            sRes$ = ReadFileN(0)
                        
        Else
            ret = MessageRequester("Math Evaluator", "Error 7: can't read the file" + #CRLF$ + "file: " + fileN, 0)
            ExitCode = #FileOpenError; -2
        EndIf

    ElseIf act = #writeCmdLn7                               ; Write file from command line
    
        FileN = OutpFN
        
        lanmResStr = sRes$
        
        If appendF
            fnr = OpenFile(0, FileN)
            If fnr
                ln = Lof(0)
                If ln> = 0
                    FileSeek(0, ln) ;EOF minus the EOF characters
                Else
                    FileSeek(0, ln)
                EndIf
            Else
                ret = MessageRequester("Math Evaluator", "Error 5: can't open the file" + #CRLF$ + "file: " + fileN, 0)
            
            EndIf
        Else
            fnr = CreateFile(0, FileN)
            
        EndIf
        If fnr>0
            WriteString(0, sRes$)
            ;WriteStringFormat(0, frmt )
            FlushFileBuffers(0)
            CloseFile(0)

        Else
                ret = MessageRequester("Math Evaluator", "Error 5: can't write the file" + #CRLF$ + "file: " + fileN, 0)
            
            ExitCode = #FileWriteError; -3
        EndIf

    ElseIf act = #WriteFile8                                ; load a custom file
    
        FileN = OpenFileRequester("Open File", "", "Text (*.txt)|*.txt|All files (*.*)|*.*", 0)
        
        If FileN<>""
            fnr = CreateFile(0, FileN)
            
        EndIf
        If fnr>0
            WriteString(0, sRes$)
            ;WriteStringFormat(0, frmt )
            FlushFileBuffers(0)
            CloseFile(0)
            ExitCode = #EVAL_NO_ERROR
            
        Else
                ret = MessageRequester("Math Evaluator", "Error 5: can't write the file" + #CRLF$ + "file: " + fileN, 0)
            
            ExitCode = #FileWriteError; -3
        EndIf

    ElseIf act = #loadOpenFile4                             ; load a custom file
    
        FileN = OpenFileRequester("Open File", "", "Text (*.txt)|*.txt|All files (*.*)|*.*", 0)
        sRes$ = FileN
        
        If FileN<>""
            ; nothing to do
        Else
            st = "Error 7: Operation cancelled by user."
            ret = MessageRequester("Math Evaluator", st, 0)
            
            ExitCode = #OperCancelledError; -4
        
        EndIf
            
    EndIf

    ProcedureReturn ExitCode

EndProcedure

Procedure.l ReSetCmdLnVars(SkipFN.b = 0)                    ; routine to reset flags
    
    If Not SkipFN
        InpFN = ""
        OutpFN = ""
    EndIf
    
    batchRunF = 1
    LnsStr.s = ""
    SaveToClpBF = 0
    ;getFromClpF = 0
    delF = 0
    lnsF = 0
    LnsStr = ""
    AppendF = 0
    splF = 0
    splPath = ""
    logF = 0
    logFileN = ""
    
; tsrvF = 0
; tsrF = 0
    quitF = 0
    rsetF = 0
    repF = 0
    decimals = 4
    ;btnOKF = 0
    wSetupF = 0
    CurDir = ""
    noHF = 0
    
EndProcedure

Procedure.l ParseCmdLine(eCmdLn.s = "", eCurDir.s = "")    ; routine to parse command line received as input by
                                                            ; anmEvalMain procedure
                                                            
Protected pars.l, i.l, PrgParam.s, param.s, st.s, selRow.l, oFN.s, IsDir.l, IsFile.l, pBarF
Protected txt.s

    anmDbg("Proc: "+LSet(#PB_Compiler_Procedure+"()", #LSt)+": CmdLine = '"+CmdLine+"'", #pbDebug)    
        
;   Debug CmdLine
    If Right(Trim(CmdLine), 1) <> "/" : CmdLine = CmdLine + " /" : EndIf
    
    txt = ""
    pars = CountString(CmdLine, "/")
    pBarF = 0
    noTextF = 0
    
    For i = 1 To pars;CountProgramParameters()
        PrgParam = Trim(StringField(CmdLine, i, "/")) + " /"
        param = Left(LCase(PrgParam), 2)
        txt = txt + Str(i) + ") "+param + " "
        Select param
        Case "nt"   ; no Text
            noTextF = 1
        Case "pb"   ;progressbar
                pBarF = 1
            
        Case "i "
            InpFN = Trim(StringField(Mid(PrgParam, 2), 1, "/"));i-1 because the first / is removed
            UseInpFNF = 1
            ;MessageRequester("InpFN", "")
            
        Case "o ", "a "
            oFN = Trim(StringField(Mid(PrgParam, 2), 1, "/"));i-1 because the first / is removed
            If oFN = ""

                ;use also FileSize(name$) returning size if found, -1 if file not found or -2 if it is a directory
                ret = IsFileOrPath(OutpFN, #FILE_ATTRIBUTE_GET)
                IsDir = ret & #FILE_ATTRIBUTE_DIRECTORY
                IsFile = ret & #FILE_ATTRIBUTE_NORMAL
                
                If (IsDir>0 Or IsFile = 0) And InpFN<>""
                ;If OutpFN = "" Or IsDir > 0
                    oFN = GetPathPart(InpFN) + "Result.anm"
                Else
                    oFN = OutpFN
                EndIf
            Else
                ; oFN <> OutpFN
            EndIf
            OutpFN = oFN
            UseOutpFNF = 1
            If param = "a " : 
                AppendF = 1: nohF = 1
                
            Else : 
                AppendF = 0: nohF = 0 
            EndIf
            SelRow = 0
            getFromSelTextF = 0
            getFromClpF = 0
            
        Case "sc", "sclp" ;copy result to clipboard
            SaveToClpBF = 1
             
        Case "se", "sel" ;evaluate selected text
            st = Trim(Mid(PrgParam, 5))
            SelText = st
            getFromSelTextF = 1
            getFromClpF = 0
            UseInpFNF = 0
            nohF = 1
            SelRow = i
            If FindString(LCase(SelText), "plot", 1)
                splf = FindString(LCase(SelText), "save", 1)
            EndIf

        Case "de", "del" ;delete files
            delF = 1

        Case "ln", "lns" ;es. /lns:1;2;3
            st = Trim(StringField(PrgParam, 2, ":"))
            LnsStr = ";" + Mid(st, 1, Len(st)-2) + ";"
            lnsF = 1
            appendF = 1
            nohF = 1
            getFromSelTextF = 0
            getFromClpF = 0
                        
        Case "lc" ;line correction
            st = Trim(StringField(PrgParam, 2, ":"))
            LnCorr = Val(Mid(st, 1, Len(st)-2))
            lnCorrF = 1
          
        Case "sp", "spl" ;Save Plots in path
            splF = 1
            splPath = Trim(StringField(Mid(PrgParam, FindString(PrgParam, ":", 1) + 1), 1, "/")) ;path

        Case "lo", "log" ;Save log to file
            logF = 1
            logFileN = Trim(StringField(PrgParam, 2, ":")) ;path
            logFileN = Left(logFileN, Len(logFileN)-2) ;Trim ' /'
            
        
        Case "rs", "rse" ;ReSet variables
            rsetF = 1
            ResetEqParser()
            getFromSelTextF = 0
            getFromClpF = 0
            noLnExpF = 0
            noLnExpFs = ""
            noHF = 0
            InpFN = ""
            UseInpFNF = 0
            pBarF = 0
            UseOutpFNF = 0
            OutpFN = ""
            splPath = ""
            appendF = 0
            LnCorr = 0
            lncorrF = 0
            sLog("Command       : Reset EqParser and all command variables and string", logF, logFileN)
            
        Case "re", "rep"
            repF = 1
            
;         Case "de", "dec"
;             decimals = Val(StringField(PrgParam, 2, ":"))
            
        Case "no", "noh"
            noHF = 1
            
        Case "nl", "nln"
            noLnExpF = 1
            noLnExpFs = " /nln "

        Case "sm"
            ShowMemF = 1
            
        Case "lg"
            ShowLogF = 1
            
        Case "sf"
            ShowFlagsF = 1
            
        Case "cm"
            ShowCmdsF = 1
            
        Case "w "
            wSetupF = 1
            ;MessageRequester("", Str(wSetupF))

        Case "ab";about
            ShowAboutF = 1
            
        Default
            If getFromSelTextF
                If SelRow = i-1 ;next row out of "case"
                    st = Trim(PrgParam)
                    SelText = SelText + st
                    ;Debug SelText
                    SelRow = i
                
                Else
                    If Right(SelText, 1) = "/"
                        SelText = Left(SelText, Len(SelText)-1)
                    EndIf
                    selRow = -1
                EndIf
            
            EndIf
; ; ;invalid parameter
        EndSelect
    Next i
        
    ;use also FileSize(name$) returning size if found, -1 if file not found or -2 if it is a directory
     ret = IsFileOrPath(OutpFN, #FILE_ATTRIBUTE_GET, #FILENAME_IS_VALID)
    IsDir = ret & #FILE_ATTRIBUTE_DIRECTORY
    IsFile = ret & #FILE_ATTRIBUTE_NORMAL
    
    If (IsDir>0 Or IsFile = 0) And InpFN<>""
        OutpFN = GetPathPart(InpFN) + "Result.anm"
    EndIf

    anmDbg("Proc: "+LSet(#PB_Compiler_Procedure+"()", #LSt)+": Params  = '"+txt+"'", #pbDebug)

EndProcedure

Procedure.s ReadFileN(FileId.l)                             ; general purpose routine to read text files and return a string
                
Protected ln.l, *MemID, bytes.l, lanmResStr.s, BOM.l, BOMMsg.s, st.s
    
    BOM = ReadStringFormat(FileId)
    
    BOMMsg=""
    
    Select BOM
    Case #PB_Ascii    ; No BOM detected. This usually means a plain text file.
        ;MessageRequester("Math Evaluator", "ASCII")
    Case #PB_UTF8     ; UTF-8 BOM detected.
        ;MessageRequester("Math Evaluator", "UTF8")
    Case #PB_Unicode  ; UTF-16 (little endian) BOM detected.
        ;MessageRequester("Math Evaluator", "Unicode")
    
    Case #PB_UTF16BE;: 
        BOMMsg="UTF-16 (big endian) BOM detected."
    Case #PB_UTF32  ;: 
        BOMMsg="UTF-32 (little endian) BOM detected."
    Case #PB_UTF32BE;: 
        BOMMsg="UTF-32 (big endian) BOM detected."
        
    EndSelect

    If BOMMsg <> ""
        st = BOMMsg + #CRLF$ + "Unable to convert the file. Try to save it in ASCII, UTF8 or Unicode format."
        MessageRequester("Math Evaluator", st)
        ProcedureReturn ""
    EndIf
    
    lanmResStr = ""
    While Not Eof(FileID)
        lanmResStr = lanmResStr + ReadString(FileId, BOM) + #CRLF$
    Wend
    
    CloseFile(FileID)
    
    ;MessageRequester("ReadFileN", lanmResStr)
    ProcedureReturn lanmResStr
EndProcedure

Procedure.l ShowMem(ConsoleF.b = 0)                         ; makeup and show a string containing Memory objects
Protected st.s, st1.s, st2.s, ln1.l
Protected ln.l, sList.s

    st = Header(1, 0)
        
    st = st + #CRLF$
    
    st = "Show Memory:" + #CRLF$ + #CRLF$
    
    st = st + "Variables:" + #CRLF$
    ln = GetVarFuncListLen("vars")
    sList = Space(1000)
    ln = GetVarFuncList(@sList, ln, "vars")
    sList = ReplaceString(sList, ";", "; ")
    sList = ReplaceString(sList, "=", " = ")
    st = st + " " + sList + #CRLF$ + #CRLF$
    
    st = st + "Functions:" + #CRLF$
    ln = GetVarFuncListLen("funct")
    sList = Space(ln)
    ln = GetVarFuncList(@sList, ln, "funct")
    sList = ReplaceString(sList, ";", "; ")
    sList = ReplaceString(sList, "=", " = ")
    st = st + " " + sList + #CRLF$ + #CRLF$
    
    ln = GetMatrixList(1)
    sList = PeekS(ln)
    st = st + sList + #CRLF$
            
    ShowString(st, ConsoleF)

EndProcedure

Procedure.l ShowLog(ConsoleF.b = 0)                         ; makeup and show a string containing Log
Protected st.s, st1.s, st2.s, ln1.l

    LoadSaveFile(#LoadLog1)
    
    st = "Log File:" + #CRLF$
    st = "FileName:" + logFileN + #CRLF$ + #CRLF$
    
    st = st + sRes$ + #CRLF$
                
    ShowString(st, ConsoleF)

EndProcedure

Procedure.l ShowFuncs(ConsoleF.b = 0)                       ; makeup and show a string containing the list of supported 
                                                              ; operators and Functions
Protected st.s, st1.s, st2.s, ln1.l

    st = Space(2000)
    GetDiff_OperAndFuncs(@st)
       
    st = st + #CRLF$
                
    ShowString(st, ConsoleF)

EndProcedure

Procedure.l ShowCmds(ConsoleF.b = 0)                        ; makeup and show a string containing the list of supported 
                                                             ; keywords and commands
Protected st.s, st1.s, st2.s, ln1.l

     LoadSaveFile(#LoadCmds2)

    st = sRes$ + #CRLF$
                
    ShowString(st, ConsoleF)

EndProcedure

Procedure.l ShowErrMsgs(ConsoleF.b = 0)                     ; makeup and show a string containing all the error messages 
                                                             ; stored in memory
Protected sOut.s, sOutLen.l, st.s

    sOutLen = GetErrorMsgs(@sOut, 0)
    
    If sOutLen > 10000
        st = "Debug Log is " + Str(sOutLen) + " characters long and may take time to be loaded." + #CRLF$ + #CRLF$
        st = st + "Press Yes to view it" + #CRLF$
        st = st + "      No to copy in clipboard"+ #CRLF$
        st = st + "      Cancel to exit"+ #CRLF$
        
        ret = MessageRequester("Math Evaluator", st, #PB_MessageRequester_YesNoCancel)
        If ret = #PB_MessageRequester_Cancel
            ProcedureReturn 0
        EndIf
    Else
        ret = #PB_MessageRequester_Yes
    EndIf

    If ret = #PB_MessageRequester_Yes
        sOut = Space(sOutLen)
        GetErrorMsgs(@sOut, sOutLen)
        
        sOut = sOut + #CRLF$
                        
        ShowString(sOut, ConsoleF)
    ElseIf ret = #PB_MessageRequester_No
        sOut = Space(sOutLen)
        GetDebugLog(@sOut, sOutLen)
        ClearClipboard()
        SetClipboardText(sOut)
        
    EndIf

EndProcedure

Procedure.l ShowDebugError(ConsoleF.b = 0, D0E1.b=0)
Protected sOut.s, sOutLen.l, st.s, s1.s

    If D0E1 = 0
        sOutLen = GetDebugLog(0, 0)
    Else
        sOutLen = GetErrorMsgs(0, 0)
    EndIf
    
    If sOutLen > 100000
        st = "Text is " + Str(sOutLen) + " characters long and may take time to be loaded." + #CRLF$ + #CRLF$
        st = st + "You can:"+#TAB$+"1) view it" + #CRLF$
        st = st + "        "+#TAB$+"2) copy to clipboard"+ #CRLF$
        st = st + "        "+#TAB$+"3) save to file"+ #CRLF$
        st = st + "        "+#TAB$+"0) exit doing nothing"+ #CRLF$
        MessageRequester("Math Evaluator", st)
        
        s1 = InputRequester("Math Evaluator", "1=View, 2=To Clipboard, 3=Save To File, 0=Exit", "0")
        
        If s1 <= "0" Or s1 > "3"
            MessageRequester("Math Evaluator", "Nothing done")
            ProcedureReturn 0
        EndIf
    Else
        s1 = "1"
    EndIf

    sOut = Space(sOutLen)
    If D0E1 = 0
        GetDebugLog(@sOut, sOutLen)
    Else
        GetErrorMsgs(@sOut, sOutLen)
    EndIf
    
    If s1 = "1"
                   
        ShowString(sOut, ConsoleF)

    ElseIf s1 = "2"
        ClearClipboard()
        SetClipboardText(sOut)
        
        MessageRequester("Math Evaluator", "Text copied to clipboard")

    ElseIf s1 = "3"
        sRes$ = sOut
        LoadSaveFile(#WriteFile8)
        sOut = "":
        
        MessageRequester("Math Evaluator", "Text saved to file")
        
    EndIf
                

EndProcedure

Procedure.l ShowFlags(ConsoleF.b = 0)                       ; makeup and show a string containing the status of the flags
                                                             ; (not updated)
Protected st.s

    st = Header(1, 0)

    st = st + "Flags and Variables:"
    st = st + #CRLF$ + "InpFN = " + InpFN
    st = st + #CRLF$ + "lnsF = " + Str(lnsF)
    st = st + #CRLF$ + "LnsStr = " + LnsStr
    st = st + #CRLF$ + "getFromClpF = " + Str(getFromClpF)
    st = st + #CRLF$ + "getFromSelTextF = " + Str(getFromSelTextF)
    st = st + #CRLF$
    st = st + #CRLF$ + "OutpFN = " + OutpFN
    st = st + #CRLF$ + "AppendF = " + Str(AppendF)
    st = st + #CRLF$ + "NoHF = " + Str(noHF)
    st = st + #CRLF$ + "noLnExpF= " + Str(noLnExpF)
    st = st + #CRLF$ + "SaveToClpBF = " + Str(SaveToClpBF)
    st = st + #CRLF$ + "decimals= " + Str(decimals)
    st = st + #CRLF$
    st = st + #CRLF$ + "CurDir = " + CurDir
    st = st + #CRLF$
    
    st = st + #CRLF$ + "splF = " + Str(splF)
    st = st + #CRLF$ + "splPath = " + splPath
    st = st + #CRLF$ + "logF = " + Str(logF)
    st = st + #CRLF$ + "logFileN= " + logFileN

    st = st + #CRLF$ + "rrF = " + Str(tsrvF)
    st = st + #CRLF$ + "rsetF = " + Str(rsetF)
    st = st + #CRLF$ + "quitF = " + Str(quitF)
    st = st + #CRLF$ + "delF = " + Str(delF)
    st = st + #CRLF$
    st = st + #CRLF$ + "Press any keys..."

    ShowString(st, ConsoleF)

EndProcedure

;-*********************************************************************************************************************

ProcedureDLL anmEvalMain(eCmdLine.s)                        ; Main routine to parse and execute command lines
                                                              ; this routine has been inherited by another program
                                                              ; linked to anumet.dll, consequently it is not optimized
                                                              ; and has some redundant code    
    Protected i.l, T1.l, WndNM.s, lHandle.l, execs.l
    Protected EventObj, EventWnd, EventGadget, EventType, EventMenu, ln, wParam, lParam, cx
    Protected st.s, k.l, tsrOnce.b
    
    RegType = 2
    RegType1 = RegType
    anmResStr = ""
    
    anmDbg("Proc: "+LSet(#PB_Compiler_Procedure+"()", #LSt)+": CmdLine = '"+eCmdLine+"'", #pbDebug)

    ;Debug GetCmdLine()
    Dim CmdLines.s(20)
    
    CmdLine = eCmdLine
    ;MessageRequester("anmEvalMain", eCmdLine)
    TSRLoop:
        
    ParseCmdLine()

;// MAIN ROUTINE

;// general code: Eval
    Protected wndF.l, car.s{1}, cHnd.l, strPtr.l, gdgText.s, cnt2.l   
        
        If ShowFlagsF ;don't terminate
            ShowFlags(1)
            ShowFlagsF = 0
        EndIf

        If ShowAboutF ;don't terminate
            ShowAbout(0)
            ShowAboutF = 0
        EndIf
        
    
;// Execute command line
    If CurDir = "";for when comes from wSetup
        ;CurDir = DllDir
        CurDir = GetPathPart(ProgramFilename())+"anmXNpp\"
    EndIf
    ;sLog("CurDir        :'"+ CurDir+"'", logF)

    If logF
        If logFileN = ""
            logFileN = CurDir + "anmCmds.log"
        Else
            ;logFileN = MergePaths(logFileN, CurDir)
            logFileN = PathFileMerge(CurDir, logFileN, 2)
        EndIf

    EndIf
    
    ; InpFN = MergePaths(InpFN, CurDir)
    InpFN = PathFileMerge(InpFN, CurDir, 1)
    ; OutpFN = MergePaths(OutpFN, CurDir)
    OutpFN = PathFileMerge(OutpFN, CurDir, 1)
    
    ;MessageRequester("", InpFN)
    
    If splPath<>"" And splPath<>"0" And splPath<>"-1"
        If Right(splPath, 1)<>"\" : car = "\" : Else : car = "" : EndIf
         splPath = GetPathPart(splPath)
    Else
        splPath = "0" ; filename with counter
    EndIf
    
    SetCurrentDirectory(GetPathPart(InpFN))
    st = PeekS(GetCommandLine_())
    st = Left(st, FindString(st, ".exe", 1) + 4)
    ;MessageRequester("", INIFileN)
    
    If FirstRunF Or (UseOutpFNF And (Not AppendF))
        sLog(Header(1, 0), logF, logFileN) 
        slog("BatchRun      : Time " + FormatDate("%dd/%mm/%yyyy - %hh:%ii:%ss", Date()) + #CRLF$, logF)
        sLog("INI File      : " + Chr(34) + INIFileN + Chr(34), logF)
        sLog("Log File      : " + Chr(34) + logFileN + Chr(34), logF)
    EndIf;init log file
    sLog("Command Line  : " + Chr(34) + CmdLine + Chr(34), logF)
    sLog("Input File    : " + Chr(34) + IIFs(UseInpFNF, InpFN, "") + Chr(34), logF)
    sLog("Output File   : " + Chr(34) + iifs(UseOutpFNF, OutpFN, "") + Chr(34), logF)
    sLog("Save Plot Path: " + Chr(34) + splPath + Chr(34), logF)
    sLog("Current Folder: " + Chr(34) + GetPathPart(InpFN) + Chr(34), logF)
    FirstRunF = 0
        
    If ShowFlagsF Or ShowMemF Or ShowLogF Or ShowCmdsF Or ShowAboutF
    
        If ShowMemF
             ShowMem(0)
             ShowMemF = 0
             
        ElseIf ShowLogF
             ShowLog(0)
             ShowLogF = 0
             
        ElseIf ShowFlagsF ;don't terminate
            ShowFlags(0)
            ShowFlagsF = 0
            
        ElseIf ShowAboutF ;don't terminate
            ShowAbout(0)
            ShowAboutF = 0
            
        ElseIf ShowCmdsF ;don't terminate
            ShowCmds(0)
            ShowCmdsF = 0

        EndIf
    
        ProcedureReturn ExitCode
        ;MessageRequester("Flag", "")
        
    ElseIf UseInpFNF Or getFromClpF Or getFromSelTextF ;execute command line
        ;MessageRequester("cmd", "")
        
        If (getFromClpF = 0 And getFromSelTextF = 0) Or UseInpFNF
            ;MessageRequester("cmd", "")
            LoadSaveFile(#loadCmdLn6) ;load file from command line
            
            anmDbg("Proc: "+LSet(#PB_Compiler_Procedure+"()", #LSt)+": LoadFromFile  : " + Chr(34) + InpFN + Chr(34), #pbDebug)
            sLog("LoadFromFile  : " + Chr(34) + InpFN + Chr(34), logF)

        ElseIf getFromClpF
            clpText = ""
            clpText = GetClipboardText()
            clpTextp = clpText
            sRes$ = Trim(clpText)
            MessageRequester("Clipbrd","???")
            sLog("GetClipbTEXT  : " + Chr(34) + sRes$ + Chr(34), logF)

        ElseIf getFromSelTextF
            sRes$ = Trim(SelText)
            SelText = ""
            clpText = ""
            anmDbg("Proc: "+LSet(#PB_Compiler_Procedure+"()", #LSt)+": Expression    : " + Chr(34) + sRes$ + Chr(34), #pbDebug)
            sLog("Expression    : " + Chr(34) + sRes$ + Chr(34), logF)
        
        EndIf
        
        If Right(sRes$, 1) = "/" : sRes$ = Trim(Left(sRes$, Len(sRes$)-1)) : EndIf
        If Left(sRes$, 1) = "'" : sRes$ = TrimChar(sRes$, "'") : EndIf
        
        Plots = 0
        HeadStr = Header(1, noHF)
        
ClipBLoop:

        If delF
            DeleteFile(OutpFN)
            If splF And splPath<>"0"
                ShellExecute_(0, 0, "command", "/c del.exe " + Chr(34) + splPath + "*.jpg" + Chr(34), "", 0)
                DeleteFile(splPath + "*.jpg")
                sLog("Deleted *.jpg : ", logF)
                
            EndIf
        EndIf
        
        T1 = ElapsedMilliseconds()
        
; ***************************************************************************        

        ret = EvalParser(InpFN, OutpFN, splPath, decimals, @strPtr, HeadStr, nohF, logF, noTextF, lnsF, LnCorr, LnsStr, pBarF, noLnExpF, splF)
        
; ***************************************************************************
        Dt = ElapsedMilliseconds() - T1
        
        anmDbg("Proc: "+LSet(#PB_Compiler_Procedure+"()", #LSt)+": Eval Codes    : Ret = " + Str(ret) + ", ExitCode = " + Str(ExitCode), #pbDebug)
        anmResStr = Space(ret*2+2)
        anmResStr = PeekS(strPtr, -1, #PB_Unicode)
        
        
        ;MessageRequester("anmanmResStr", anmanmResStr)
        sLog("Eval Codes    : Ret = " + Str(ret) + ", ExitCode = " + Str(ExitCode), logF)
        anmDbg("Proc: "+LSet(#PB_Compiler_Procedure+"()", #LSt)+": Len(anmResStr)   : " + Str(Len(anmResStr)), #pbDebug)
        
        If (UseInpFNF)
            st = "'--- End Of BatchRun : Time " + FormatDate ("%dd/%mm/%yyyy - %hh:%ii:%ss", Date())
            st = st + " - (Execution Time: " + Str(Dt) + " ms)"
            st = LSet(st, 84, "-")
            sRes$ = sRes$ + st
            LoadSaveFile(#writeCmdLn7) ;save file from command line
            ;MessageRequester("cmd", Str(UseInpFNF))
            sLog("SaveToFile    : " + Chr(34) + OutpFN + Chr(34), logF)

        ElseIf SaveToClpBF
            ;ClearClipboard()
            SetClipboardText(sRes$)
            outClpb = sRes$
            sLog("Result        : " + Chr(34) + sRes$ + Chr(34), logF)

        EndIf
        
        execs = execs + 1;             
        sLog(RSet(Str(execs), 13) + " : Command Line Executed.", logF)

    Else
    
        st = "Error : Invalid Input file." + #CRLF$ + "filename: " + InpFN + "." + #CRLF$
        If tsrvF = 0
            st = st + " Program will terminate."
            ExitCode = #InvalidParameter
        Else
            st = st + " Program will remain resident waiting for further inputs."
        EndIf
        sLog(st, logF)
           
    EndIf
    
    anmDbg("Proc: "+LSet(#PB_Compiler_Procedure+"()", #LSt)+": Evaluation End: Exit code: " + Str(ExitCode), #pbDebug)

    sLog("Evaluation End: Exit code: " + Str(ExitCode), logF)
    sLog("-----------------------------------------------------", logF)
    
    ;MessageRequester("anmEvalMain - anmResStr", anmResStr)
    
    ProcedureReturn ExitCode
    
EndProcedure

Procedure.l anmDbg(txt.s, LogF.l) ;
; //LogFName is deleted at the DLL loading
Protected CreateF.b,	F.l;

	If (LogF = 1) ;then
	    ;MessageRequester("LogFName", LogFName)
	    
		If OpenFile(F, DbgFName);;//If no external file of the given name exists, an error occurs. 
		    ;MessageRequester("LogFName", LogFName)
            FileSeek(F, Lof(0))         
    	    WriteStringN(F, txt);
    		FlushFileBuffers(F);
    	    Delay(10)
    	    CloseFile(F)	; Close file, save changes }
		EndIf
		
	Else
		If LogF = 2 ;then
			MessageRequester("", txt);
        EndIf
    EndIf
    	
EndProcedure

Procedure.s RemoveComment(text.s);:string;
Protected pos1, CRLFpos, ln.l;

	
	Repeat
		pos1 = FindString(text, Chr(39), 1);look for '
		CRLFpos = FindString(Mid(text, pos1, Len(text)), #CRLF$, 1);

		If (CRLFpos > 0) ;then 
			;//showmessage("pos1 = "+Str(pos1)+", CRLFpos = "+Str(CRLFpos)); 
			;MessageRequester("", "CRLFpos="+Str(CRLFpos))
			ln = CRLFpos -1
		;//end
		Else 
			ln = Len(text);
			
		EndIf

		If pos1 > 0 ;then 
			text = RemoveString(text, Mid(text, pos1, ln));;//sExpr = Copy(sExpr, pos1, 10000);;//

        EndIf
	Until pos1 = 0;
	
	ProcedureReturn text; 
	
EndProcedure

Procedure SetKWList(Array KWs.s(1), Array KWAct.b(1), Array TTMsg.s(1));: KWList);
#Act_NONE         = 0
#Act_Evaluate_OR_Canc = 1
#Act_Load_OR_Canc = 2
#Act_Execute_OR_Canc = 3
Protected i.l
    
    i = -1
    
	KWs(IncL(@i)) ="aElemOrderEx": KWAct(i) = #Act_NONE                :TTMsg(i) = ""
	KWs(IncL(@i)) ="Debug":        KWAct(i) = #Act_Load_OR_Canc        :TTMsg(i) = "Value Set"
	KWs(IncL(@i)) ="ErrorMsgs":    KWAct(i) = #Act_Load_OR_Canc        :TTMsg(i) = "Value Set"
	KWs(IncL(@i)) ="Derivate":     KWAct(i) = #Act_Evaluate_OR_Canc    :TTMsg(i) = ""
	KWs(IncL(@i)) ="DerivateF":    KWAct(i) = #Act_Evaluate_OR_Canc    :TTMsg(i) = ""
	KWs(IncL(@i)) ="DimX":         KWAct(i) = #Act_Load_OR_Canc        :TTMsg(i) = "Expression Loaded in Memory"
	KWs(IncL(@i)) ="Expr":         KWAct(i) = #Act_Evaluate_OR_Canc    :TTMsg(i) = ""
	gAct_Expr = i ; stored for future use
	KWs(IncL(@i)) ="ExprF":        KWAct(i) = #Act_Evaluate_OR_Canc    :TTMsg(i) = ""
	KWs(IncL(@i)) ="Funct":        KWAct(i) = #Act_Load_OR_Canc        :TTMsg(i) = "Expression Loaded in Memory"
	KWs(IncL(@i)) ="FunctF":       KWAct(i) = #Act_Load_OR_Canc        :TTMsg(i) = "Expression Loaded in Memory"
	KWs(IncL(@i)) ="Hex":          KWAct(i) = #Act_Evaluate_OR_Canc    :TTMsg(i) = ""
	KWs(IncL(@i)) ="Bin":          KWAct(i) = #Act_Evaluate_OR_Canc    :TTMsg(i) = ""
	KWs(IncL(@i)) ="Integrate":    KWAct(i) = #Act_Evaluate_OR_Canc    :TTMsg(i) = ""
	KWs(IncL(@i)) ="IntegrateF":   KWAct(i) = #Act_Evaluate_OR_Canc    :TTMsg(i) = ""
	KWs(IncL(@i)) ="Matr":         KWAct(i) = #Act_Load_OR_Canc        :TTMsg(i) = "Expression Loaded in Memory"
	KWs(IncL(@i)) ="MatrF":        KWAct(i) = #Act_Load_OR_Canc        :TTMsg(i) = "Expression Loaded in Memory"
	KWs(IncL(@i)) ="Plot":         KWAct(i) = #Act_Execute_OR_Canc     :TTMsg(i) = "Command Executed"
	KWs(IncL(@i)) ="Pause":        KWAct(i) = #Act_NONE                :TTMsg(i) = ""
	KWs(IncL(@i)) ="StoExpr":      KWAct(i) = #Act_Evaluate_OR_Canc    :TTMsg(i) = ""
	KWs(IncL(@i)) ="Show":         KWAct(i) = #Act_Execute_OR_Canc     :TTMsg(i) = ""
	KWs(IncL(@i)) ="Var":          KWAct(i) = #Act_Load_OR_Canc        :TTMsg(i) = "Expression Loaded in Memory"
	KWs(IncL(@i)) ="VarPolyn":     KWAct(i) = #Act_Load_OR_Canc        :TTMsg(i) = "Expression Loaded in Memory"
	KWs(IncL(@i)) ="Vect":         KWAct(i) = #Act_Load_OR_Canc        :TTMsg(i) = "Expression Loaded in Memory"
	KWs(IncL(@i)) ="VectF":        KWAct(i) = #Act_Load_OR_Canc        :TTMsg(i) = "Expression Loaded in Memory"
	KWs(IncL(@i)) ="sDiff":        KWAct(i) = #Act_Evaluate_OR_Canc    :TTMsg(i) = ""
	KWs(IncL(@i)) ="sDiffF":       KWAct(i) = #Act_Evaluate_OR_Canc    :TTMsg(i) = ""
	
	MaxKWs = i
	
EndProcedure

Procedure.s CheckExpressionS(lExpr.s, Msg.s, *btnRet, AutoF.b)
Protected btnRet.l, ExprF.b, lcExpr.s
Protected mbVar.l, SwapYesNoF.b, i.l
Protected st.s
Protected Dim Msgs.s(3)
     
    anmDbg("Proc: "+LSet(#PB_Compiler_Procedure+"()", #LSt)+": Expr IN = '"+lExpr+"'", #pbDebug)

    Msgs(#Act_NONE) = "Press: Yes to Evaluate Expression" + #CRLF$;used by SelTextToWnd
    Msgs(#Act_Execute_OR_Canc) = "Press: Yes to Execute Command"+#CRLF$
    Msgs(#Act_Load_OR_Canc) = "Press: Yes to Load Expression in Memory"+#CRLF$
    Msgs(#Act_Evaluate_OR_Canc) = "Press: Yes to Evaluate Expression"+#CRLF$
    
    lExpr = TrimChar(lExpr, #CRLF$)
    lExpr = Trim(lExpr)
    lcExpr = LCase(lExpr)
	gStrActIdx = 0
	
	If lExpr <> "" 
	    i = -1: ExprF = 0
	    Repeat
	        ExprF = FindString(lcExpr, LCase(srchStr(incL(@i))), 1)
	    Until ExprF > 0 Or i = MaxKWs
		
		gStrActIdx = i
		
		;MessageRequester("i=", Str(i))
	    		
	    st = Msgs(strAct(gstrActIdx))
		st = st + "           No to abort operation";		

		st = Msg+#CRLF$+#CRLF$+ lExpr + #CRLF$ +#CRLF$+st;
		
		;MessageRequester("AutoF=", Str(AutoF))
		If (AutoF = 0) And (DontConfExpF = 0)
		    btnRet = MessageRequester("Math Evaluator", st, #PB_MessageRequester_YesNo);
		Else
		    btnRet = #PB_MessageRequester_Yes
		EndIf
		
		If (btnRet = #PB_MessageRequester_Yes);;{mbYes} ;then
		    ;MessageRequester("strAct(gStrActIdx)=", Str(strAct(gStrActIdx)))
		    If (ExprF = 0);
        		;MessageRequester("ExprF=", Str(exprF))
		        lExpr = "Expr = " + lExpr;
		        gStrActIdx = gAct_Expr
		    EndIf
		    ;//MessageRequester("ExprF, Yes lExpr = ", lExpr)
		EndIf
		
	Else
		
		MessageRequester("Math Evaluator", "No Expression found!");	
		btnRet = #PB_MessageRequester_Cancel;
	EndIf	

    anmDbg("Proc: "+LSet(#PB_Compiler_Procedure+"()", #LSt)+": lExpr OUT = '"+lExpr+"'", #pbDebug)
    anmDbg("Proc: "+LSet(#PB_Compiler_Procedure+"()", #LSt)+": btnRet = "+Str(btnRet), #pbDebug)

    PokeL(*btnRet, btnRet)
    
	ProcedureReturn lExpr ;
EndProcedure

Procedure ReloadOutpFile(*NppHnd, InpFN.s);
Protected OutpFN.s;
#NPPM_RELOADFILE = 1024+1000+36;

;//[in] BOOL withAlert	[in] char *filePathName2Reload
;//This Message reloads the file indicated in filePathName2Reload. If withAlert is TRUE, ;then an alert message box will be launched
	;//ShowMessage(OutFN);
	OutpFN = GetPathPart(InpFN)+"\Result.anm";
	SendMessage_(*NppHnd, #NPPM_RELOADFILE, 1, OutpFN);

EndProcedure 

Prototype SendMessage_Ascii(hWnd.l, Msg.l, lParam.l, wParam.p-ascii) 

Procedure SearchInTarget(SCIView.l, tStart.l, tEND.l, sFlag.l, text.s, lib.l);): integer;
Protected ln, ret.l, lb.l

	ret = SendMessage_(SCIView, #SCI_SETTARGETSTART, tSTART, 0);
	ret = SendMessage_(SCIView, #SCI_SETTARGETEND, tEND, 0);
	ret = SendMessage_(SCIView, #SCI_SETSEARCHFLAGS, sFlag, 0);

    Protected SendMessage_Ascii.SendMessage_Ascii = GetFunction(lib, "SendMessageA")  
	ln = Len(text)
	ret = SendMessage_Ascii(SCIView, #SCI_SEARCHINTARGET, ln, text);
	;//If commentCharPos > 0 then showmessage("commentChar found"); TargetEND = commentCharPos-1; ;//

    ProcedureReturn ret
EndProcedure;




; IDE Options = PureBasic 4.31 (Windows - x86)
; ExecutableFormat = Shared Dll
; CursorPosition = 243
; FirstLine = 231
; Folding = -----
; EnableUnicode
; UseIcon = order.ico
; Executable = ..\anmEval.dll
; CompileSourceDirectory
; EnableCompileCount = 146
; EnableBuildCount = 18
; IncludeVersionInfo
; VersionField0 = 0.0.2.0
; VersionField1 = 0.0.2.0
; VersionField2 = Carlo Somigliana
; VersionField3 = anmEval
; VersionField4 = 0
; VersionField5 = 0
; VersionField6 = aNuMet Script Parser & Evaluator (.anm)
; VersionField7 = anmEval
; VersionField8 = anmEval
; VersionField13 = somic@libero.it
; VersionField14 = www.semelinanno.com