﻿;$LPP

EnableExplicit
DisableASM
#vbNormal       = 0 ;Normale (impostazione predefinita per Dir e SetAttr)
#vbReadOnly     = 1; Sola lettura
#vbHidden       = 2 ;Nascosto
#vbSystem       = 4 ;File di sistema
#vbVolume       = 8 ;Etichetta di volume
#vbDirectory    = 16 ;Directory o cartella
#vbArchive      = 32 ;Il file è stato modificato dall'ultimo backup

#FILE_ATTRIBUTE_GET = -1
#FILENAME_IS_VALID  = 64
#FILENAME_EXIST     = 128

#TEST_IF_VALID      = -1

Global lInIde.l, ResultString$, sRes$, gwLog.l, geLog.l, gWinLogTitle.s="anmXNpp Plugin for Notepad++"
Global CR.s{2} = Chr(13) + Chr(10)

Prototype.l pPrintWindow(hWnd.l, hDc.l, lFlags.l)
Global hLib.l = OpenLibrary(#PB_Any, "user32.dll")
Global PrintWindow_.pPrintWindow = GetFunction(hLib, "PrintWindow")
Global DllDir.s = GetPathPart(ProgramFilename())


Declare.l DoEvents(hWnd.l = 0, CallingProc.s="", CallingLine=0)

Procedure.l DebugF(st.s, AppendF.b=1, SkipF.b=0)
Protected fn.s ="c:\debugf.dbg", f.l, ret

    If SkipF ;Or 1
        ProcedureReturn
    EndIf

RetryDebugF:
    
    If AppendF
        f = OpenFile(#PB_Any, fn)
        FileSeek(f, FileSize(fn))

        Else
        f = CreateFile(#PB_Any, fn)
        EndIf
    
    
    If f And ((ret = 0 Or ret = 1) Or (ret = #PB_MessageRequester_Yes))
        WriteStringN(f, st)
        FlushFileBuffers(F)
        CloseFile(f)
    Else
        If ret = 0:
            Delay(10) 
            ; DoEvents()
            ret + 1
            Goto RetryDebugF: 
        EndIf
        
        ret = MessageRequester("DebugF() Error", "Unable to open file: '"+fn+"' for message:"+#CRLF$+#CRLF$+st+#CRLF$+#CRLF$+"Retry?", #PB_MessageRequester_YesNo)
        If ret = #PB_MessageRequester_Yes
            Doevents()
            Goto RetryDebugF
        EndIf
    EndIf
    
    ;DebugSt(st, AppendF)
    ;MessageRequester("",st)
EndProcedure

Procedure.s WinAPIError(lGetLastError.l)
Protected sBuff.s
Protected lCount.l
    
   sBuff = LSet("", 256, ".")
   lCount = FormatMessage_(#FORMAT_MESSAGE_FROM_SYSTEM + #FORMAT_MESSAGE_IGNORE_INSERTS, 0, lGetLastError, 0, @sBuff, Len(sBuff), 0)
    If lCount
       ProcedureReturn "LastError("+Str(lGetLastError)+") "+Left(sBuff, lCount)
    EndIf

EndProcedure

Procedure ErrorHandler()
Protected ErrMsg.s
    
    ErrMsg =  "Msg :"+ErrorMessage() + #CRLF$
    ErrMsg = ErrMsg + "File: " +ErrorFile() + #CRLF$
    ErrMsg = ErrMsg + "Line: " +Str(ErrorLine()) + #CRLF$
    ErrMsg = ErrMsg + #CRLF$
    
    MessageRequester("OnError test", "The following error happened: " + #CRLF$+ ErrMsg)
    
    ProcedureReturn ErrorCode()
    
  EndProcedure

Procedure.l DoEvents(hWnd.l = 0, CallingProc.s="", CallingLine=0)
Protected msg.MSG, cnt.l, lret

; BOOL PeekMessage(          
;     LPMSG lpMsg,
;     HWND hWnd,
;     UINT wMsgFilterMin,
;     UINT wMsgFilterMax,
;     UINT wRemoveMsg
; );
; HWND
;[in] Handle to the window whose messages are to be retrieved. The window must belong to the current thread. 
;If hWnd is NULL, PeekMessage retrieves messages For any window that belongs To the current thread, And any 
;messages on the current thread's message queue whose hwnd value is NULL (see the MSG structure). 
;Therefore if hWnd is NULL, both window messages and thread messages are processed.

;If hWnd is -1, PeekMessage retrieves only messages on the current thread's message queue whose hwnd value is NULL, 
;that is, thread messages as posted by PostMessage (when the hWnd parameter is NULL) or PostThreadMessage.
    If CallingProc <> "" Or CallingLine <> 0
        debugf("DoEvents: "+CallingProc+"("+Str(callingline)+")")
    EndIf
    
    While PeekMessage_(@msg, hWnd, 0, 0, #PM_REMOVE)
        cnt = cnt + 1 
        lret = TranslateMessage_(@msg) 
        lret = DispatchMessage_(@msg) 
        lret = Delay(5) ; SleepEx_(5, #True)
        Wend
 
    ProcedureReturn cnt
               
EndProcedure


Procedure.s GetWinText(hWnd)
Protected Text.s, lret

    Text=Space(256) 
    lret = GetWindowText_(hWnd, Text, 256) 
    
    ProcedureReturn Left(Text, lret)

EndProcedure

Procedure.s GetClassName(hWnd)
Protected Text.s, lret

    Text=Space(256) 
    lret = GetClassName_(hWnd, Text, 256) 
    
    ProcedureReturn Left(Text, lret)

EndProcedure

Procedure.s GetWinData(hWnd)
Protected st.s

    st = GetWinText(hWnd)+"/"+GetClassName(hWnd)
    
    ProcedureReturn st
    
EndProcedure

Procedure WaitForWindow(Open1Close0.b, sClass.s = "", sTitle.s = "", msTimeOut.l = #INFINITE)
Protected T1.l, Dt.l, hWnd.l, CondF.b, Dt1.l, cnt.l, lret.l, dwPID.l

    T1 = ElapsedMilliseconds()
    Dt = 0: cnt.l
  
    Repeat
        
        cnt = cnt + 1
                    
        If sClass = "" And sTitle = ""
            hWnd = FindWindow_(0, 0)
            
            ElseIf sClass = "" And sTitle <> ""
            hWnd = FindWindow_(0, sTitle)
            
            ElseIf sClass <> "" And sTitle = ""
            hWnd = FindWindow_(sClass, 0)
            
            Else
            hWnd = FindWindow_(sClass, sTitle)
            
        EndIf
        
        lret = Doevents()   ; to process message queque
        Sleep_(5)           ; to leave CPU for other processes and limit CPU usage
        
        If Open1Close0      ; = 1
            If (hWnd > 0): CondF = 1: Else: CondF = 0: EndIf
        
        Else            ; = 0
            If (hWnd = 0): CondF = 1: Else: CondF = 0: EndIf
        
        EndIf

        Dt = (ElapsedMilliseconds() - T1) * msTimeOut
        Dt1 = (msTimeOut*msTimeOut)
                
    Until CondF Or (Dt > Dt1)
       
;     ; wait window to show (if any is found)
;     lret = Doevents()   ; to process message queque
;     Sleep_(5)           ; to leave CPU for other processes and limit CPU usage

    If CondF
        If hWnd
            ProcedureReturn hWnd
        Else
            ProcedureReturn cnt
        EndIf
    Else
        ProcedureReturn 0
    EndIf
    
EndProcedure

Procedure.l FlushKeyboardInputBuffer(hWnd_i.l)
Protected cnt.l, stMsg.MSG

   While PeekMessage_(@stMsg, hWnd_i , #WM_KEYFIRST, #WM_KEYLAST, #PM_REMOVE )
    cnt = cnt + 1
   Wend
   
   ProcedureReturn cnt

EndProcedure

Procedure.l FlushMouseInputBuffer(hWnd_i.l)
Protected cnt.l, stMsg.MSG ;

   While PeekMessage_(@stMsg, hWnd_i , #WM_MOUSEFIRST, #WM_MOUSELAST, #PM_REMOVE )
    cnt = cnt + 1
   Wend
   
   ProcedureReturn cnt

EndProcedure

Procedure pbDoEvents() 
  While WindowEvent() : Wend 
EndProcedure 

Procedure.s String(n.l, car.s);000000000000
Protected i.l, st.s
    
    If n <= 0
        ProcedureReturn ""
    EndIf
    
    st = LSet(st, n, car)
    
    ProcedureReturn st.s

EndProcedure

; Public Function GetLoWord(l As Long) As Integer
;     GetLoWord = (l / &H10000) And &HFFFF&
; End Function
; 
; Public Function GetHiWord(l As Long) As Integer
;     GetHiWord = l And &HFFFF&
; End Function
; 
; Public Function IntegersToLong(LoWord As Integer, _
;    HiWord As Integer) As Long
; 
; IntegersToLong = (HiWord * &H10000) + (LoWord And &HFFFF&)
; 
; End Function
Procedure.l MinL(l1.l, l2.l)

    If l1 < l2
        ProcedureReturn l1
    Else
        ProcedureReturn l2
    EndIf

EndProcedure
Procedure.l MaxL(l1.l, l2.l)

    If l1 > l2
        ProcedureReturn l1
    Else
        ProcedureReturn l2
    EndIf

EndProcedure

Procedure yBottom(ObjId)

    ProcedureReturn GadgetY(ObjId)+GadgetHeight(ObjId)
    
EndProcedure
Procedure yTop(ObjId)

    ProcedureReturn GadgetY(ObjId)
    
EndProcedure
Procedure xLeft(ObjId)

    ProcedureReturn GadgetX(ObjId)
    
EndProcedure
Procedure xRight(ObjId)

    ProcedureReturn GadgetX(ObjId)+GadgetWidth(ObjId)
    
EndProcedure

Procedure.l OpenWindow_Log(wFlags.l = -1, *lwLog = 0)
Static wLog.l, edtLog.l, lblInfo.l
    
    If wFlags = -1
        wFlags = #PB_Window_SystemMenu | #PB_Window_MinimizeGadget | #PB_Window_TitleBar | #PB_Window_SizeGadget
        
    EndIf
    
    ;wLog = OpenWindow(#PB_Any, 0, 195, 610, 350, "anmXNpp Plugin for Notepad++", wFlags)
    wLog = OpenWindow(#PB_Any, 0, 195, 610, 350, gWinLogTitle, wFlags)
    gwLog = wLog
    If *lwLog > 0
        PokeL(*lwLog, wLog)
    EndIf
    ;Debug WindowID(gwLog)
    
    If wLog
        
        ;If CreateGadgetList(WindowID(wLog))
            
            lblInfo = TextGadget(#PB_Any, 5, 10, 100, 15, "Messages Window")
            
            edtLog = EditorGadget(#PB_Any, 5, 25, 330, 320, #PB_Editor_ReadOnly)
            geLog = edtLog
            SetGadgetText(edtLog, "")
        ;EndIf
    EndIf
    
    Delay(10)
    ProcedureReturn edtLog
    
EndProcedure

Procedure.l SetProgressBar(Pos.f, MaxPos.f, Flag.b=0, txt.s="")
Static EdtWidth.l, carWidth.f, MaxCars.f, retBtn.l
Protected nCars.l, bStr.s, msg.MSG

;     If retBtn = 0
;         retBtn = #PB_MessageRequester_Yes
;     EndIf
    
    If Flag 
        If geLog
            nCars = Pos/MaxPos * MaxCars 
            bStr = string(nCars, "|")
            bStr = "        "+StrD(Int(Pos/MaxPos*1000)/10, 1)+" %"
            If txt <> ""
                bStr = txt
            EndIf
            SetGadgetText(geLog, bStr)
            
        Else
            geLog = OpenWindow_Log(#PB_Window_ScreenCentered)
            ResizeWindow(gwLog, #PB_Ignore , #PB_Ignore , 200, 50)
            EdtWidth = WindowWidth(gwLog)-5-5
            ResizeGadget(geLog, 5, 25, EdtWidth , WindowHeight(gwLog)-5-25)
            StartDrawing(WindowOutput(gwLog))
            carWidth = TextWidth("||||||||||")/11
            StopDrawing()
            MaxCars = EdtWidth / carWidth
        EndIf

        While PeekMessage_(msg.MSG, WindowID(gwLog), 0, 0, #PM_REMOVE) 
            TranslateMessage_(msg) 
            Delay(10)
            If retBtn = #PB_MessageRequester_Yes
                retBtn = MessageRequester("anmXNpp", "Continue?", #PB_MessageRequester_YesNo)
            EndIf
            
            DispatchMessage_(msg) 
        Wend
        DoEvents()
    Else
        If gwLog: CloseWindow(gwLog): EndIf
        gwLog = 0
        geLog = 0
    EndIf
        

    ;ProcedureReturn geLog
    
EndProcedure

Procedure.l sLog(st$, File1Wnd2.b, gfName.s = "", pos.l = 0, resetF.b = 0, *lwLog=0)
Static edtLog.l, lFName.s, fnr.l, cnt.l
    
    If resetF = 1
        If File1Wnd2 = 2
            gwLog = 0
            geLog = 0
            edtLog = 0
            cnt = 0
        ElseIf File1Wnd2 = 1
            fnr = 0
            lFName = ""
        EndIf

        ProcedureReturn 0;nothing done
    EndIf
                
    If File1Wnd2 = 2
        If edtLog = 0 Or IsGadget(edtLog) = 0
            edtLog = OpenWindow_Log(-1, *lwLog)
            cnt = 0
        EndIf
        cnt = cnt + 1
        AddGadgetItem(edtLog, pos, Str(cnt) + ": " + st$)
            
        ProcedureReturn edtLog

    ElseIf File1Wnd2 = 1
        
        If Right(st$, 2)<>#CRLF$
            st$ = st$ + #CRLF$
        EndIf

        If gfName<>"" And lFName = "" : 
            lFName = gfName : 
        EndIf
        If lFName = ""
            ProcedureReturn -1;error
        EndIf
        
        If fnr = 0
            fnr = CreateFile(#PB_Any, lFname)
        Else
            fnr = OpenFile(#PB_Any, lFname)
        EndIf
        FileSeek(fnr, Lof(fnr))
        WriteString(fnr, st$)
        CloseFile(fnr)

        ProcedureReturn 1

    EndIf
    
     ;Delay(5)
     ;Debug st$

EndProcedure


Procedure.l ShowString(st.s, ConsoleF.b = 0, waitF.b = 0)
Protected i.l, sln.s, hWnd.l, Event.l, EventWindow.l, gedtLog, lwLog

    If ConsoleF
        If OpenConsole()
            Print(st)
            Input()
            CloseConsole()
            
        EndIf
    Else
        ;wHnd = FindWindow_("WindowClass_0", #aStEvalTSR)
        
        hWnd = FindWindow_(#Null, gWinLogTitle)
        sLog("", 2, "", 0, 1)
        If hWnd
            SendMessage_(hWnd, #WM_CLOSE, 0, 0)
            SendMessage_(hWnd, #SC_CLOSE, 0, 0)
            SendMessage_(hWnd, #WM_QUIT, 0, 0)
        EndIf
        
        ;SetGadgetFont(#PB_Default, LoadFont(1, "Courier New", 8, 16))

        gedtLog = sLog(gWinLogTitle, 2, gWinLogTitle, -1, -1, @lwLog)

        SetGadgetFont(gedtLog, LoadFont(0, "Courier New", 8, 16))

        For i = 1 To CountString(st, #CR$)
            sln = StringField(st, i, #CR$)
            If Left(sln, 1) = #LF$ : sln = Mid(sln, 2) : EndIf
            sLog(sln, 2, "", -1)
        Next i
        SetGadgetFont(#PB_Default, #PB_Default)
        ;SetGadgetFont(gedtLog , #PB_Default)

        
        Repeat
            SetForegroundWindow_(WindowID(gwLog))
            Event = WaitWindowEvent()
            EventWindow = EventWindow()
            
            If Event = #PB_Event_SizeWindow
                If EventWindow = gwLog
                    ResizeGadget(geLog, 5, 25, WindowWidth(gwLog)-5-5, WindowHeight(gwLog)-5-25)
                EndIf
            EndIf
        Until Event = #PB_Event_CloseWindow
        sLog("", 2, "", 0, 1)
        CloseWindow(EventWindow)
    EndIf
    
EndProcedure

ProcedureDLL.s GetVolumeInfo(Tp.l);(NOINCL)
Define lpRootPathName.s, pVolumeNameBuffer.s, nVolumeNameSize.l, lpVolumeSerialNumber.l, lpMaximumComponentLength.l
Define lpFileSystemFlags.l, lpFileSystemNameBuffer.s, nFileSystemNameSize.l
Define Info.s, Result.l, s.s

    lpRootPathName.s = "C:\"
    pVolumeNameBuffer.s = Space(256)
    nVolumeNameSize.l = 256
    lpVolumeSerialNumber.l
    lpMaximumComponentLength.l
    lpFileSystemFlags.l
    lpFileSystemNameBuffer.s = Space(256)
    nFileSystemNameSize.l = 256

    Result = GetVolumeInformation_(lpRootPathName, pVolumeNameBuffer, 256, @lpVolumeSerialNumber, @lpMaximumComponentLength, @lpFileSystemFlags, lpFileSystemNameBuffer, 256)
    
    If result<>0
        Select Tp
        Case 0 : s = Trim(pVolumeNameBuffer)
        Case 1 : s = Str(lpVolumeSerialNumber)
        Case 2 : s = Hex(lpVolumeSerialNumber);max 8 char
        Case 3 : s = Trim(lpFileSystemNameBuffer)
        Default
            s = s + "Volume SN Hex=" + Hex(lpVolumeSerialNumber) + Chr(13)
            s = s + "VolumeName:" + Trim(pVolumeNameBuffer) + Chr(13)
            s = s + "VolumeSN:" + Str(lpVolumeSerialNumber) + Chr(13)
            s = s + "Filesystem:" + Trim(lpFileSystemNameBuffer)
            
        EndSelect
        
    EndIf
    ProcedureReturn s
EndProcedure

ProcedureDLL.l DisplayVerInfo(FileN.s, *FileVer, *ProdVer);(NOINCL)

    Dim sBuffer.b(0)
    Define rc.l, lDummy.l, i.l
    Define lBufferLen.l, lVerPointer.l
    Define udtVerBuffer.VS_FIXEDFILEINFO
    Define lVerbufferLen.l, FileVer.s, ProdVer.s
    
    If FileN = ""
        FileN = ProgramFilename()
    EndIf
    ;*** Get size ****
    lBufferLen = GetFileVersionInfoSize_(FileN, lDummy)
    If lBufferLen<1
        ;"No Version Info available!"
        ProcedureReturn lBufferLen
        
    EndIf
    
    ;'**** Store info to udtVerBuffer struct ****
    ReDim sBuffer.b(lBufferLen)
;    rc = GetFileVersionInfo_(DLLFileN, 0, lBufferLen, sBuffer(0))
    rc = GetFileVersionInfo_(FileN, 0, @lBufferLen, @sBuffer())
    If rc = 0 : MessageRequester("", Str(GetLastError_())) : EndIf
    rc = VerQueryValue_(@sBuffer(), "\", @lVerPointer, lVerbufferLen)
    MoveMemory(lVerPointer, udtVerBuffer, SizeOf(udtVerBuffer))
    
    ;'**** Determine File Version number ****
    With udtVerBuffer
    
        ; build file version string "x.x.x.x"
        ;FileVersion = Str((VerBuffer\dwFileVersionMS & $FFFF0000) >> 16) + "." + Str(VerBuffer\dwFileVersionMS & $0000FFFF) + "." + Str((VerBuffer\dwFileVersionLS & $FFFF0000) >> 16) + "." + Str(VerBuffer\dwFileVersionLS & $0000FFFF)
    
        FileVer = Str((\dwFileVersionMS & $FFFF0000)>>16) + "." + Str(\dwFileVersionMS & $0000FFFF) + "." + Str((\dwFileVersionLS & $FFFF0000)>>16) + "." + Str(\dwFileVersionLS & $0000FFFF)
    
    ;'**** Determine Product Version number ****
        ProdVer = Str((\dwProductVersionMS & $FFFF0000)>>16) + "." + Str(\dwProductVersionMS & $0000FFFF) + "." + Str((\dwProductVersionLS & $FFFF0000)>>16) + "." + Str(\dwProductVersionLS & $0000FFFF)
    EndWith

    PokeS(*FileVer, FileVer)
    PokeS(*ProdVer, ProdVer)
    
    ProcedureReturn 2
    
EndProcedure

ProcedureDLL.l CRC(text.s, *Outp);(NOINCL);calculate a CRC of one caracter for Text; result string is pointed by §Outp
Define CRCnum.l, CRCrest.l, k.l, car.s, pos.l, num.l
Dim codfiscstr.s{52}(2)

    ;WriteDbgLog "CRC Init"
    ;If parola = "" Then CRC = "": WriteDbgLog "CRC End": Exit Function
    
    codfiscstr(1) = "B1A0K P L C2Q D3R E4V O S F5T G6U H7M I8N J9W Z Y X "
    codfiscstr(2) = "A0B1C2D3E4F5G6H7I8J9K L M N O P Q R S T U V W X Y Z "
    
    ;verifica CRC
    CRCnum = 0
    For k = 1 To Len(text)
        car = Mid(text, k, 1)
        If (k%2) = 0
            ;pari
            ;pos = InStr(1, codfiscstr(2), car, vbBinaryCompare)
            pos = FindString(codfiscstr(2), car, 1)
        Else
            ;dispari
            ;pos = InStr(1, codfiscstr(1), car, vbBinaryCompare)
            pos = FindString(codfiscstr(1), car, 1)
        EndIf
        num = Int((pos-1)/2)
        CRCnum = CRCnum + num
    Next k
    
    CRCrest = CRCnum%26
    PokeS(*Outp, Chr(CRCrest + 65))
    
    ProcedureReturn
    ;CRC = Chr(CRCrest + 65)
    
    ;WriteDbgLog "CRC End"
EndProcedure

ProcedureDLL.l RC4(inp.s, key.s); (NOINCL) crypt 'inp' string with 'key' key using RC4 algorithm; returns a pointer to the crypted string
;  crVSNh = EnHex(RC4(VSN, IIf(CRCOut <> "", CRCOut, cmnPssw)))
;esadecimalizza sempre RC4 (EnHex(RC4)) per rendere leggibile il risultato

Dim s.b(255) : Dim k.b(255)
Define j.l, temp.b, y.b, t.l, x.l, i.l
Define Outp.s

    If inp = "" Or key = ""
        ;PokeS(*Outp, Inp)
        ;RC4 = inp:
        ProcedureReturn @Inp
    EndIf
    
    For i = 0 To 255
        s(i) = i
    Next
    
    j = 1
    For i = 0 To 255
        If j>Len(key) : j = 1 : EndIf
        k(i) = Asc(Mid(key, j, 1))
        j = j + 1
    Next i
    
    j = 0
    For i = 0 To 255
        j = (j + s(i) + k(i))%256
        temp = s(i)
        s(i) = s(j)
        s(j) = temp
    Next i
    
    i = 0
    j = 0
    For x = 1 To Len(inp)
        i = (i + 1)%256
        j = (j + s(i))%256
        temp = s(i)
        s(i) = s(j)
        s(j) = temp
        t = (s(i) + (s(j)%256))%256
        y = s(t)
        
        Outp = Outp + Chr(Asc(Mid(inp, x, 1)) ! y)
    Next
    ;RC4 = Outp
    ;PokeS(*Outp, Outp)
    
    ProcedureReturn @Outp
  
EndProcedure

Procedure.s Trim0s(st.s);(NOINCL)
Define i.l, numfound.b, Trim0s.s, car.s

    numfound = 0 : Trim0s = ""
    For i = 1 To Len(st);da sinistra a destra
        car = Mid(st, i, 1)
        If FindString("0123456789.+-", car, 1)<>0
;         If FindString("0-+", car, 1)=0
            numfound = -1
            Trim0s = Trim0s + Mid(st, i)
            Break
        EndIf
    Next i

    st = Trim0s
    numfound = 0 : Trim0s = ""
    For i = Len(st) To 1 Step -1; da destra a sinistra
        car = Mid(st, i, 1)
        If car<>"0"
            numfound = -1
            Trim0s = Trim0s + Left(st, i)
            Break
        EndIf
    Next i

    If Right(Trim0s, 1) = "." : Trim0s = Left(trim0s, Len(trim0s)-1) : EndIf
    If Left(Trim0s, 1) = "." : Trim0s = "0" + trim0s : EndIf
    If Trim0s = "" : Trim0s = "0" : EndIf
    
    ResultString$ = Trim0s
    ProcedureReturn ResultString$

EndProcedure

Procedure.l CreateWndSnapshot(hWnd.l, Image.l = #PB_Any) ;(NOINCL)
   Protected hdc.l = GetWindowDC_(hWnd)
   Protected RC.RECT
   Protected res.l
   Protected Img.l
   Protected DC.l
    
    If Not hdc
        ProcedureReturn #Null
    EndIf
        
    If GetWindowRect_(hWnd, RC)
DisableDebugger                 ;to avoid stop for the hight Image number
         Res = CreateImage(Image, RC\right-RC\left, RC\bottom-RC\top, #PB_Image_DisplayFormat)
EnableDebugger
         If Image = #PB_Any
            Img = Res
         Else
            Img = Image
         EndIf
         
         If Res
            DC = StartDrawing(ImageOutput(Img))
            PrintWindow_(hwnd, DC, 0)
            StopDrawing()
         EndIf
    EndIf
    
    If hdc
        ReleaseDC_(hWnd, hdc)
    EndIf
    
    If Image = #PB_Any
        ProcedureReturn Img
    Else
        ProcedureReturn Res
    EndIf

EndProcedure


Procedure.l GetWndSnapShot(WndToGet.l, SaveToFileN.s = "", *SavedFileN=0);(NOINCL)
    Protected NewWnd.l, newImg.l, newImg2.l, lret.l, dd1.s
    Static Savecnt.l

    NewWnd = OpenWindow(#PB_Any, 0, 0, 1024, 30, "Window in a box", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
    
    If NewWnd ;And CreateGadgetList(WindowID(NewWnd))
    
        newImg = ImageGadget(#PB_Any, 0, 0, 1024, 30, 0)
        If CreateWndSnapshot(FindWindow_(#Null, GetWindowTitle(WndToGet)), newImg)
        
            ;SetGadgetState(newImg, ImageID(newImg))        ; may be useless

            ClearClipboard()
            SetClipboardImage(newImg)
        
        EndIf
        FreeImage(newImg)
        CloseWindow(NewWnd)
        
    EndIf
    
    If SaveToFileN<>""
        newImg2 = GetClipboardImage(#PB_Any)
        
        If newImg2
            Protected SaveToPath.s
            
            SaveToPath = DllDir+"anmXNpp\"
            If PathIsDirectory_(SaveToPath) = 0
                SaveToPath = DllDir
            EndIf
            
            If SaveToFileN = "-1"        ;window handle
                SaveToFileN = SaveToPath+"aPlotNr_" + Str(newImg2) + ".jpg"
            
            ElseIf SaveToFileN = "0"    ;counter
                Savecnt = Savecnt + 1
                dd1 = Str(Savecnt)
                If Len(dd1) = 1 : dd1 = "0" + dd1 : EndIf
                SaveToFileN = SaveToPath+"aPlotNr_" + dd1 + ".jpg"
                                
            Else;is a fully defined filename
                ;SaveToFileN
            EndIf
            
            UseJPEGImageEncoder()
            lret = SaveImage(newImg2, SaveToFileN, #PB_ImagePlugin_JPEG)
            Delay(5)
            FreeImage(newImg2)
            If Not lret 
                 
                 ProcedureReturn 0
            EndIf
        EndIf
    EndIf

    If *SavedFileN
        PokeS(*SavedFileN, SaveToFileN)
    EndIf
    ProcedureReturn 1;#OK

EndProcedure


CompilerIf Defined(TrimChar, #PB_Procedure)=0
Procedure.s TrimChar(st.s, car.s, CaseSensitive.b=0)
Protected lStr.s, lCar.s, ln.l, lnStr.l

    If CaseSensitive
        lStr = LCase(st)
        lcar = LCase(car)
    Else
        lStr = st
        lcar = car
        
    EndIf
    
    ;MessageRequester("TrimChar IN", lstr)

    ln = Len(lcar)
    While Left(lStr, Ln) = lcar
        lStr = Mid(lStr, ln+1)
    Wend

    ;MessageRequester("TrimChar MID", lstr)

    While Right(lStr, Ln) = lcar
        lnStr = Len(lStr)
        lStr = Left(lStr, lnStr-ln);abcd## Left("abcd##",6-2) 
    Wend

    ;MessageRequester("TrimChar OUT", lstr)

    sRes$ = lStr
    ProcedureReturn sRes$
    
EndProcedure

CompilerEndIf

Procedure.s GetStrBetWeen(text.s, st.s)
Protected pos1.l, pos2.l

    pos1 = FindString(text, st, 1);
    pos2 = FindString(text, st, pos1 + 1)
    
    sRes$ = Mid(text, pos1 + 1, pos2-pos1-1)
    
    ProcedureReturn sRes$
EndProcedure

Procedure.s TrimQPar(st.s);trim square parentesys
    
    If Left(st, 1) = "[" : st = Mid(st, 2) : EndIf
    If Right(st, 1) = "]" : st = Left(st, Len(st)-1) : EndIf

    sRes$ = st
    ProcedureReturn sRes$
    
EndProcedure

Procedure.l IsNumeric(arg.s)
Protected i.l, lret.l, car.s{1}

    lret = 1;numeric
    
    If Left(arg, 1) = "(" : arg = Mid(arg, 2) : EndIf
    If Right(arg, 1) = ")" : arg = Left(arg, Len(arg)-1) : EndIf
  
    For i = 1 To Len(arg)
        car = Mid(arg, i, 1)
        Select Asc(car)
        Case Asc("0") To Asc("9"), Asc(".")
            ;
        Default
            lret = 0;non numeric
            Break
        EndSelect
    
    Next i
    
    ProcedureReturn lret
    
EndProcedure

ProcedureDLL.s StrD0(st.s) ;(NOINCL)
Define i.l, numfound.b, Trim0s.s, car.s

    numfound = 0 : Trim0s = ""
    For i = 1 To Len(st);da sinistra a destra
        car = Mid(st, i, 1)
        If FindString("0123456789.+-", car, 1)<>0
; If FindString("0-+", car, 1)=0
            numfound = -1
            Trim0s = Trim0s + Mid(st, i)
            Break
        EndIf
    Next i

    st = Trim0s
    numfound = 0 : Trim0s = ""
    For i = Len(st) To 1 Step -1; da destra a sinistra
        car = Mid(st, i, 1)
        If car<>"0"
            numfound = -1
            Trim0s = Trim0s + Left(st, i)
            Break
        EndIf
    Next i

    If Right(Trim0s, 1) = "." : Trim0s = Left(trim0s, Len(trim0s)-1) : EndIf
    If Left(Trim0s, 1) = "." : Trim0s = "0" + trim0s : EndIf
    If Trim0s = "" : Trim0s = "0" : EndIf
    
    ResultString$ = Trim0s
    ProcedureReturn ResultString$

EndProcedure


Procedure.l WriteBytes(fn.s, *addr, bytes.l)

    If OpenFile(0, fn)
       WriteData(0, *addr, bytes)
       FlushFileBuffers(0)
       CloseFile(0)
    
    Else
        MessageRequester("Writebytes Error", "Unable to open " + fn)
    EndIf

EndProcedure



; Procedure.s MergePaths(fn.s, lCurDir.s, checkFileN.b = 0)
; Protected part1.s, part2.s, i1.l, i2.l, res.s, c.l, car.s{1}, car2.s{1}
; ;if fn = InOut\FileName must do lCurDir\InOut\FileName
;     
;     ;fn = "InOut\Full_SyntSamp.anm": lCurDir = "c:\temp\npp\ansi\anmeval\inout"
; 
;     fn = Trim(fn)
;     lCurDir = Trim(lCurDir)
;     
;     If fn = ""
;         res = lCurDir
;         ProcedureReturn
;     EndIf
; 
;     
;     If Mid(fn, 2, 2)= ":\" Or Mid(fn, 2, 2)= "\\" ;absolute HD or NET path
;         res = fn
;     Else
;         ;is fn = RelativePath (manage only overlapping names c:\temp\inout and inout\filename.anm)
;         ;not c:\temp\inout and ..\inout\filename.anm
;         Repeat
;             i1 = i1 + 1
;             part1 = StringField(fn, i1, "\")
;             i2 = 100
;             While part2 = ""
;                 i2 = i2 - 1
;                 part2 = StringField(lCurDir, i2, "\")
;             Wend    
; 
;             Repeat
;                 If part2<>"" And LCase(part2) = LCase(part1)
;                     lCurDir = RemoveString(lCurDir, part2, #PB_String_NoCase)
;                 EndIf
;                 i2 = i2 - 1
;                 part2 = StringField(lCurDir, i2, "\")
;             Until part2 = "" Or i2 = 0
;             
; ;             If part1<>""
; ;                 res = res + "\" + part1
;             ;ElseIf part2 = "" And part1
; ;            EndIf
;         Until part1 = ""
; 
;         If Right(lCurDir, 1)<>"\"
;             lCurDir = lCurDir + "\"
;         EndIf
;         If Left(fn, 1) = "\" 
;             fn = Mid(fn, 2)
;         EndIf
;         res = lCurDir + fn
;     EndIf
;         
;     
; ;    res = Mid(res, 2)
;     
;     If checkFileN
;         i1 = ReadFile(#PB_Any, res)
;         If i1<>0
;             CloseFile(i1)
;             ProcedureReturn res
;         Else
;             ProcedureReturn ""
;         
;         EndIf
;     Else
;         ProcedureReturn res
;     EndIf
;     
; EndProcedure
; 


; Dim l As Long
; l = GetWindowLong(Command1.hwnd, GWL_STYLE)
; prev = SetWindowLong(Command1.hwnd, GWL_STYLE, l And Not WS_DISABLED)
; Dim l As Long
; l = GetWindowLong(Command1.hwnd, GWL_STYLE)
; prev = SetWindowLong(Command1.hwnd, GWL_STYLE, l Or WS_DISABLED)



Procedure.s IIFs(condition, sTrue.s, sFalse.s)
    If condition<>0
        ProcedureReturn sTrue
    Else
        ProcedureReturn sFalse
    EndIf
EndProcedure

Procedure.l IIFn(condition.l, sTrue.l, sFalse.l)
    If condition<>0
        ProcedureReturn sTrue
    Else
        ProcedureReturn sFalse
    EndIf
EndProcedure

Procedure.s GetVolumeInformation(PathName.s, infoF.b)

    ;Create buffer:
    Protected Serial.l :
    Protected VName.s = Space(255), l.l = 255
    Protected FSName.s = Space(255), d.l = 255
    Protected *F, lret.l

    ;Get the volume information
    
    If OpenLibrary(0, "Kernel32.dll")
      *F = GetFunction(0, "GetVolumeInformationA")
      If *F
          ;VB GetVolumeInformation "C:\", VName, 255, Serial, 0, 0, FSName, 255
        lret.l = CallFunctionFast(*F, PathName, VName, @l, @Serial, 0, 0, FSName, @d)
      EndIf
      CloseLibrary(0)
    EndIf

    ;'Strip the extra chr$(0)'s
    VName = Trim(VName)
    FSName = Trim(FSName)

    If infoF = 0
      ProcedureReturn VName
    ElseIf infoF = 1
      ProcedureReturn Str(Serial)
    ElseIf infoF = 2
      ProcedureReturn FSName
    EndIf

EndProcedure

Procedure.l IsFileOrPath(FileOrPathName.s, Attributes.l, TestIfValidFName.b = 0)
Protected lret.l, pfAttr.l, f.l
    
    pfAttr = GetFileAttributes_(FileOrPathName)
    ; returns
    ; #FILE_ATTRIBUTE_ARCHIVE
    ; #FILE_ATTRIBUTE_DIRECTORY
    ; #FILE_ATTRIBUTE_READONLY
    ; #FILE_ATTRIBUTE_HIDDEN
    ; #FILE_ATTRIBUTE_SYSTEM
    
    If Attributes = -1
        ProcedureReturn pfAttr
    EndIf
    
    If pfAttr & Attributes;OR, & And
        lret = pfAttr
    Else
        lret = -1
    EndIf
    
    If TestIfValidFName And lret = -1 And Attributes = #vbNormal
        f = OpenFile(#PB_Any, FileOrPathName)
        If f
            CloseFile(f)
            lret = #FILENAME_EXIST
        Else
            f = CreateFile(#PB_Any, FileOrPathName)
            If f
                lret = #FILENAME_IS_VALID
                CloseFile(f)
                DeleteFile(FileOrPathName)
            Else
                lret = -1
            EndIf
        EndIf
        
    EndIf
    
    ProcedureReturn lret

EndProcedure

Procedure.l IncL(*lng)
Protected lng.l

    lng = PeekL(*lng)
    lng = lng + 1
    PokeL(*lng, lng)
    
    ProcedureReturn lng
    
EndProcedure

Procedure.l DecL(*lng)
Protected lng.l

    lng = PeekL(*lng)
    lng = lng - 1
    PokeL(*lng, lng)
    
    ProcedureReturn lng
    
EndProcedure

Global sComPrefix.s

Procedure.s PathFileMerge(FileN1.s, FileN2.s, Prevail12.l=1)
Protected sSave.s, ret.l, FileN3.s, *sAddr, nullStr.s
    sSave.s = Space(#MAX_PATH)
    ;PathCommonPrefix Lib "shlwapi.dll" Alias "PathCommonPrefixA" (pszFile1.s, pszFile2.s, achPath.s) As Long

    ret = PathCommonPrefix_(FileN1, FileN2, sSave)
        sComPrefix = Left(sSave, ret)
        
    
    If ret And sComPrefix <> ""
        If Prevail12 = 1
            FileN3 = RemoveString(FileN1, sComPrefix, #PB_String_NoCase) ; +Space(100)
        Else    
            FileN3 = RemoveString(FileN2, sComPrefix, #PB_String_NoCase) ; +Space(100)
        EndIf
        
       
        *sAddr = AllocateMemory(#MAX_PATH)
        PokeS(*sAddr, sComPrefix, #MAX_PATH)
        
        ret = PathAppend_(*sAddr, FileN3)
        
        sComPrefix = PeekS(*sAddr, #MAX_PATH)
        
        FreeMemory(*sAddr)
        
        If ret
            
            ProcedureReturn sComPrefix ; Left(FileN3, ret)
            
        EndIf
        
        
    EndIf

    ProcedureReturn ""

    
EndProcedure

;Debug LSet("1234", 10, #NULL$)+"'"

; Debug PathFileMerge("C:\test2", "c:\test1\test2\prova.txt", 1)
; Debug PathFileMerge("C:\test\prova.txt", "c:\test\test\prova.txt", 1)
; Debug PathFileMerge("c:\test\prova.txt", "c:\test\test\prova.txt", 2)
; IDE Options = PureBasic 4.31 (Windows - x86)
; ExecutableFormat = Shared Dll
; CursorPosition = 747
; FirstLine = 314
; Folding = AA-PYAg-
; EnableUnicode
; CurrentDirectory = C:\Program Files\PureBasic_420\Arch\
; EnableCompileCount = 0
; EnableBuildCount = 0